(PackageInfo named: 'Monticello') preamble: 'MCFileBasedRepository allSubInstances do: [ : each | each flushCache ]'!
SystemOrganization addCategory: #'Monticello-Base'!
SystemOrganization addCategory: #'Monticello-Chunk Format'!
SystemOrganization addCategory: #'Monticello-Loading'!
SystemOrganization addCategory: #'Monticello-Merging'!
SystemOrganization addCategory: #'Monticello-Modeling'!
SystemOrganization addCategory: #'Monticello-Patching'!
SystemOrganization addCategory: #'Monticello-Repositories'!
SystemOrganization addCategory: #'Monticello-Storing'!
SystemOrganization addCategory: #'Monticello-UI'!
SystemOrganization addCategory: #'Monticello-Versioning'!

!CrLfFileStream methodsFor: '*monticello' stamp: ''!
lineEndingConvention: t1 
	lineEndConvention := t1! !

!Stream methodsFor: '*monticello' stamp: ''!
isMessageStream
	^ false! !

Object subclass: #MCAncestry
	instanceVariableNames: 'ancestors stepChildren'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCAncestry class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCAncestry methodsFor: 'ancestry' stamp: 'ul 5/8/2011 19:45'!
allAncestors
	
	| allAncestors |
	allAncestors := Set new.
	self allAncestorsDo: [ :each | ] visitedAncestors: allAncestors.
	^allAncestors ! !

!MCAncestry methodsFor: 'ancestry' stamp: 'ul 5/8/2011 19:08'!
allAncestorsDo: aBlock
	
	self allAncestorsDo: aBlock visitedAncestors: Set new! !

!MCAncestry methodsFor: 'ancestry' stamp: 'ul 5/8/2011 19:06'!
allAncestorsDo: aBlock visitedAncestors: visitedAncestors

	self ancestors do: [ :each |
		(visitedAncestors includes: each) ifFalse: [
			visitedAncestors add: each.
			aBlock value: each.
			each allAncestorsDo: aBlock visitedAncestors: visitedAncestors ] ]! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
allAncestorsOnPathTo: t1 
	^ MCFilteredVersionSorter new target: t1;
		 addAllVersionInfos: self ancestors;
		 sortedVersionInfos! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
ancestorString
	^ String
		streamContents: [:t1 | self ancestors
				do: [:t2 | t1 nextPutAll: t2 name]
				separatedBy: [t1 nextPutAll: ', ']]! !

!MCAncestry methodsFor: 'ancestry' stamp: 'bp 11/21/2010 18:33'!
ancestorStringWithout: packageName
	^ String streamContents:
		[:s | self ancestors do: [:ea | s nextPutAll: (ea nameWithout: packageName)] separatedBy: [s nextPutAll: ', ']]! !

!MCAncestry methodsFor: 'ancestry' stamp: 'cmm 3/10/2011 20:04'!
ancestors
	^ ancestors ifNil: [ Array empty ]! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
ancestorsDoWhileTrue: t1 
	self ancestors
		do: [:t2 | (t1 value: t2)
				ifTrue: [t2 ancestorsDoWhileTrue: t1]]! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
breadthFirstAncestors
	^ Array
		streamContents: [:t1 | self
				breadthFirstAncestorsDo: [:t2 | t1 nextPut: t2]]! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
breadthFirstAncestorsDo: t1 
	| t2 t3 t4 |
	t2 := Set with: self.
	t3 := OrderedCollection with: self.
	[t3 isEmpty]
		whileFalse: [t4 := t3 removeFirst.
			t4 ancestors
				do: [:t5 | (t2 includes: t5)
						ifFalse: [t1 value: t5.
							t2 add: t5.
							t3 add: t5]]]! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
commonAncestorWith: t1 
	| t2 |
	t2 := self commonAncestorsWith: t1.
	^ t2
		at: 1
		ifAbsent: []! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
commonAncestorsWith: t1 
	| t2 t3 t4 |
	t4 := MCVersionSorter new addVersionInfo: self;
				 addVersionInfo: t1.
	t3 := t4 sortedVersionInfos.
	t2 := (t4 allAncestorsOf: self)
				intersection: (t4 allAncestorsOf: t1).
	^ t3
		select: [:t5 | t2 includes: t5]! !

!MCAncestry methodsFor: 'ancestry' stamp: 'cmm 3/12/2011 17:11'!
hasAncestor: aVersionInfo
	"Answer whether the receiver has ancestor, aVersionInfo."
"Would it be more performant to use a Set for alreadySeen:?"
	^ self
		hasAncestor: aVersionInfo
		alreadySeen: OrderedCollection new! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
hasAncestor: t1 alreadySeen: t2 
	(t2 includes: self)
		ifTrue: [^ false].
	t2 add: self.
	^ self = t1
		or: [self ancestors
				anySatisfy: [:t3 | t3 hasAncestor: t1 alreadySeen: t2]]! !

!MCAncestry methodsFor: 'initializing' stamp: ''!
initialize
	ancestors := #().
	stepChildren := #()! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
isRelatedTo: t1 
	^ t1 timeStamp < self timeStamp
		ifTrue: [self hasAncestor: t1]
		ifFalse: [t1 hasAncestor: self]! !

!MCAncestry methodsFor: 'ancestry' stamp: 'cmm 3/4/2011 14:41'!
names
	"The names of the ancestors."
	^ self ancestors collect: [ : each | each name asMCVersionName ]! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
stepChildren
	^ stepChildren
		ifNil: [#()]! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
stepChildrenString
	^ String
		streamContents: [:t1 | self stepChildren
				do: [:t2 | t1 nextPutAll: t2 name]
				separatedBy: [t1 nextPutAll: ', ']]! !

!MCAncestry methodsFor: 'ancestry' stamp: 'bf 12/8/2011 23:51'!
topologicalAncestors
	"Answer all ancestors in topological order (that is, children always come before all their ancestors). If multiple such orderings are possible, arbitrate by time stamp."	
	^ Array streamContents:
		[:s | | frontier next |
		frontier := MCFrontier frontierOn: self.
		next := self.
		[	frontier remove: next.
			s nextPut: next.
			next := frontier frontier detectMax: [:v | v timeStamp].
			next isNil] whileFalse]! !

!MCAncestry methodsFor: 'ancestry' stamp: ''!
withBreadthFirstAncestors
	^ (Array with: self)
		, self breadthFirstAncestors! !

MCAncestry subclass: #MCVersionInfo
	instanceVariableNames: 'id name message date time author'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCVersionInfo class methodsFor: 'as yet unclassified' stamp: ''!
name: t1 id: t2 message: t3 date: t4 time: t5 author: t6 ancestors: t7 
	^ self
		name: t1
		id: t2
		message: t3
		date: t4
		time: t5
		author: t6
		ancestors: t7
		stepChildren: #()! !

!MCVersionInfo class methodsFor: 'as yet unclassified' stamp: ''!
name: t1 id: t2 message: t3 date: t4 time: t5 author: t6 ancestors: t7 stepChildren: t8 
	^ self new
		initializeWithName: t1
		id: t2
		message: t3
		date: t4
		time: t5
		author: t6
		ancestors: t7
		stepChildren: t8! !

!MCVersionInfo methodsFor: 'comparing' stamp: ''!
= t1 
	^ t1 species = self species
		and: [t1 hasID: id]! !

!MCVersionInfo methodsFor: 'converting' stamp: 'bf 4/18/2010 23:25'!
asDictionary
	^ Dictionary new
		at: #name put: name;
		at: #id put: id asString;
		at: #message put: message;
		at: #date put: date;
		at: #time put: time;
		at: #author put: author;
		at: #ancestors put: (self ancestors collect: [:a | a asDictionary]);
		yourself! !

!MCVersionInfo methodsFor: 'pillaging' stamp: ''!
author
	^ author! !

!MCVersionInfo methodsFor: 'pillaging' stamp: ''!
date
	^ date! !

!MCVersionInfo methodsFor: 'accessing' stamp: 'cmm 3/12/2011 17:10'!
dateAndTime
	^ DateAndTime
		date: date
		time: (time ifNil: [ Time midnight ])! !

!MCVersionInfo methodsFor: 'private' stamp: ''!
hasID: t1 
	^ id = t1! !

!MCVersionInfo methodsFor: 'comparing' stamp: ''!
hash
	^ id hash! !

!MCVersionInfo methodsFor: 'pillaging' stamp: ''!
id
	^ id! !

!MCVersionInfo methodsFor: 'initialize-release' stamp: 'cmm 3/7/2011 14:22'!
initializeWithName: vName id: aUUID message: aString date: aDate time: aTime author: initials ancestors: aCollection stepChildren: stepCollection
	name := vName asString asMCVersionName.
	id := aUUID.
	message := aString.
	date := aDate.
	time := aTime.
	author := initials.
	ancestors :=  aCollection.
	stepChildren := stepCollection! !

!MCVersionInfo methodsFor: 'accessing' stamp: ''!
message
	^ message
		ifNil: ['']! !

!MCVersionInfo methodsFor: 'accessing' stamp: ''!
name
	^ name
		ifNil: ['<working copy>']! !

!MCVersionInfo methodsFor: 'accessing' stamp: 'bp 11/21/2010 19:27'!
nameWithout: packageName
	| result |
	result := self name.
	(result beginsWith: packageName , '-') ifTrue: [
		result := result copyFrom: packageName size + 2 to: result size].
	^result! !

!MCVersionInfo methodsFor: 'accessing' stamp: 'bf 2/24/2012 14:42'!
packageAndBranchName
	^ name
		ifNil: [ self name ]
		ifNotNil: [ name asMCVersionName packageAndBranchName ]! !

!MCVersionInfo methodsFor: 'printing' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPut: $(;
		 nextPutAll: self name;
		 nextPut: $)! !

!MCVersionInfo methodsFor: 'accessing' stamp: ''!
summary
	^ String
		streamContents: [:t1 | t1 nextPutAll: self summaryHeader;
				 cr;
				 cr;
				 nextPutAll: self message]! !

!MCVersionInfo methodsFor: 'accessing' stamp: ''!
summaryHeader
	^ String
		streamContents: [:t1 | 
			t1 nextPutAll: 'Name: ';
				 nextPutAll: self name;
				 cr.
			date
				ifNotNil: [t1 nextPutAll: 'Author: ';
						 nextPutAll: author;
						 cr;
						 nextPutAll: 'Time: ';
						 nextPutAll: date asString , ', ' , time asString;
						 cr].
			id
				ifNotNil: [t1 nextPutAll: 'UUID: ';
						 nextPutAll: id asString;
						 cr].
			t1 nextPutAll: 'Ancestors: ';
				 nextPutAll: self ancestorString.
			self stepChildren isEmpty
				ifFalse: [t1 cr; nextPutAll: 'Backported From: '; nextPutAll: self stepChildrenString]]! !

!MCVersionInfo methodsFor: 'pillaging' stamp: ''!
time
	^ time! !

!MCVersionInfo methodsFor: 'accessing' stamp: ''!
timeStamp
	^ TimeStamp date: date time: time! !

!MCVersionInfo methodsFor: 'accessing' stamp: ''!
timeString
	^ date asString , ', ' , time asString! !

!MCVersionInfo methodsFor: 'accessing' stamp: 'cmm 3/3/2011 14:34'!
versionName
	^ name
		ifNil: [ self name ]
		ifNotNil: [ name asMCVersionName ]! !

!MCVersionInfo methodsFor: 'accessing' stamp: 'cmm 3/5/2011 15:18'!
versionNumber
	^ self versionName versionNumber! !

MCAncestry subclass: #MCWorkingAncestry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCWorkingAncestry methodsFor: 'as yet unclassified' stamp: ''!
addAncestor: t1 
	ancestors := (self ancestors
				reject: [:t2 | t1 hasAncestor: t2])
				copyWith: t1! !

!MCWorkingAncestry methodsFor: 'as yet unclassified' stamp: ''!
addStepChild: t1 
	stepChildren := stepChildren copyWith: t1! !

!MCWorkingAncestry methodsFor: 'as yet unclassified' stamp: ''!
infoWithName: t1 message: t2 
	^ MCVersionInfo
		name: t1
		id: UUID new
		message: t2
		date: Date today
		time: Time now
		author: Utilities authorInitials
		ancestors: ancestors asArray
		stepChildren: self stepChildren asArray! !

!MCWorkingAncestry methodsFor: 'as yet unclassified' stamp: ''!
name
	^ '<working copy>'! !

!MCWorkingAncestry methodsFor: 'as yet unclassified' stamp: ''!
summary
	^ 'Ancestors: ' , self ancestorString! !

Object subclass: #MCConflict
	instanceVariableNames: 'operation chooseRemote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Merging'!

!MCConflict class methodsFor: 'as yet unclassified' stamp: ''!
operation: t1 
	^ self new operation: t1! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
annotations
	^ operation
		ifNotNil: [:t1 | t1 annotations]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
applyTo: t1 
	self isResolved
		ifFalse: [self error: 'Cannot continue until this conflict has been resolved'].
	self remoteChosen
		ifTrue: [operation applyTo: t1]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
chooseLocal
	chooseRemote := false! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
chooseNewer
	self isLocalNewer
		ifTrue: [self chooseLocal]
		ifFalse: [self isRemoteNewer
				ifTrue: [self chooseRemote]]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
chooseOlder
	self isRemoteNewer
		ifTrue: [self chooseLocal]
		ifFalse: [self isLocalNewer
				ifTrue: [self chooseRemote]]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
chooseRemote
	chooseRemote := true! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
clearChoice
	chooseRemote := nil! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
definition
	^ operation
		ifNotNil: [:t1 | t1 definition]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
isConflict
	^ true! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
isLocalNewer
	^ self localDefinition fullTimeStamp > self remoteDefinition fullTimeStamp! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
isRemoteNewer
	^ self localDefinition fullTimeStamp < self remoteDefinition fullTimeStamp! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
isResolved
	^ chooseRemote notNil! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
localChosen
	^ chooseRemote notNil
		and: [chooseRemote not]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
localDefinition
	^ operation baseDefinition! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
operation
	^ operation! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
operation: t1 
	operation := t1! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
remoteChosen
	^ chooseRemote notNil
		and: [chooseRemote]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
remoteDefinition
	^ operation targetDefinition! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
source
	^ self localChosen
		ifTrue: [operation fromSource]
		ifFalse: [operation source]! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
status
	^ self isResolved
		ifTrue: [self remoteChosen
				ifTrue: ['R']
				ifFalse: ['L']]
		ifFalse: ['']! !

!MCConflict methodsFor: 'as yet unclassified' stamp: ''!
summary
	| t1 |
	t1 := self isResolved
				ifTrue: [self remoteChosen
						ifTrue: [#underlined]
						ifFalse: [#struckOut]]
				ifFalse: [#bold].
	^ Text
		string: operation summary
		attribute: (TextEmphasis perform: t1)! !

Object subclass: #MCDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Base'!

MCDefinition class
	instanceVariableNames: 'instances'!

MCDefinition class
	instanceVariableNames: 'instances'!

MCDefinition subclass: #MCClassDefinition
	instanceVariableNames: 'name superclassName variables category type comment commentStamp traitComposition classTraitComposition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCClassDefinition class methodsFor: 'obsolete' stamp: ''!
name: t1 superclassName: t2 category: t3 instVarNames: t4 classVarNames: t5 poolDictionaryNames: t6 classInstVarNames: t7 comment: t8 
	^ self
		name: t1
		superclassName: t2
		category: t3
		instVarNames: t4
		classVarNames: t5
		poolDictionaryNames: t6
		classInstVarNames: t7
		type: #normal
		comment: t8! !

!MCClassDefinition class methodsFor: 'obsolete' stamp: ''!
name: t1 superclassName: t2 category: t3 instVarNames: t4 classVarNames: t5 poolDictionaryNames: t6 classInstVarNames: t7 type: t8 comment: t9 
	^ self
		name: t1
		superclassName: t2
		category: t3
		instVarNames: t4
		classVarNames: t5
		poolDictionaryNames: t6
		classInstVarNames: t7
		type: t8
		comment: t9
		commentStamp: nil! !

!MCClassDefinition class methodsFor: 'instance creation' stamp: ''!
name: t1 superclassName: t2 category: t3 instVarNames: t4 classVarNames: t5 poolDictionaryNames: t6 classInstVarNames: t7 type: t8 comment: t9 commentStamp: t10 
	^ self
		instanceLike: (self new
				initializeWithName: t1
				superclassName: t2
				traitComposition: '{}'
				classTraitComposition: '{}'
				category: t3
				instVarNames: t4
				classVarNames: t5
				poolDictionaryNames: t6
				classInstVarNames: t7
				type: t8
				comment: t9
				commentStamp: t10)! !

!MCClassDefinition class methodsFor: 'obsolete' stamp: ''!
name: t1 superclassName: t2 category: t3 instVarNames: t4 comment: t5 
	^ self
		name: t1
		superclassName: t2
		category: t3
		instVarNames: t4
		classVarNames: #()
		poolDictionaryNames: #()
		classInstVarNames: #()
		comment: t5! !

!MCClassDefinition class methodsFor: 'instance creation' stamp: ''!
name: t1 superclassName: t2 traitComposition: t3 classTraitComposition: t4 category: t5 instVarNames: t6 classVarNames: t7 poolDictionaryNames: t8 classInstVarNames: t9 type: t10 comment: t11 commentStamp: t12 
	^ self
		instanceLike: (self new
				initializeWithName: t1
				superclassName: t2
				traitComposition: t3
				classTraitComposition: t4
				category: t5
				instVarNames: t6
				classVarNames: t7
				poolDictionaryNames: t8
				classInstVarNames: t9
				type: t10
				comment: t11
				commentStamp: t12)! !

!MCClassDefinition methodsFor: 'visiting' stamp: ''!
= t1 
	^ super = t1
		and: [superclassName = t1 superclassName
				and: [self traitCompositionString = t1 traitCompositionString
						and: [self classTraitCompositionString = t1 classTraitCompositionString
								and: [category = t1 category
										and: [type = t1 type
												and: [self sortedVariables = t1 sortedVariables
														and: [comment = t1 comment]]]]]]]! !

!MCClassDefinition methodsFor: 'visiting' stamp: ''!
accept: t1 
	t1 visitClassDefinition: self.
	(self hasClassInstanceVariables
			or: [self hasClassTraitComposition])
		ifTrue: [t1 visitMetaclassDefinition: self]! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
actualClass
	^ Smalltalk classNamed: self className! !

!MCClassDefinition methodsFor: 'initializing' stamp: ''!
addVariables: t1 ofType: t2 
	variables
		addAll: (t1
				collect: [:t3 | t2 name: t3 asString])! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
category
	^ category! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
classInstVarNames
	^ self selectVariables: #isClassInstanceVariable! !

!MCClassDefinition methodsFor: 'printing' stamp: ''!
classInstanceVariablesString
	^ self stringForVariablesOfType: #isClassInstanceVariable! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
className
	^ name! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
classTraitComposition
	^ classTraitComposition! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
classTraitCompositionString
	^ self classTraitComposition
		ifNil: ['{}']! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
classVarNames
	^ (self selectVariables: #isClassVariable) asArray sort! !

!MCClassDefinition methodsFor: 'printing' stamp: ''!
classVariablesString
	^ self stringForVariablesOfType: #isClassVariable! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
comment
	^ comment! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
commentStamp
	^ commentStamp! !

!MCClassDefinition methodsFor: 'installing' stamp: ''!
createClass
	| t1 t2 t3 |
	t1 := superclassName == #nil
				ifFalse: [Smalltalk at: superclassName].
	[t3 := ClassBuilder new
				name: name
				inEnvironment: t1 environment
				subclassOf: t1
				type: type
				instanceVariableNames: self instanceVariablesString
				classVariableNames: self classVariablesString
				poolDictionaries: self sharedPoolsString
				category: category]
		on: Warning , DuplicateVariableError
		do: [:t5 | t5 resume].
	t2 := Compiler
				evaluate: (self traitComposition
						ifNil: ['{}']).
	(t2 isCollection
			and: [t2 isEmpty
					and: [t3 traitComposition isEmpty]])
		ifFalse: [t3 setTraitComposition: t2 asTraitComposition].
	t2 := Compiler
				evaluate: (self classTraitComposition
						ifNil: ['{}']).
	(t2 isCollection
			and: [t2 isEmpty
					and: [t3 class traitComposition isEmpty]])
		ifFalse: [t3 class setTraitComposition: t2 asTraitComposition].
	^ t3! !

!MCClassDefinition methodsFor: 'initializing' stamp: ''!
defaultCommentStamp
	^ String new! !

!MCClassDefinition methodsFor: 'printing' stamp: 'ul 11/6/2010 05:50'!
definitionAndCommentString
	^ String streamContents: [:stream |
		self printDefinitionOn: stream.
		stream cr; cr.
		self printClassSideDefinitionOn: stream.    
		stream cr; cr.
		self printCommentOn: stream]! !

!MCClassDefinition methodsFor: 'printing' stamp: ''!
definitionString
	^ String
		streamContents: [:t1 | self printDefinitionOn: t1]! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
description
	^ Array with: name! !

!MCClassDefinition methodsFor: 'renaming' stamp: 'cmm 6/8/2011 13:36'!
handlePackageRename: oldPackageName to: newPackageName 
	(self actualClass category beginsWith: newPackageName) ifFalse:
		[ self actualClass category:
			(self
				newCategoryNameFor: self actualClass category
				givenRenameFrom: oldPackageName
				to: newPackageName) ]! !

!MCClassDefinition methodsFor: 'testing' stamp: ''!
hasClassInstanceVariables
	^ (self selectVariables: #isClassInstanceVariable) isEmpty not! !

!MCClassDefinition methodsFor: 'testing' stamp: ''!
hasClassTraitComposition
	^ self classTraitCompositionString ~= '{}'! !

!MCClassDefinition methodsFor: 'testing' stamp: ''!
hasComment
	^ comment isEmptyOrNil not! !

!MCClassDefinition methodsFor: 'testing' stamp: ''!
hasTraitComposition
	^ self traitCompositionString ~= '{}'! !

!MCClassDefinition methodsFor: 'comparing' stamp: ''!
hash
	| t1 |
	t1 := name hashWithInitialHash: 0.
	t1 := superclassName hashWithInitialHash: t1.
	t1 := self traitCompositionString hashWithInitialHash: t1.
	t1 := self classTraitComposition asString hashWithInitialHash: t1.
	t1 := (category
				ifNil: [''])
				hashWithInitialHash: t1.
	t1 := type hashWithInitialHash: t1.
	variables
		do: [:t3 | t1 := t3 name hashWithInitialHash: t1].
	^ t1! !

!MCClassDefinition methodsFor: 'initializing' stamp: ''!
initializeWithName: t1 superclassName: t2 category: t3 instVarNames: t4 classVarNames: t5 poolDictionaryNames: t6 classInstVarNames: t7 type: t8 comment: t9 commentStamp: t10 
	name := t1 asSymbol.
	superclassName := t2
				ifNil: ['nil']
				ifNotNil: [t2 asSymbol].
	category := t3.
	name = #CompiledMethod
		ifTrue: [type := #compiledMethod]
		ifFalse: [type := t8].
	comment := t9 withSqueakLineEndings.
	commentStamp := t10
				ifNil: [self defaultCommentStamp].
	variables := OrderedCollection new.
	self addVariables: t4 ofType: MCInstanceVariableDefinition.
	self addVariables: t5 asSortedCollection ofType: MCClassVariableDefinition.
	self addVariables: t6 asSortedCollection ofType: MCPoolImportDefinition.
	self addVariables: t7 ofType: MCClassInstanceVariableDefinition! !

!MCClassDefinition methodsFor: 'initializing' stamp: ''!
initializeWithName: t1 superclassName: t2 traitComposition: t3 classTraitComposition: t4 category: t5 instVarNames: t6 classVarNames: t7 poolDictionaryNames: t8 classInstVarNames: t9 type: t10 comment: t11 commentStamp: t12 
	name := t1 asSymbol.
	superclassName := t2
				ifNil: ['nil']
				ifNotNil: [t2 asSymbol].
	traitComposition := t3.
	classTraitComposition := t4.
	category := t5.
	name = #CompiledMethod
		ifTrue: [type := #compiledMethod]
		ifFalse: [type := t10].
	comment := t11 withSqueakLineEndings.
	commentStamp := t12
				ifNil: [self defaultCommentStamp].
	variables := OrderedCollection new.
	self addVariables: t6 ofType: MCInstanceVariableDefinition.
	self addVariables: t7 asSortedCollection ofType: MCClassVariableDefinition.
	self addVariables: t8 asSortedCollection ofType: MCPoolImportDefinition.
	self addVariables: t9 ofType: MCClassInstanceVariableDefinition! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
instVarNames
	^ self selectVariables: #isInstanceVariable! !

!MCClassDefinition methodsFor: 'printing' stamp: ''!
instanceVariablesString
	^ self stringForVariablesOfType: #isInstanceVariable! !

!MCClassDefinition methodsFor: 'testing' stamp: ''!
isClassDefinition
	^ true! !

!MCClassDefinition methodsFor: 'testing' stamp: ''!
isCodeDefinition
	^ true! !

!MCClassDefinition methodsFor: 'printing' stamp: ''!
kindOfSubclass
	type = #normal
		ifTrue: [^ ' subclass: '].
	type = #words
		ifTrue: [^ ' variableWordSubclass: '].
	type = #variable
		ifTrue: [^ ' variableSubclass: '].
	type = #bytes
		ifTrue: [^ ' variableByteSubclass: '].
	type = #weak
		ifTrue: [^ ' weakSubclass: '].
	type = #compiledMethod
		ifTrue: [^ ' variableByteSubclass: '].
	self error: 'Unrecognized class type'! !

!MCClassDefinition methodsFor: 'installing' stamp: ''!
load
	self createClass
		ifNotNil: [:t1 | 
			t1 class instanceVariableNames: self classInstanceVariablesString.
			self hasComment
				ifTrue: [t1 classComment: comment stamp: commentStamp]]! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
poolDictionaries
	^ self selectVariables: #isPoolImport! !

!MCClassDefinition methodsFor: 'annotations' stamp: ''!
printAnnotations: t1 on: t2 
	t1
		do: [:t3 | t3 == #requirements
				ifTrue: [self requirements
						do: [:t4 | t2 nextPutAll: t4]
						separatedBy: [t2 space]]]
		separatedBy: [t2 space]! !

!MCClassDefinition methodsFor: 'printing' stamp: 'ul 11/6/2010 05:49'!
printClassSideDefinitionOn: stream
	
	stream
		nextPutAll: self className;
		nextPutAll: ' class ';
		cr; tab;
		nextPutAll: 'instanceVariableNames: ';
		store: self classInstanceVariablesString! !

!MCClassDefinition methodsFor: 'printing' stamp: 'dtl 5/5/2010 21:36'!
printCommentOn: stream
	stream
		nextPut: $";
		nextPutAll: self comment asString;
		nextPut: $"
! !

!MCClassDefinition methodsFor: 'printing' stamp: ''!
printDefinitionOn: t1 
	t1 nextPutAll: self superclassName;
		 nextPutAll: self kindOfSubclass;
		 nextPut: $#;
		 nextPutAll: self className;
		 cr;
		 tab.
	self hasTraitComposition
		ifTrue: [t1 nextPutAll: 'uses: ';
				 nextPutAll: self traitCompositionString;
				 cr;
				 tab].
	t1 nextPutAll: 'instanceVariableNames: ';
		 store: self instanceVariablesString;
		 cr;
		 tab;
		 nextPutAll: 'classVariableNames: ';
		 store: self classVariablesString;
		 cr;
		 tab;
		 nextPutAll: 'poolDictionaries: ';
		 store: self sharedPoolsString;
		 cr;
		 tab;
		 nextPutAll: 'category: ';
		 store: self category asString! !

!MCClassDefinition methodsFor: 'comparing' stamp: ''!
provisions
	^ Array with: name! !

!MCClassDefinition methodsFor: 'comparing' stamp: ''!
requirements
	^ superclassName == #nil
		ifTrue: [self poolDictionaries]
		ifFalse: [(Array with: superclassName)
				, self poolDictionaries]! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
selectVariables: t1 
	^ variables
		select: [:t2 | t2 perform: t1]
		thenCollect: [:t2 | t2 name]! !

!MCClassDefinition methodsFor: 'printing' stamp: ''!
sharedPoolsString
	^ self stringForVariablesOfType: #isPoolImport! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
sortKey
	^ self className! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
sortedVariables
	| t1 |
	t1 := variables
				select: [:t2 | t2 isOrderDependend].
	t1
		addAll: ((variables
				reject: [:t2 | t2 isOrderDependend])
				asSortedCollection: [:t2 :t3 | t2 name <= t3 name]).
	^ t1! !

!MCClassDefinition methodsFor: 'printing' stamp: 'dtl 5/5/2010 20:33'!
source
	^ self definitionAndCommentString! !

!MCClassDefinition methodsFor: 'serializing' stamp: ''!
storeDataOn: t1 
	| t2 |
	t2 := (self hasTraitComposition
					or: [self hasClassTraitComposition])
				ifTrue: [self class instSize]
				ifFalse: [self class instSize - 2].
	t1 beginInstance: self class size: t2.
	1
		to: t2
		do: [:t3 | t1
				nextPut: (self instVarAt: t3)]! !

!MCClassDefinition methodsFor: 'installing' stamp: ''!
stringForVariablesOfType: t1 
	^ String
		streamContents: [:t2 | (self selectVariables: t1)
				do: [:t3 | t2 nextPutAll: t3]
				separatedBy: [t2 space]]! !

!MCClassDefinition methodsFor: 'printing' stamp: ''!
summary
	^ name! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
superclassName
	^ superclassName! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
traitComposition
	^ traitComposition! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
traitCompositionString
	^ self traitComposition
		ifNil: ['{}']! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
type
	^ type! !

!MCClassDefinition methodsFor: 'installing' stamp: ''!
unload
	Smalltalk removeClassNamed: name! !

!MCClassDefinition methodsFor: 'accessing' stamp: ''!
variables
	^ variables! !

!MCClassDefinition methodsFor: 'accessing' stamp: 'cmm 3/8/2011 21:00'!
workingCopy
	^ self actualClass workingCopy! !

MCClassDefinition subclass: #MCTraitDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCTraitDefinition class methodsFor: 'as yet unclassified' stamp: ''!
name: t1 traitComposition: t2 category: t3 comment: t4 commentStamp: t5 
	^ self
		instanceLike: (self new
				initializeWithName: t1
				traitComposition: t2
				category: t3
				comment: t4
				commentStamp: t5)! !

!MCTraitDefinition methodsFor: 'visiting' stamp: ''!
= t1 
	self flag: #traits.
	^ (t1 isKindOf: MCDefinition)
		and: [(self isRevisionOf: t1)
				and: [self traitCompositionString = t1 traitCompositionString
						and: [category = t1 category
								and: [comment = t1 comment]]]]! !

!MCTraitDefinition methodsFor: 'visiting' stamp: ''!
accept: t1 
	^ t1 visitTraitDefinition: self! !

!MCTraitDefinition methodsFor: 'accessing' stamp: ''!
classTraitCompositionString
	^ self traitComposition
		ifNil: ['{}']! !

!MCTraitDefinition methodsFor: 'visiting' stamp: ''!
createClass
	^ ClassDescription
		newTraitNamed: name
		uses: (Compiler evaluate: self traitCompositionString)
		category: category! !

!MCTraitDefinition methodsFor: 'testing' stamp: ''!
hasClassInstanceVariables
	^ false! !

!MCTraitDefinition methodsFor: 'testing' stamp: ''!
hasTraitComposition
	^ self traitCompositionString ~= '{}'! !

!MCTraitDefinition methodsFor: 'comparing' stamp: ''!
hash
	| t1 |
	t1 := name hashWithInitialHash: 0.
	t1 := self traitCompositionString hashWithInitialHash: t1.
	t1 := (category
				ifNil: [''])
				hashWithInitialHash: t1.
	^ t1! !

!MCTraitDefinition methodsFor: 'initializing' stamp: ''!
initializeWithName: t1 traitComposition: t2 category: t3 comment: t4 commentStamp: t5 
	name := t1 asSymbol.
	traitComposition := t2.
	category := t3.
	comment := t4 withSqueakLineEndings.
	commentStamp := t5
				ifNil: [self defaultCommentStamp]! !

!MCTraitDefinition methodsFor: 'installing' stamp: ''!
load
	self createClass
		ifNotNil: [:t1 | self hasComment
				ifTrue: [t1 classComment: comment stamp: commentStamp]]! !

!MCTraitDefinition methodsFor: 'printing' stamp: ''!
printDefinitionOn: t1 
	t1 nextPutAll: 'Trait named: #' , self className;
		 cr;
		 tab;
		 nextPutAll: 'uses: ';
		 nextPutAll: self traitCompositionString;
		 cr;
		 tab;
		 nextPutAll: 'category: ';
		 store: self category asString! !

!MCTraitDefinition methodsFor: 'comparing' stamp: ''!
requirements
	| t1 t2 |
	self hasTraitComposition
		ifFalse: [^ Array new].
	t1 := Scanner new scanTokens: self traitComposition.
	t2 := t1
				select: [:t3 | t3 first isUppercase].
	^ t2 asArray! !

!MCTraitDefinition methodsFor: 'accessing' stamp: ''!
traitComposition
	^ traitComposition! !

MCDefinition subclass: #MCClassTraitDefinition
	instanceVariableNames: 'baseTrait classTraitComposition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCClassTraitDefinition class methodsFor: 'instance creation' stamp: ''!
baseTraitName: t1 classTraitComposition: t2 
	^ self
		instanceLike: (self new initializeWithBaseTraitName: t1 classTraitComposition: t2)! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
= t1 
	^ super = t1
		and: [baseTrait = t1 baseTrait
				and: [self classTraitCompositionString = t1 classTraitCompositionString]]! !

!MCClassTraitDefinition methodsFor: 'as yet unclassified' stamp: ''!
accept: t1 
	^ t1 visitClassTraitDefinition: self! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
baseTrait
	^ baseTrait! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
className
	^ self baseTrait! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
classTraitComposition
	^ classTraitComposition! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
classTraitCompositionString
	^ self classTraitComposition
		ifNil: ['{}']! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
definitionString
	^ self baseTrait , ' classTrait
	uses: ' , self classTraitCompositionString! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
description
	^ Array with: baseTrait with: classTraitComposition! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
hash
	| t1 |
	t1 := baseTrait hashWithInitialHash: 0.
	t1 := self classTraitCompositionString hashWithInitialHash: t1.
	^ t1! !

!MCClassTraitDefinition methodsFor: 'initialization' stamp: ''!
initializeWithBaseTraitName: t1 classTraitComposition: t2 
	baseTrait := t1.
	classTraitComposition := t2! !

!MCClassTraitDefinition methodsFor: 'as yet unclassified' stamp: ''!
load
	Compiler evaluate: self definitionString! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
requirements
	^ Array with: baseTrait! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
sortKey
	^ self baseTrait name , '.classTrait'! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
source
	^ self definitionString! !

!MCClassTraitDefinition methodsFor: 'accessing' stamp: ''!
summary
	^ self baseTrait , ' classTrait'! !

!MCDefinition class methodsFor: 'class initialization' stamp: ''!
cleanUp
	self clearInstances! !

!MCDefinition class methodsFor: 'as yet unclassified' stamp: ''!
clearInstances
	instances := nil.
	self subclassesDo: #clearInstances! !

!MCDefinition class methodsFor: 'as yet unclassified' stamp: ''!
instanceLike: t1 
	^ (instances
		ifNil: [instances := WeakSet new])
		like: t1
		ifAbsent: [instances add: t1]! !

!MCDefinition methodsFor: 'comparing' stamp: ''!
<= t1 
	^ self sortKey <= t1 sortKey! !

!MCDefinition methodsFor: 'comparing' stamp: ''!
= t1 
	^ (t1 isKindOf: MCDefinition)
		and: [self isRevisionOf: t1]! !

!MCDefinition methodsFor: 'accessing' stamp: 'ul 11/7/2010 22:45'!
actualClass

	^nil! !

!MCDefinition methodsFor: 'installing' stamp: ''!
addMethodAdditionTo: t1 
	Transcript show: self printString.
	self load! !

!MCDefinition methodsFor: 'annotations' stamp: ''!
annotations
	^ self annotations: Preferences defaultAnnotationRequests! !

!MCDefinition methodsFor: 'annotations' stamp: ''!
annotations: t1 
	^ String
		streamContents: [:t2 | self printAnnotations: t1 on: t2]! !

!MCDefinition methodsFor: 'comparing' stamp: ''!
description
	self subclassResponsibility! !

!MCDefinition methodsFor: 'comparing' stamp: ''!
fullTimeStamp
	^ TimeStamp current! !

!MCDefinition methodsFor: 'renaming' stamp: 'cmm 6/8/2011 13:22'!
handlePackageRename: oldPackageName to: newPackageName
	"Overridden as necessary in subclasses."! !

!MCDefinition methodsFor: 'comparing' stamp: ''!
hash
	^ self description hash! !

!MCDefinition methodsFor: 'testing' stamp: ''!
isClassDefinition
	^ false! !

!MCDefinition methodsFor: 'testing' stamp: ''!
isClassDefinitionExtension
	^ false! !

!MCDefinition methodsFor: 'testing' stamp: ''!
isMethodDefinition
	^ false! !

!MCDefinition methodsFor: 'testing' stamp: ''!
isOrganizationDefinition
	^ false! !

!MCDefinition methodsFor: 'comparing' stamp: ''!
isRevisionOf: t1 
	^ t1 description = self description! !

!MCDefinition methodsFor: 'comparing' stamp: ''!
isSameRevisionAs: t1 
	^ self = t1! !

!MCDefinition methodsFor: 'testing' stamp: ''!
isScriptDefinition
	^ false! !

!MCDefinition methodsFor: 'installing' stamp: ''!
load
	^ self! !

!MCDefinition methodsFor: 'installing' stamp: ''!
loadOver: t1 
	self load! !

!MCDefinition methodsFor: 'renaming' stamp: 'cmm 6/6/2011 15:22'!
newCategoryNameFor: categoryName givenRenameFrom: oldPackageName to: newPackageName 
	^ oldPackageName size < categoryName size
		ifTrue:
			[ newPackageName ,
				(categoryName
					copyFrom: oldPackageName size + 1
					to: categoryName size) ]
		ifFalse: [ newPackageName ]! !

!MCDefinition methodsFor: 'installing' stamp: ''!
postload
	^ self! !

!MCDefinition methodsFor: 'installing' stamp: ''!
postloadOver: t1 
	self postload! !

!MCDefinition methodsFor: 'annotations' stamp: ''!
printAnnotations: t1 on: t2 
	t2 nextPutAll: 'not yet implemented'! !

!MCDefinition methodsFor: 'printing' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPutAll: '(' , self summary , ')'! !

!MCDefinition methodsFor: 'accessing' stamp: ''!
provisions
	^ #()! !

!MCDefinition methodsFor: 'repositories' stamp: 'cmm 3/8/2011 20:59'!
repositoryGroup
	"Answer the MCRepositoryGroup from which this this object was loaded."
	^ self workingCopy repositoryGroup! !

!MCDefinition methodsFor: 'accessing' stamp: ''!
requirements
	^ #()! !

!MCDefinition methodsFor: 'comparing' stamp: ''!
sortKey
	self subclassResponsibility! !

!MCDefinition methodsFor: 'printing' stamp: ''!
summary
	self subclassResponsibility! !

!MCDefinition methodsFor: 'printing' stamp: 'bf 11/1/2011 11:42'!
summarySuffixOver: previousDefinition
	^self source = previousDefinition source
		ifTrue: [ ' (source same but rev changed)' ]
		ifFalse: [ ' (changed)' ]! !

!MCDefinition methodsFor: 'installing' stamp: ''!
unload
	^ self! !

!MCDefinition methodsFor: 'repositories' stamp: 'cmm 3/8/2011 21:13'!
workingCopy
	self subclassResponsibility! !

MCDefinition subclass: #MCMethodDefinition
	instanceVariableNames: 'classIsMeta source category selector className timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

MCMethodDefinition class
	instanceVariableNames: 'definitions'!

MCMethodDefinition class
	instanceVariableNames: 'definitions'!

!MCMethodDefinition class methodsFor: 'accessing' stamp: 'ul 2/26/2010 17:42'!
cachedDefinitions
	
	^definitions ifNil: [ definitions := WeakIdentityKeyDictionary new ]! !

!MCMethodDefinition class methodsFor: 'create' stamp: 'ab 7/26/2003 02:05'!
className: classString
classIsMeta: metaBoolean
selector: selectorString
category: catString
timeStamp: timeString
source: sourceString
	^ self instanceLike:
		(self new initializeWithClassName: classString
					classIsMeta: metaBoolean
					selector: selectorString
					category: catString
					timeStamp: timeString
					source: sourceString)! !

!MCMethodDefinition class methodsFor: 'create' stamp: 'ab 4/1/2003 01:40'!
className: classString
selector: selectorString
category: catString
timeStamp: timeString
source: sourceString
	^ self	className: classString
			classIsMeta: false
			selector: selectorString
			category: catString
			timeStamp: timeString
			source: sourceString! !

!MCMethodDefinition class methodsFor: 'class initialization' stamp: ''!
cleanUp
	self shutDown! !

!MCMethodDefinition class methodsFor: 'create' stamp: 'nice 1/1/2010 22:10'!
forMethodReference: aMethodReference
	| definition |
	definition := self cachedDefinitions at: aMethodReference compiledMethod ifAbsent: [].
	(definition isNil
		or: [definition selector ~= aMethodReference methodSymbol
		or: [definition className ~= aMethodReference classSymbol
		or: [definition classIsMeta ~= aMethodReference classIsMeta
		or: [definition category ~= aMethodReference category]]]])
			ifTrue: [definition := self 
						className: aMethodReference classSymbol
						classIsMeta: aMethodReference classIsMeta
						selector: aMethodReference methodSymbol
						category: aMethodReference category
						timeStamp: aMethodReference timeStamp
						source: aMethodReference source.
					self cachedDefinitions at: aMethodReference compiledMethod put: definition].
	^ definition
	! !

!MCMethodDefinition class methodsFor: 'class initialization' stamp: 'ab 8/22/2003 18:14'!
initialize
	Smalltalk addToShutDownList: self! !

!MCMethodDefinition class methodsFor: 'class initialization' stamp: 'ul 2/26/2010 17:42'!
shutDown
	
	definitions := nil.! !

!MCMethodDefinition methodsFor: 'comparing' stamp: ''!
= t1 
	^ super = t1
		and: [t1 source = self source
				and: [t1 category = self category
						and: [t1 timeStamp = self timeStamp]]]! !

!MCMethodDefinition methodsFor: 'visiting' stamp: ''!
accept: t1 
	^ t1 visitMethodDefinition: self! !

!MCMethodDefinition methodsFor: 'accessing' stamp: ''!
actualClass
	^ Smalltalk
		at: className
		ifPresent: [:t1 | classIsMeta
				ifTrue: [t1 classSide]
				ifFalse: [t1]]! !

!MCMethodDefinition methodsFor: 'installing' stamp: 'cmm 3/8/2011 20:25'!
addMethodAdditionTo: aCollection 
	aCollection
		 add: self asMethodAddition createCompiledMethod ;
		 yourself! !

!MCMethodDefinition methodsFor: 'converting' stamp: 'ar 3/4/2010 23:39'!
asMethodAddition
	^MethodAddition new
		compile: source
		classified: category
		withStamp: timeStamp
		notifying: nil
		logSource: true
		inClass: self actualClass.! !

!MCMethodDefinition methodsFor: 'converting' stamp: 'cmm 3/8/2011 19:44'!
asMethodReference
	^ MethodReference
		class: self actualClass
		selector: self selector! !

!MCMethodDefinition methodsFor: 'accessing' stamp: ''!
category
	^ category! !

!MCMethodDefinition methodsFor: 'accessing' stamp: ''!
classIsMeta
	^ classIsMeta! !

!MCMethodDefinition methodsFor: 'accessing' stamp: ''!
className
	^ className! !

!MCMethodDefinition methodsFor: 'printing' stamp: ''!
description
	^ Array
		with: className
		with: selector
		with: classIsMeta! !

!MCMethodDefinition methodsFor: 'printing' stamp: 'bf 3/28/2011 18:41'!
fullClassName
	"Using #class selector for classes for backwards compatibility"

	^ self classIsMeta
		ifFalse: [self className]
		ifTrue: [
			(self actualClass notNil and: [ self actualClass isTrait ])
				ifFalse: [self className, ' class']
				ifTrue: [self className, ' classSide']]! !

!MCMethodDefinition methodsFor: 'accessing' stamp: ''!
fullTimeStamp
	^ TimeStamp fromMethodTimeStamp: timeStamp! !

!MCMethodDefinition methodsFor: 'renaming' stamp: 'cmm 12/2/2011 13:17'!
handlePackageRename: oldPackageName to: newPackageName 
	"If I'm an extension or override method, rename the category to be prefixed with newPackageName."
	((self isExtensionMethod or: [ self isOverrideMethod ]) and: [ (self category allButFirst beginsWith: newPackageName asLowercase) not ]) ifTrue:
		[ self actualClass organization
			renameCategory: self category
			toBe:
				'*' ,
					(self
						newCategoryNameFor: self category allButFirst
						givenRenameFrom: oldPackageName
						to: newPackageName) asLowercase ]! !

!MCMethodDefinition methodsFor: 'comparing' stamp: ''!
hash
	| t1 |
	t1 := classIsMeta asString hashWithInitialHash: 0.
	t1 := source hashWithInitialHash: t1.
	t1 := category hashWithInitialHash: t1.
	t1 := className hashWithInitialHash: t1.
	^ t1! !

!MCMethodDefinition methodsFor: 'serializing' stamp: ''!
initializeWithClassName: t1 classIsMeta: t2 selector: t3 category: t4 timeStamp: t5 source: t6 
	className := t1 asSymbol.
	selector := t3 asSymbol.
	category := t4 asSymbol.
	timeStamp := t5.
	classIsMeta := t2.
	source := t6 withSqueakLineEndings! !

!MCMethodDefinition methodsFor: 'testing' stamp: ''!
isCodeDefinition
	^ true! !

!MCMethodDefinition methodsFor: 'installing' stamp: ''!
isExtensionMethod
	^ category beginsWith: '*'! !

!MCMethodDefinition methodsFor: 'testing' stamp: ''!
isExternalStructureFieldDefinition
	^ selector = #fields
		and: [classIsMeta
				and: [(Smalltalk
						at: #ExternalStructure
						ifPresent: [:t1 | self actualClass theNonMetaClass inheritsFrom: t1])
						== true]]! !

!MCMethodDefinition methodsFor: 'testing' stamp: ''!
isInitializer
	^ selector = #initialize
		and: [classIsMeta]! !

!MCMethodDefinition methodsFor: 'testing' stamp: ''!
isMethodDefinition
	^ true! !

!MCMethodDefinition methodsFor: 'installing' stamp: ''!
isOverrideMethod
	^ self isExtensionMethod
		and: [category endsWith: '-override']! !

!MCMethodDefinition methodsFor: 'accessing' stamp: ''!
load
	self actualClass
		compile: source
		classified: category
		withStamp: timeStamp
		notifying: nil! !

!MCMethodDefinition methodsFor: 'installing' stamp: ''!
postload
	self isInitializer
		ifTrue: [self actualClass theNonMetaClass initialize].
	self isExternalStructureFieldDefinition
		ifTrue: [self actualClass theNonMetaClass compileFields]! !

!MCMethodDefinition methodsFor: 'annotations' stamp: ''!
printAnnotations: t1 on: t2 
	t1
		do: [:t3 | 
			t3 == #timeStamp
				ifTrue: [t2 nextPutAll: self timeStamp].
			t3 == #messageCategory
				ifTrue: [t2 nextPutAll: self category].
			t3 == #requirements
				ifTrue: [self requirements
						do: [:t4 | t2 nextPutAll: t4]
						separatedBy: [t2 space]]]
		separatedBy: [t2 space]! !

!MCMethodDefinition methodsFor: 'installing' stamp: ''!
removeSelector: t1 fromClass: t2 
	| t3 |
	t3 := t2 organization categoryOfElement: t1.
	t3
		ifNotNil: [(category beginsWith: '*')
					= (t3 beginsWith: '*')
				ifFalse: [^ self].
			((category beginsWith: '*')
					and: [category ~= t3])
				ifTrue: [^ self]].
	t2 removeSelector: t1! !

!MCMethodDefinition methodsFor: 'comparing' stamp: ''!
requirements
	^ Array with: className! !

!MCMethodDefinition methodsFor: 'installing' stamp: 'bf 5/4/2012 16:27'!
scanForPreviousVersions
	"Answer change records for other versions of this method, i.e. other overrides and the original version"
	| versions |
	versions := OrderedCollection new.
	PackageInfo default changeRecordsForMethod: self asMethodReference do: [:record |
		record category = category ifFalse: [versions add: record]].
	^versions
! !

!MCMethodDefinition methodsFor: 'accessing' stamp: ''!
selector
	^ selector! !

!MCMethodDefinition methodsFor: 'comparing' stamp: ''!
sortKey
	^ self className , '.'
		, (self classIsMeta
				ifTrue: ['meta']
				ifFalse: ['nonmeta']) , '.' , self selector! !

!MCMethodDefinition methodsFor: 'accessing' stamp: ''!
source
	^ source! !

!MCMethodDefinition methodsFor: 'printing' stamp: ''!
summary
	^ self fullClassName , '>>' , selector! !

!MCMethodDefinition methodsFor: 'printing' stamp: 'bf 11/1/2011 11:49'!
summarySuffixOver: previousDefinition
	| sourceChanged categoryChanged timeStampChanged |
	sourceChanged := self source ~= previousDefinition source.
	timeStampChanged := self timeStamp ~= previousDefinition timeStamp.
	categoryChanged := self category ~= previousDefinition category.
	sourceChanged | timeStampChanged | categoryChanged
		ifFalse: [ ^super summarySuffixOver: previousDefinition ].
	sourceChanged ifTrue: [
		^categoryChanged
			ifTrue: [ ' (changed and recategorized)' ]
			ifFalse: [ ' (changed)' ] ].
	timeStampChanged & categoryChanged
		ifTrue: [^ ' (recategorized and different time stamp)' ].
	^categoryChanged
		ifTrue: [ ' (only recategorized)' ]
		ifFalse: [ ' (only different time stamp)' ]
! !

!MCMethodDefinition methodsFor: 'accessing' stamp: 'nice 9/22/2010 00:48'!
timeStamp
	^ timeStamp ifNil: ['']! !

!MCMethodDefinition methodsFor: 'installing' stamp: 'bf 5/4/2012 17:11'!
unload
	| previousVersions |
	self isOverrideMethod ifTrue: [
		previousVersions := self scanForPreviousVersions].
	previousVersions isEmptyOrNil 
		ifTrue: [self actualClass ifNotNil: [:class |
			self removeSelector: selector fromClass: class]]
		ifFalse: [
			"remove our override from history, even if buried below other overrides"
			previousVersions reverseDo: [:version | version fileIn]] ! !

!MCMethodDefinition methodsFor: 'accessing' stamp: 'cmm 3/8/2011 20:28'!
workingCopy
	"Answer the working copy of which this object is defined."
	^ self asMethodReference workingCopy! !

MCDefinition subclass: #MCOrganizationDefinition
	instanceVariableNames: 'categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCOrganizationDefinition class methodsFor: 'as yet unclassified' stamp: ''!
categories: t1 
	^ self
		instanceLike: (self new categories: t1)! !

!MCOrganizationDefinition methodsFor: 'testing' stamp: 'ab 7/19/2003 18:25'!
= aDefinition
	^ (super = aDefinition)
		and: [categories = aDefinition categories]! !

!MCOrganizationDefinition methodsFor: 'actions' stamp: 'ab 7/18/2003 21:47'!
accept: aVisitor
	^ aVisitor visitOrganizationDefinition: self! !

!MCOrganizationDefinition methodsFor: 'accessing' stamp: 'ab 5/24/2003 13:51'!
categories
	^ categories! !

!MCOrganizationDefinition methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
categories: anArray
	categories := anArray! !

!MCOrganizationDefinition methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
commonPrefix
	| stream |
	categories isEmpty ifTrue: [^ ''].
	
	stream := String new writeStream.
	categories first withIndexDo:
		[:c :i|
		categories do:
			[:ea |
			(ea at: i ifAbsent: []) = c ifFalse: [^ stream contents]].
		stream nextPut: c].
	^ stream contents! !

!MCOrganizationDefinition methodsFor: 'accessing' stamp: 'bf 6/21/2011 13:52'!
description
	^ Array with: #organization
! !

!MCOrganizationDefinition methodsFor: 'actions' stamp: 'cmm 6/8/2011 13:59'!
handlePackageRename: oldPackageName to: newPackageName 
	categories do:
		[ : each | (each beginsWith: newPackageName) ifFalse:
			[ | newCategoryName |
			newCategoryName := self
				newCategoryNameFor: each
				givenRenameFrom: oldPackageName
				to: newPackageName.
			(SystemOrganizer default categories includes: newCategoryName) ifTrue: [ SystemOrganizer default removeCategory: newCategoryName ].
			SystemOrganizer default
				renameCategory: each
				toBe: newCategoryName ] ]! !

!MCOrganizationDefinition methodsFor: 'testing' stamp: 'cwp 7/11/2003 01:33'!
isOrganizationDefinition
	^ true! !

!MCOrganizationDefinition methodsFor: 'actions' stamp: 'avi 2/22/2004 13:46'!
postloadOver: oldDefinition
	SystemOrganization categories:
		(self
			reorderCategories: SystemOrganization categories
			original: (oldDefinition ifNil: [#()] ifNotNil: [oldDefinition categories]))! !

!MCOrganizationDefinition methodsFor: 'actions' stamp: 'bf 4/11/2012 10:09'!
reorderCategories: allCategories original: oldCategories
	| first locallyAddedCategories |
	first := allCategories detect: [:ea | categories includes: ea]
		ifNone: [^ allCategories, categories].
	locallyAddedCategories := (oldCategories copyWithoutAll: categories) select: [:cat |
		(SystemOrganization listAtCategoryNamed: cat) notEmpty].
	^ 	((allCategories copyUpTo: first) copyWithoutAll: oldCategories, categories),
		categories,
		locallyAddedCategories,
		((allCategories copyAfter: first) copyWithoutAll: oldCategories, categories)
! !

!MCOrganizationDefinition methodsFor: 'accessing' stamp: 'ab 7/19/2003 18:01'!
sortKey
	^ '<organization>'! !

!MCOrganizationDefinition methodsFor: 'accessing' stamp: 'ab 7/22/2003 01:14'!
source
	^ String streamContents:
		[:s |
		categories do: [:ea | s nextPutAll: ea] separatedBy: [s cr]]! !

!MCOrganizationDefinition methodsFor: 'accessing' stamp: 'ab 5/24/2003 13:55'!
summary
	^ categories asArray printString! !

!MCOrganizationDefinition methodsFor: 'actions' stamp: 'bf 4/11/2012 11:00'!
unload
	| empty |
	empty := categories select: [:ea |
		(SystemOrganization listAtCategoryNamed: ea) isEmpty].
	SystemOrganization categories:
		(SystemOrganization categories copyWithoutAll: empty)! !

MCDefinition subclass: #MCScriptDefinition
	instanceVariableNames: 'script packageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

MCScriptDefinition subclass: #MCPostscriptDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCPostscriptDefinition class methodsFor: 'as yet unclassified' stamp: ''!
scriptSelector
	^ #postscript! !

!MCPostscriptDefinition methodsFor: 'as yet unclassified' stamp: ''!
postload
	self evaluate! !

!MCPostscriptDefinition methodsFor: 'as yet unclassified' stamp: ''!
sortKey
	^ 'zzz'! !

MCScriptDefinition subclass: #MCPreambleDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCPreambleDefinition class methodsFor: 'as yet unclassified' stamp: ''!
scriptSelector
	^ #preamble! !

!MCPreambleDefinition methodsFor: 'as yet unclassified' stamp: ''!
load
	super load.
	self evaluate! !

MCScriptDefinition subclass: #MCRemovalPostscriptDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCRemovalPostscriptDefinition class methodsFor: 'as yet unclassified' stamp: ''!
scriptSelector
	^ #postscriptOfRemoval! !

!MCRemovalPostscriptDefinition methodsFor: 'as yet unclassified' stamp: ''!
unload
	super unload.
	self evaluate! !

MCScriptDefinition subclass: #MCRemovalPreambleDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCRemovalPreambleDefinition class methodsFor: 'as yet unclassified' stamp: ''!
scriptSelector
	^ #preambleOfRemoval! !

!MCRemovalPreambleDefinition methodsFor: 'as yet unclassified' stamp: ''!
sortKey
	^ 'zzz'! !

!MCRemovalPreambleDefinition methodsFor: 'as yet unclassified' stamp: ''!
unload
	super unload.
	self evaluate! !

!MCScriptDefinition class methodsFor: 'as yet unclassified' stamp: ''!
from: t1 
	^ self script: (t1 perform: self scriptSelector) contents asString packageName: t1 name! !

!MCScriptDefinition class methodsFor: 'as yet unclassified' stamp: ''!
script: t1 packageName: t2 
	^ self
		instanceLike: (self new initializeWithScript: t1 packageName: t2)! !

!MCScriptDefinition class methodsFor: 'as yet unclassified' stamp: ''!
scriptSelector
	self subclassResponsibility! !

!MCScriptDefinition class methodsFor: 'as yet unclassified' stamp: ''!
scriptSelector: t1 script: t2 packageName: t3 
	^ (self subclassForScriptSelector: t1)
		script: t2
		packageName: t3! !

!MCScriptDefinition class methodsFor: 'as yet unclassified' stamp: ''!
subclassForScriptSelector: t1 
	^ self allSubclasses
		detect: [:t2 | t2 scriptSelector = t1]! !

!MCScriptDefinition methodsFor: 'comparing' stamp: ''!
= t1 
	^ super = t1
		and: [script = t1 script]! !

!MCScriptDefinition methodsFor: 'visiting' stamp: ''!
accept: t1 
	t1 visitScriptDefinition: self! !

!MCScriptDefinition methodsFor: 'accessing' stamp: ''!
description
	^ Array with: packageName with: self scriptSelector! !

!MCScriptDefinition methodsFor: 'installing' stamp: ''!
evaluate
	Compiler evaluate: script! !

!MCScriptDefinition methodsFor: 'initializing' stamp: ''!
initializeWithScript: t1 packageName: t2 
	script := t1.
	packageName := t2! !

!MCScriptDefinition methodsFor: 'installing' stamp: ''!
installScript
	self installScript: script! !

!MCScriptDefinition methodsFor: 'installing' stamp: ''!
installScript: t1 
	| t2 t3 |
	t2 := (self scriptSelector , ':') asSymbol.
	t3 := self packageInfo.
	(t3 respondsTo: t2)
		ifTrue: [t3 perform: t2 with: t1]! !

!MCScriptDefinition methodsFor: 'testing' stamp: ''!
isScriptDefinition
	^ true! !

!MCScriptDefinition methodsFor: 'installing' stamp: ''!
load
	self installScript! !

!MCScriptDefinition methodsFor: 'accessing' stamp: ''!
packageInfo
	^ PackageInfo named: packageName! !

!MCScriptDefinition methodsFor: 'accessing' stamp: ''!
packageName
	^ packageName! !

!MCScriptDefinition methodsFor: 'accessing' stamp: ''!
script
	^ script! !

!MCScriptDefinition methodsFor: 'accessing' stamp: ''!
scriptSelector
	^ self class scriptSelector! !

!MCScriptDefinition methodsFor: 'accessing' stamp: ''!
sortKey
	^ '!!' , self scriptSelector! !

!MCScriptDefinition methodsFor: 'accessing' stamp: ''!
source
	^ script! !

!MCScriptDefinition methodsFor: 'accessing' stamp: 'bf 7/31/2012 11:43'!
summary
	^ packageName, ' package ', self scriptSelector! !

!MCScriptDefinition methodsFor: 'installing' stamp: ''!
unload
	self installScript: nil! !

Object subclass: #MCDefinitionIndex
	instanceVariableNames: 'definitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCDefinitionIndex class methodsFor: 'as yet unclassified' stamp: ''!
definitions: t1 
	^ self new addAll: t1! !

!MCDefinitionIndex class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: ''!
add: t1 
	^ definitions at: t1 description put: t1! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: ''!
addAll: t1 
	t1
		do: [:t2 | self add: t2]! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: ''!
definitionLike: t1 ifPresent: t2 ifAbsent: t3 
	| t4 |
	t4 := definitions
				at: t1 description
				ifAbsent: [].
	^ t4
		ifNil: t3
		ifNotNil: [t2 value: t4]! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: ''!
definitions
	^ definitions values! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: ''!
initialize
	definitions := Dictionary new! !

!MCDefinitionIndex methodsFor: 'as yet unclassified' stamp: ''!
remove: t1 
	definitions
		removeKey: t1 description
		ifAbsent: []! !

Object subclass: #MCDependencySorter
	instanceVariableNames: 'required provided orderedItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Loading'!

!MCDependencySorter class methodsFor: 'as yet unclassified' stamp: ''!
items: t1 
	^ self new addAll: t1! !

!MCDependencySorter class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCDependencySorter class methodsFor: 'as yet unclassified' stamp: ''!
sortItems: t1 
	| t2 |
	t2 := self items: t1.
	t2 externalRequirements
		do: [:t3 | t2 addProvision: t3].
	^ t2 orderedItems! !

!MCDependencySorter methodsFor: 'building' stamp: ''!
add: t1 
	| t2 |
	t2 := self unresolvedRequirementsFor: t1.
	t2 isEmpty
		ifTrue: [self addToOrder: t1]
		ifFalse: [self addRequirements: t2 for: t1].
	^ t1! !

!MCDependencySorter methodsFor: 'building' stamp: ''!
addAll: t1 
	t1 asArray sort
		do: [:t2 | self add: t2]! !

!MCDependencySorter methodsFor: 'building' stamp: ''!
addExternalProvisions: t1 
	(t1 intersection: self externalRequirements)
		do: [:t2 | self addProvision: t2]! !

!MCDependencySorter methodsFor: 'private' stamp: ''!
addProvision: t1 
	| t2 |
	provided add: t1.
	t2 := required
				removeKey: t1
				ifAbsent: [#()].
	self addAll: t2! !

!MCDependencySorter methodsFor: 'private' stamp: ''!
addRequirement: t1 for: t2 
	(self itemsRequiring: t1)
		add: t2! !

!MCDependencySorter methodsFor: 'private' stamp: ''!
addRequirements: t1 for: t2 
	t1
		do: [:t3 | self addRequirement: t3 for: t2]! !

!MCDependencySorter methodsFor: 'private' stamp: ''!
addToOrder: t1 
	orderedItems add: t1.
	t1 provisions
		do: [:t2 | self addProvision: t2]! !

!MCDependencySorter methodsFor: 'accessing' stamp: ''!
externalRequirements
	| t1 t2 |
	t1 := self itemsWithMissingRequirements.
	t2 := (t1
				gather: [:t3 | t3 provisions]) asSet.
	^ required keys
		reject: [:t3 | t2 includes: t3]! !

!MCDependencySorter methodsFor: 'initialize-release' stamp: ''!
initialize
	provided := Set new.
	required := Dictionary new.
	orderedItems := OrderedCollection new! !

!MCDependencySorter methodsFor: 'private' stamp: ''!
itemsRequiring: t1 
	^ required
		at: t1
		ifAbsentPut: [Set new]! !

!MCDependencySorter methodsFor: 'accessing' stamp: ''!
itemsWithMissingRequirements
	| t1 |
	t1 := Set new.
	required
		do: [:t2 | t1 addAll: t2].
	^ t1! !

!MCDependencySorter methodsFor: 'sorting' stamp: ''!
orderedItems
	^ orderedItems! !

!MCDependencySorter methodsFor: 'private' stamp: ''!
unresolvedRequirementsFor: t1 
	^ t1 requirements difference: provided! !

Object subclass: #MCDoItParser
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Chunk Format'!

MCDoItParser subclass: #MCClassTraitParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCClassTraitParser class methodsFor: 'as yet unclassified' stamp: ''!
pattern
	^ '*classTrait*uses:*'! !

!MCClassTraitParser methodsFor: 'as yet unclassified' stamp: ''!
addDefinitionsTo: t1 
	| t2 t3 t4 |
	t2 := Scanner new scanTokens: source.
	t4 := ((ReadStream on: source) match: 'uses:';
				 upToEnd) withBlanksTrimmed.
	t3 := MCClassTraitDefinition
				baseTraitName: (t2 at: 1)
				classTraitComposition: t4.
	t1 add: t3! !

!MCDoItParser class methodsFor: 'as yet unclassified' stamp: ''!
concreteSubclasses
	^ self allSubclasses
		reject: [:t1 | t1 isAbstract]! !

!MCDoItParser class methodsFor: 'as yet unclassified' stamp: ''!
forDoit: t1 
	^ (self subclassForDoit: t1)
		ifNotNil: [:t2 | t2 new source: t1]! !

!MCDoItParser class methodsFor: 'as yet unclassified' stamp: ''!
isAbstract
	^ self pattern isNil! !

!MCDoItParser class methodsFor: 'as yet unclassified' stamp: ''!
pattern
	^ nil! !

!MCDoItParser class methodsFor: 'as yet unclassified' stamp: ''!
subclassForDoit: t1 
	^ self concreteSubclasses
		detect: [:t2 | t2 pattern match: t1]
		ifNone: []! !

!MCDoItParser methodsFor: 'as yet unclassified' stamp: ''!
addDefinitionsTo: t1 
	self subclassResponsibility! !

!MCDoItParser methodsFor: 'as yet unclassified' stamp: ''!
source
	^ source! !

!MCDoItParser methodsFor: 'as yet unclassified' stamp: ''!
source: t1 
	source := t1! !

MCDoItParser subclass: #MCScriptParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Chunk Format'!

!MCScriptParser class methodsFor: 'as yet unclassified' stamp: ''!
pattern
	^ '(PackageInfo named: *'! !

!MCScriptParser methodsFor: 'as yet unclassified' stamp: ''!
addDefinitionsTo: t1 
	| t2 t3 |
	t2 := Scanner new scanTokens: source.
	t3 := MCScriptDefinition
				scriptSelector: t2 second allButLast
				script: t2 third
				packageName: t2 first third.
	t1 add: t3! !

MCDoItParser subclass: #MCSystemCategoryParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Chunk Format'!

!MCSystemCategoryParser class methodsFor: 'as yet unclassified' stamp: ''!
pattern
	^ 'SystemOrganization*'! !

!MCSystemCategoryParser methodsFor: 'as yet unclassified' stamp: ''!
addDefinitionsTo: t1 
	| t2 |
	t2 := t1
				detect: [:t3 | t3 isOrganizationDefinition]
				ifNone: [t1
						add: (MCOrganizationDefinition categories: #())].
	t2
		categories: (t2 categories copyWith: self category)! !

!MCSystemCategoryParser methodsFor: 'as yet unclassified' stamp: ''!
category
	| t1 |
	t1 := Scanner new scanTokens: source.
	t1 size = 3
		ifFalse: [self error: 'Unrecognized category definition'].
	^ t1 at: 3! !

MCDoItParser subclass: #MCTraitParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCTraitParser class methodsFor: 'as yet unclassified' stamp: ''!
pattern
	^ 'Trait named:*'! !

!MCTraitParser methodsFor: 'as yet unclassified' stamp: ''!
addDefinitionsTo: t1 
	| t2 t3 t4 |
	t2 := Scanner new scanTokens: source.
	t4 := ((ReadStream on: source) match: 'uses:';
				 upToAll: 'category:') withBlanksTrimmed.
	t3 := MCTraitDefinition
				name: (t2 at: 3)
				traitComposition: t4
				category: t2 last
				comment: ''
				commentStamp: ''.
	t1 add: t3! !

Object subclass: #MCFrontier
	instanceVariableNames: 'frontier bag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCFrontier class methodsFor: 'instance creation' stamp: ''!
frontierOn: t1 
	^ self
		frontierOnAll: (Array with: t1)! !

!MCFrontier class methodsFor: 'instance creation' stamp: ''!
frontierOn: t1 and: t2 
	^ self
		frontierOnAll: (Array with: t1 with: t2)! !

!MCFrontier class methodsFor: 'instance creation' stamp: ''!
frontierOnAll: t1 
	| t2 t3 |
	t2 := Bag new.
	t3 := (t1
				gather: [:t4 | t4 withBreadthFirstAncestors]) asSet.
	t3
		do: [:t4 | t2 addAll: t4 ancestors].
	^ self new frontier: t1 bag: t2! !

!MCFrontier methodsFor: 'accessing' stamp: 'bf 12/8/2011 19:35'!
frontier
	^frontier asArray	"not safe to hand out the frontier itself"! !

!MCFrontier methodsFor: 'initialization' stamp: ''!
frontier: t1 bag: t2 
	frontier := t1 asOrderedCollection.
	bag := t2! !

!MCFrontier methodsFor: 'advancing' stamp: ''!
remove: t1 
	frontier remove: t1.
	t1 ancestors
		do: [:t2 | 
			bag remove: t2.
			(bag occurrencesOf: t2)
					= 0
				ifTrue: [frontier add: t2]].
	^ t1! !

!MCFrontier methodsFor: 'advancing' stamp: ''!
removeAll: t1 
	t1
		do: [:t2 | self remove: t2]! !

Object subclass: #MCMenuSpec
	instanceVariableNames: 'entry target selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCMenuSpec commentStamp: 'tfel 6/12/2010 14:57' prior: 0!
A MCMenuSpec holds information to add menu entries to the monticello browser menus from external classes.
Required is the entry string (#entry), the call target and the selector be called.
An external class may use the MCWorkingCopyBrowser class>>addMenuSpec: method to add it's own menu entry to the monticello browser context menu.

Note that MCMenuSpecs are compared via their menu entry string and if multiple MCMenuSpecs are added to the MCWorkingCopyBrowser, the last one takes precedence.!

!MCMenuSpec methodsFor: 'comparing' stamp: 'tfel 6/12/2010 11:43'!
= aMCMenuSpec

	^ self class == aMCMenuSpec class and: [self entry = aMCMenuSpec entry].! !

!MCMenuSpec methodsFor: 'accessing' stamp: 'tfel 6/12/2010 11:38'!
entry

	^entry! !

!MCMenuSpec methodsFor: 'accessing' stamp: 'tfel 6/12/2010 11:38'!
entry: anObject

	entry := anObject! !

!MCMenuSpec methodsFor: 'comparing' stamp: 'tfel 6/12/2010 11:42'!
hash

	^ self entry hash! !

!MCMenuSpec methodsFor: 'accessing' stamp: 'tfel 6/12/2010 11:38'!
selector

	^selector! !

!MCMenuSpec methodsFor: 'accessing' stamp: 'tfel 6/12/2010 11:38'!
selector: anObject

	selector := anObject! !

!MCMenuSpec methodsFor: 'accessing' stamp: 'tfel 6/12/2010 11:38'!
target

	^target! !

!MCMenuSpec methodsFor: 'accessing' stamp: 'tfel 6/12/2010 11:38'!
target: anObject

	target := anObject! !

Object subclass: #MCMergeRecord
	instanceVariableNames: 'version packageSnapshot ancestorInfo ancestor ancestorSnapshot imagePatch mergePatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCMergeRecord class methodsFor: 'as yet unclassified' stamp: ''!
version: t1 
	^ self basicNew initializeWithVersion: t1! !

!MCMergeRecord methodsFor: 'as yet unclassified' stamp: ''!
ancestorInfo
	^ ancestorInfo
		ifNil: [ancestorInfo := version info commonAncestorWith: version workingCopy ancestry]! !

!MCMergeRecord methodsFor: 'as yet unclassified' stamp: ''!
ancestorSnapshot
	^ ancestorSnapshot
		ifNil: [ancestorSnapshot := version workingCopy findSnapshotWithVersionInfo: self ancestorInfo]! !

!MCMergeRecord methodsFor: 'as yet unclassified' stamp: ''!
imageIsClean
	| t1 |
	t1 := version workingCopy ancestors.
	^ t1 size = 1
		and: [t1 first = self ancestorInfo
				and: [self imagePatch isEmpty]]! !

!MCMergeRecord methodsFor: 'as yet unclassified' stamp: ''!
imagePatch
	^ imagePatch
		ifNil: [imagePatch := self packageSnapshot patchRelativeToBase: self ancestorSnapshot]! !

!MCMergeRecord methodsFor: 'as yet unclassified' stamp: ''!
initializeWithVersion: t1 
	version := t1! !

!MCMergeRecord methodsFor: 'as yet unclassified' stamp: ''!
isAncestorMerge
	^ version workingCopy ancestry hasAncestor: version info! !

!MCMergeRecord methodsFor: 'as yet unclassified' stamp: ''!
mergePatch
	^ mergePatch
		ifNil: [mergePatch := version snapshot patchRelativeToBase: self ancestorSnapshot]! !

!MCMergeRecord methodsFor: 'as yet unclassified' stamp: ''!
packageSnapshot
	^ packageSnapshot
		ifNil: [packageSnapshot := version package snapshot]! !

!MCMergeRecord methodsFor: 'as yet unclassified' stamp: ''!
updateWorkingCopy
	self isAncestorMerge
		ifFalse: [self imageIsClean
				ifTrue: [version workingCopy loaded: version]
				ifFalse: [version workingCopy merged: version]]! !

!MCMergeRecord methodsFor: 'as yet unclassified' stamp: ''!
version
	^ version! !

Object subclass: #MCMerger
	instanceVariableNames: 'conflicts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Merging'!

!MCMerger methodsFor: 'as yet unclassified' stamp: ''!
addConflictWithOperation: t1 
	self conflicts
		add: (MCConflict operation: t1)! !

!MCMerger methodsFor: 'as yet unclassified' stamp: ''!
applyTo: t1 
	self isMerged
		ifFalse: [self error: 'You must resolve all the conflicts first'].
	conflicts
		do: [:t2 | t2 applyTo: t1]! !

!MCMerger methodsFor: 'as yet unclassified' stamp: ''!
conflicts
	^ conflicts
		ifNil: [conflicts := OrderedCollection new]! !

!MCMerger methodsFor: 'as yet unclassified' stamp: ''!
isMerged
	^ self conflicts
		allSatisfy: [:t1 | t1 isResolved]! !

!MCMerger methodsFor: 'as yet unclassified' stamp: ''!
load
	| t1 |
	t1 := MCPackageLoader new.
	t1 provisions addAll: self provisions.
	self applyTo: t1.
	t1 load! !

!MCMerger methodsFor: 'as yet unclassified' stamp: ''!
loadWithNameLike: t1 
	| t2 |
	t2 := MCPackageLoader new.
	t2 provisions addAll: self provisions.
	self applyTo: t2.
	t2 loadWithNameLike: t1! !

!MCMerger methodsFor: 'as yet unclassified' stamp: ''!
mergedSnapshot
	^ MCPatcher apply: self to: self baseSnapshot! !

!MCMerger methodsFor: 'as yet unclassified' stamp: ''!
operations
	^ #()! !

!MCMerger methodsFor: 'as yet unclassified' stamp: ''!
provisions
	^ #()! !

MCMerger subclass: #MCThreeWayMerger
	instanceVariableNames: 'index operations provisions redundantAdds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Merging'!

!MCThreeWayMerger class methodsFor: 'as yet unclassified' stamp: ''!
base: t1 patch: t2 
	t2 isEmpty
		ifTrue: [MCNoChangesException signal].
	^ self new addBaseSnapshot: t1;
		 applyPatch: t2;
		 yourself! !

!MCThreeWayMerger class methodsFor: 'as yet unclassified' stamp: ''!
base: t1 target: t2 ancestor: t3 
	^ self
		base: t1
		patch: (t2 patchRelativeToBase: t3)! !

!MCThreeWayMerger class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
addBaseSnapshot: t1 
	t1 definitions
		do: [:t2 | 
			index add: t2.
			provisions addAll: t2 provisions]! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
addDefinition: t1 
	index
		definitionLike: t1
		ifPresent: [:t2 | 
			(self removalForDefinition: t1)
				ifNotNil: [:t3 | 
					self
						addOperation: (MCModification of: t2 to: t1).
					self removeOperation: t3.
					^ self].
			t2 = t1
				ifTrue: [self redundantAdds add: t1]
				ifFalse: [self
						addConflictWithOperation: (MCModification of: t2 to: t1)]]
		ifAbsent: [self
				addOperation: (MCAddition of: t1)]! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
addOperation: t1 
	self operations add: t1! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
applyPatch: t1 
	t1 applyTo: self! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
applyTo: t1 
	super applyTo: t1.
	self operations
		do: [:t2 | t2 applyTo: t1]! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
baseSnapshot
	^ MCSnapshot fromDefinitions: index definitions! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
initialize
	index := MCDefinitionIndex new.
	provisions := Set new! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
modificationConflictForDefinition: t1 
	^ conflicts
		ifNotNil: [conflicts
				detect: [:t2 | (t2 definition isRevisionOf: t1)
						and: [t2 operation isModification]]
				ifNone: []]! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
modifyDefinition: t1 to: t2 
	index
		definitionLike: t1
		ifPresent: [:t3 | t3 = t1
				ifTrue: [self
						addOperation: (MCModification of: t1 to: t2)]
				ifFalse: [t3 = t2
						ifFalse: [self
								addConflictWithOperation: (MCModification of: t3 to: t2)]]]
		ifAbsent: [self
				addConflictWithOperation: (MCAddition of: t2)]! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
operations
	^ operations
		ifNil: [operations := OrderedCollection new]! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
provisions
	^ provisions! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
redundantAdds
	^ redundantAdds
		ifNil: [redundantAdds := Set new]! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
removalForDefinition: t1 
	^ operations
		ifNotNil: [operations
				detect: [:t2 | (t2 definition isRevisionOf: t1)
						and: [t2 isRemoval]]
				ifNone: []]! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
removeConflict: t1 
	conflicts remove: t1! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
removeDefinition: t1 
	index
		definitionLike: t1
		ifPresent: [:t2 | t2 = t1
				ifTrue: [(self modificationConflictForDefinition: t1)
						ifNotNil: [:t3 | 
							self addOperation: t3 operation.
							self removeConflict: t3.
							^ self].
					(self redundantAdds includes: t1)
						ifFalse: [self
								addOperation: (MCRemoval of: t1)]]
				ifFalse: [self
						addConflictWithOperation: (MCRemoval of: t2)]]
		ifAbsent: []! !

!MCThreeWayMerger methodsFor: 'as yet unclassified' stamp: ''!
removeOperation: t1 
	operations remove: t1! !

Object subclass: #MCPackage
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Base'!

!MCPackage class methodsFor: 'as yet unclassified' stamp: ''!
named: t1 
	^ self new name: t1! !

!MCPackage methodsFor: 'testing' stamp: 'ar 4/26/2005 21:57'!
= other
	^ other species = self species and: [other name sameAs: name]! !

!MCPackage methodsFor: 'testing' stamp: 'bf 4/19/2005 16:26'!
hasWorkingCopy
	^ MCWorkingCopy registry includesKey: self! !

!MCPackage methodsFor: 'testing' stamp: 'ar 4/26/2005 21:57'!
hash
	^ name asLowercase hash! !

!MCPackage methodsFor: 'accessing' stamp: 'ab 7/7/2003 00:57'!
name
	^ name! !

!MCPackage methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
name: aString
	name := aString! !

!MCPackage methodsFor: 'accessing' stamp: 'ab 7/7/2003 13:33'!
packageInfo
	^ PackageInfo named: name! !

!MCPackage methodsFor: 'printing' stamp: 'nk 7/28/2003 13:30'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: name;
		nextPut: $)! !

!MCPackage methodsFor: 'input/output' stamp: 'ul 3/17/2011 01:29'!
snapshot
	| packageInfo definitions categories |
	packageInfo := self packageInfo.
	definitions := OrderedCollection new.
	categories := packageInfo systemCategories.
	categories isEmpty ifFalse: [ definitions add: (MCOrganizationDefinition categories: categories) ].
	CurrentReadOnlySourceFiles cacheDuring: [
		packageInfo methods do: [:ea | definitions add: ea asMethodDefinition] displayingProgress: 'Snapshotting methods...'.
		(packageInfo respondsTo: #overriddenMethods) ifTrue:
			[packageInfo overriddenMethods
				do: [:ea | definitions add:
						(packageInfo changeRecordForOverriddenMethod: ea) asMethodDefinition]
				displayingProgress: 'Searching for overrides...'].
		packageInfo classes do: [:ea | definitions addAll: ea classDefinitions] displayingProgress: 'Snapshotting classes...' ].
	(packageInfo respondsTo: #hasPreamble) ifTrue: [
		packageInfo hasPreamble ifTrue: [definitions add: (MCPreambleDefinition from: packageInfo)].
		packageInfo hasPostscript ifTrue: [definitions add: (MCPostscriptDefinition from: packageInfo)].
		packageInfo hasPreambleOfRemoval ifTrue: [definitions add: (MCRemovalPreambleDefinition from: packageInfo)].
		packageInfo hasPostscriptOfRemoval ifTrue: [definitions add: (MCRemovalPostscriptDefinition from: packageInfo)]]. 
	^ MCSnapshot fromDefinitions: definitions
! !

!MCPackage methodsFor: 'input/output' stamp: 'ab 7/10/2003 01:13'!
storeOn: aStream
	aStream
		nextPutAll: 'MCPackage';
		space; nextPutAll: 'named: '; store: name.! !

!MCPackage methodsFor: 'input/output' stamp: 'cwp 11/13/2003 13:32'!
unload
	^ self workingCopy unload! !

!MCPackage methodsFor: 'accessing' stamp: 'cwp 11/13/2003 13:33'!
workingCopy
	^ MCWorkingCopy forPackage: self.! !

Object subclass: #MCPackageCache
	instanceVariableNames: 'sorter fileNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCPackageCache class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCPackageCache methodsFor: 'as yet unclassified' stamp: ''!
initialize
	sorter := MCVersionSorter new.
	fileNames := Dictionary new! !

!MCPackageCache methodsFor: 'as yet unclassified' stamp: ''!
recordVersionInfo: t1 forFileNamed: t2 
	Transcript cr; show: t2.
	fileNames at: t1 put: t2.
	sorter addVersionInfo: t1! !

!MCPackageCache methodsFor: 'as yet unclassified' stamp: ''!
versionInfos
	^ sorter sortedVersionInfos! !

Object subclass: #MCPackageLoader
	instanceVariableNames: 'requirements unloadableDefinitions obsoletions additions removals errorDefinitions provisions methodAdditions preamble'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Loading'!

!MCPackageLoader commentStamp: 'rej 2/26/2007 07:35' prior: 0!
A MCPackageLoader is responsible for loading packages.  It gets used by VersionLoader, so it is eventually responsible for loading everything.

Instance Variables
	additions:		<Definitions>  Definitions that need to be added
	errorDefinitions:		<Object>
	obsoletions:		<Object>
	provisions:		<Object>
	removals:		<Object>
	requirements:		<Object>
	unloadableDefinitions:		<Object>
	methodAdditions  <MethodAdditions> MethodDefinitions corresponding to the Definitions in "additions" that have been added so far.

additions
	- xxxxx

errorDefinitions
	- xxxxx

obsoletions
	- xxxxx

provisions
	- xxxxx

removals
	- xxxxx

requirements
	- xxxxx

unloadableDefinitions
	- xxxxx
!

!MCPackageLoader class methodsFor: 'as yet unclassified' stamp: ''!
installSnapshot: t1 
	self new installSnapshot: t1;
		 load! !

!MCPackageLoader class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCPackageLoader class methodsFor: 'as yet unclassified' stamp: ''!
unloadPackage: t1 
	self new unloadPackage: t1;
		 loadWithNameLike: t1 name , '-unload'! !

!MCPackageLoader class methodsFor: 'as yet unclassified' stamp: ''!
updatePackage: t1 withSnapshot: t2 
	self new updatePackage: t1 withSnapshot: t2;
		 load! !

!MCPackageLoader methodsFor: 'patch ops' stamp: ''!
addDefinition: t1 
	additions add: t1! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
analyze
	| t1 |
	t1 := self sorterForItems: additions.
	additions := t1 orderedItems.
	requirements := t1 externalRequirements.
	unloadableDefinitions := t1 itemsWithMissingRequirements asSortedCollection.
	t1 := self sorterForItems: removals.
	removals := t1 orderedItems reversed! !

!MCPackageLoader methodsFor: 'public' stamp: 'bf 5/11/2012 13:23'!
appendToPreamble: aString
	preamble
		ifNil: [preamble := aString]
		ifNotNil: [preamble := preamble, aString].
! !

!MCPackageLoader methodsFor: 'private' stamp: 'bf 5/11/2012 13:22'!
basicLoad
	"Load the contents of some package. This is the core loading method
	in Monticello. Be wary about modifying it unless you understand the details
	and dependencies of the various entities being modified."
	| pkgName |
	errorDefinitions := OrderedCollection new.
	"Obviously this isn't the package name but we don't have anything else
	to use here. ChangeSet current name will generally work since a CS is 
	usually installed prior to installation."
	pkgName := ChangeSet current name.
	preamble ifNotNil: [ChangeSet current preambleString: (self preambleAsCommentNamed: pkgName)].

	[CurrentReadOnlySourceFiles cacheDuring: [[
	"Pass 1: Load everything but the methods,  which are collected in methodAdditions."
	additions do: [:ea | 
		ea isMethodDefinition 
			ifTrue:[methodAdditions add: ea asMethodAddition]
			ifFalse:[[ea load]on: Error do: [errorDefinitions add: ea]].
	] displayingProgress: 'Reshaping ', pkgName.

	"Try again any delayed definitions"
	self shouldWarnAboutErrors ifTrue: [self warnAboutErrors].
	errorDefinitions do: [:ea | ea load] 
		displayingProgress: 'Reloading ', pkgName.

	"Pass 2: We compile new / changed methods"
	methodAdditions do:[:ea| ea createCompiledMethod] 
		displayingProgress: 'Compiling ', pkgName.

	'Installing ', pkgName displayProgressFrom: 0 to: 2 during:[:bar|
		"There is no progress *during* installation since a progress bar update
		will redraw the world and potentially call methods that we're just trying to install."
		bar value: 1.

		"Pass 3: Install the new / changed methods
		(this is a separate pass to allow compiler changes to be loaded)"
		methodAdditions do:[:ea| ea installMethod].

		"Pass 4: Remove the obsolete methods"
		removals do:[:ea| ea unload].
	].

	"Finally, notify observers for the method additions"
	methodAdditions do: [:each | each notifyObservers] 
		"the message is fake but actually telling people how much time we spend
		in the notifications is embarrassing so lie instead"
		displayingProgress: 'Installing ', pkgName.

	additions do: [:ea | ea postloadOver: (self obsoletionFor: ea)] 
		displayingProgress: 'Initializing ', pkgName.

	] on: InMidstOfFileinNotification do: [:n | n resume: true]
	]] ensure: [self flushChangesFile]! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
dependencyWarning
	^ String
		streamContents: [:t1 | 
			t1 nextPutAll: 'This package depends on the following classes:';
				 cr.
			requirements
				do: [:t2 | t1 space; space; nextPutAll: t2; cr].
			t1 nextPutAll: 'You must resolve these dependencies before you will be able to load these definitions: ';
				 cr.
			unloadableDefinitions
				do: [:t2 | t1 space; space; nextPutAll: t2 summary; cr]]! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
errorDefinitionWarning
	^ String
		streamContents: [:t1 | 
			t1 nextPutAll: 'The following definitions had errors while loading.  Press Proceed to try to load them again (they may work on a second pass):';
				 cr.
			errorDefinitions
				do: [:t2 | t1 space; space; nextPutAll: t2 summary; cr]]! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
flushChangesFile
	(SourceFiles at: 2) flush! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
initialize
	additions := OrderedCollection new.
	removals := OrderedCollection new.
	obsoletions := Dictionary new.
	methodAdditions := OrderedCollection new! !

!MCPackageLoader methodsFor: 'public' stamp: ''!
installSnapshot: t1 
	| t2 |
	t2 := t1 patchRelativeToBase: MCSnapshot empty.
	t2 applyTo: self! !

!MCPackageLoader methodsFor: 'public' stamp: ''!
load
	self analyze.
	unloadableDefinitions isEmpty
		ifFalse: [self warnAboutDependencies].
	self
		useNewChangeSetDuring: [self basicLoad]! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
loadClassDefinition: t1 
	[t1 isClassDefinition
		ifTrue: [t1 load]]
		on: Error
		do: [errorDefinitions add: t1]! !

!MCPackageLoader methodsFor: 'public' stamp: ''!
loadWithName: t1 
	self analyze.
	unloadableDefinitions isEmpty
		ifFalse: [self warnAboutDependencies].
	self
		useChangeSetNamed: t1
		during: [self basicLoad]! !

!MCPackageLoader methodsFor: 'public' stamp: ''!
loadWithNameLike: t1 
	self analyze.
	unloadableDefinitions isEmpty
		ifFalse: [self warnAboutDependencies].
	self
		useNewChangeSetNamedLike: t1
		during: [self basicLoad]! !

!MCPackageLoader methodsFor: 'patch ops' stamp: ''!
modifyDefinition: t1 to: t2 
	self addDefinition: t2.
	obsoletions at: t2 put: t1! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
obsoletionFor: t1 
	^ obsoletions
		at: t1
		ifAbsent: []! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
orderDefinitionsForLoading: t1 
	^ (self sorterForItems: t1) orderedItems! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
orderedAdditions
	^ additions! !

!MCPackageLoader methodsFor: 'private' stamp: 'bf 5/11/2012 13:22'!
preambleAsCommentNamed: pkgName
	^
'"Changeset:	{1}
Date:	{2}
Author:	(generated by MC)

{3}
"' format: {pkgName. Date today. preamble copyReplaceAll: '"' with: ''''''}! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
provisions
	^ provisions
		ifNil: [provisions := Set withAll: Smalltalk globals keys]! !

!MCPackageLoader methodsFor: 'patch ops' stamp: ''!
removeDefinition: t1 
	removals add: t1! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
shouldWarnAboutErrors
	^ errorDefinitions isEmpty not
		and: [false]! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
sorterForItems: t1 
	| t2 |
	t2 := MCDependencySorter items: t1.
	t2 addExternalProvisions: self provisions.
	^ t2! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
tryToLoad: t1 
	[t1 addMethodAdditionTo: methodAdditions]
		on: Error
		do: [errorDefinitions add: t1]! !

!MCPackageLoader methodsFor: 'public' stamp: ''!
unloadPackage: t1 
	self updatePackage: t1 withSnapshot: MCSnapshot empty! !

!MCPackageLoader methodsFor: 'public' stamp: ''!
updatePackage: t1 withSnapshot: t2 
	| t3 t4 |
	t4 := t1 snapshot.
	t3 := t2 patchRelativeToBase: t4.
	t3 applyTo: self.
	t4 definitions
		do: [:t5 | self provisions addAll: t5 provisions]! !

!MCPackageLoader methodsFor: 'private' stamp: 'ul 8/2/2011 20:03'!
useChangeSetNamed: baseName during: aBlock
	"Use the named change set, or create one with the given name."
	| changeHolder oldChanges newChanges |
	changeHolder := (ChangeSet respondsTo: #newChanges:)
						ifTrue: [ChangeSet]
						ifFalse: [Smalltalk].
	oldChanges := (ChangeSet respondsTo: #current)
						ifTrue: [ChangeSet current]
						ifFalse: [Smalltalk changes].

	newChanges := (ChangesOrganizer changeSetNamed: baseName) ifNil: [ ChangeSet new name: baseName ].
	changeHolder newChanges: newChanges.
	aBlock ensure: [changeHolder newChanges: oldChanges].
! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
useNewChangeSetDuring: t1 
	^ self useNewChangeSetNamedLike: 'MC' during: t1! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
useNewChangeSetNamedLike: t1 during: t2 
	^ self
		useChangeSetNamed: (ChangeSet uniqueNameLike: t1)
		during: t2! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
warnAboutDependencies
	self notify: self dependencyWarning! !

!MCPackageLoader methodsFor: 'private' stamp: ''!
warnAboutErrors
	self notify: self errorDefinitionWarning! !

Object subclass: #MCPackageManager
	instanceVariableNames: 'package modified'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

MCPackageManager class
	instanceVariableNames: 'registry'!

MCPackageManager class
	instanceVariableNames: 'registry'!

!MCPackageManager class methodsFor: 'as yet unclassified' stamp: ''!
allManagers
	^ self registry values! !

!MCPackageManager class methodsFor: 'system changes' stamp: ''!
classModified: t1 
	self
		managersForClass: t1 item
		do: [:t2 | t2 modified: true]! !

!MCPackageManager class methodsFor: 'system changes' stamp: ''!
classMoved: t1 
	self classModified: t1.
	self
		managersForCategory: t1 oldCategory
		do: [:t2 | t2 modified: true]! !

!MCPackageManager class methodsFor: 'system changes' stamp: ''!
classRemoved: t1 
	self classModified: t1! !

!MCPackageManager class methodsFor: 'as yet unclassified' stamp: ''!
forPackage: t1 
	^ self registry
		at: t1
		ifAbsent: [| t2 |
			t2 := self new initializeWithPackage: t1.
			self registry at: t1 put: t2.
			self changed: #allManagers.
			t2]! !

!MCPackageManager class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	Smalltalk
		at: #SystemChangeNotifier
		ifPresent: [:t1 | t1 uniqueInstance noMoreNotificationsFor: self]! !

!MCPackageManager class methodsFor: 'system changes' stamp: ''!
managersForCategory: t1 do: t2 
	| t3 t4 t5 |
	t5 := false.
	t3 := t1
				ifNil: [^ nil].
	self registry
		do: [:t7 | (t7 packageInfo includesSystemCategory: t1)
				ifTrue: [t2 value: t7.
					t5 := true]].
	t5
		ifTrue: [^ self].
	[self registry
		at: (MCPackage named: t3)
		ifPresent: [:t7 | 
			t2 value: t7.
			t5 := true].
	t4 := t3 lastIndexOf: $-.
	t4 > 0]
		whileTrue: [t3 := t3 copyFrom: 1 to: t4 - 1].
	t5
		ifFalse: [t2
				value: (MCWorkingCopy
						forPackage: (MCPackage named: (t1 copyUpTo: $-) capitalized))]! !

!MCPackageManager class methodsFor: 'system changes' stamp: ''!
managersForClass: t1 category: t2 do: t3 
	(t2 isEmptyOrNil
			or: [t2 first ~= $*])
		ifTrue: [^ self managersForClass: t1 do: t3].
	self managersForCategory: t2 allButFirst do: t3! !

!MCPackageManager class methodsFor: 'system changes' stamp: ''!
managersForClass: t1 do: t2 
	self registry
		do: [:t3 | (t3 packageInfo includesClass: t1)
				ifTrue: [t2 value: t3]]! !

!MCPackageManager class methodsFor: 'system changes' stamp: ''!
managersForClass: t1 selector: t2 do: t3 
	^ self
		managersForClass: t1
		category: (t1 organization categoryOfElement: t2)
		do: t3! !

!MCPackageManager class methodsFor: 'system changes' stamp: ''!
methodModified: t1 
	^ self
		managersForClass: t1 itemClass
		selector: t1 itemSelector
		do: [:t2 | t2 modified: true]! !

!MCPackageManager class methodsFor: 'system changes' stamp: ''!
methodMoved: t1 
	self
		managersForClass: t1 itemClass
		category: t1 oldCategory
		do: [:t2 | t2 modified: true].
	self methodModified: t1! !

!MCPackageManager class methodsFor: 'system changes' stamp: ''!
methodRemoved: t1 
	self
		managersForClass: t1 itemClass
		category: t1 itemProtocol
		do: [:t2 | t2 modified: true]! !

!MCPackageManager class methodsFor: 'system changes' stamp: 'eem 7/3/2009 11:15'!
registerForNotifications
	Smalltalk
		at: #SystemChangeNotifier
		ifPresent:
			[:cls|
			cls uniqueInstance noMoreNotificationsFor: self.
			self reregisterForNotificationsWith: cls uniqueInstance]! !

!MCPackageManager class methodsFor: 'as yet unclassified' stamp: ''!
registry
	^ registry
		ifNil: [registry := Dictionary new]! !

!MCPackageManager class methodsFor: 'system changes' stamp: 'eem 7/3/2009 11:14'!
reregisterForNotificationsWith: aSystemChangeNotifier
	aSystemChangeNotifier
		notify: self ofSystemChangesOfItem: #class change: #Added using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Modified using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Renamed using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Commented using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Recategorized using: #classMoved:;
		notify: self ofSystemChangesOfItem: #class change: #Removed using: #classRemoved:;
		notify: self ofSystemChangesOfItem: #method change: #Added using: #methodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #methodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Recategorized using: #methodMoved:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #methodRemoved:! !

!MCPackageManager methodsFor: 'system changes' stamp: ''!
classModified: t1 
	^ self! !

!MCPackageManager methodsFor: 'system changes' stamp: ''!
classMoved: t1 
	^ self! !

!MCPackageManager methodsFor: 'system changes' stamp: ''!
classRemoved: t1 
	^ self! !

!MCPackageManager methodsFor: 'initialize-release' stamp: ''!
initialize
	modified := false.
	self registerForNotifications! !

!MCPackageManager methodsFor: 'initialize-release' stamp: ''!
initializeWithPackage: t1 
	package := t1.
	self initialize! !

!MCPackageManager methodsFor: 'system changes' stamp: ''!
methodModified: t1 
	^ self! !

!MCPackageManager methodsFor: 'system changes' stamp: ''!
methodMoved: t1 
	^ self! !

!MCPackageManager methodsFor: 'system changes' stamp: ''!
methodRemoved: t1 
	^ self! !

!MCPackageManager methodsFor: 'accessing' stamp: ''!
modified
	^ modified! !

!MCPackageManager methodsFor: 'accessing' stamp: ''!
modified: t1 
	modified = t1
		ifTrue: [^ self].
	modified := t1.
	self changed: #modified.
	modified
		ifFalse: [(((Smalltalk classNamed: 'SmalltalkImage')
				ifNotNil: [:t2 | t2 current])
				ifNil: [Smalltalk])
				logChange: '"' , self packageName , '"']! !

!MCPackageManager methodsFor: 'accessing' stamp: ''!
package
	^ package! !

!MCPackageManager methodsFor: 'accessing' stamp: ''!
packageInfo
	^ package packageInfo! !

!MCPackageManager methodsFor: 'accessing' stamp: ''!
packageName
	^ package name! !

!MCPackageManager methodsFor: 'accessing' stamp: ''!
packageNameWithStar
	^ modified
		ifTrue: ['* ' , self packageName]
		ifFalse: [self packageName]! !

!MCPackageManager methodsFor: 'system changes' stamp: ''!
registerForNotifications
	^ self! !

!MCPackageManager methodsFor: 'system changes' stamp: ''!
registerForNotificationsFrom: t1 
	^ self! !

!MCPackageManager methodsFor: 'system changes' stamp: ''!
systemChange: t1 
	^ self! !

!MCPackageManager methodsFor: 'operations' stamp: 'cmm 6/8/2011 13:39'!
unregister
	self class registry
		removeKey: package
		ifAbsent: [ "Should not complain when trying to clean up." ].
	self class changed: #allManagers! !

!MCPackageManager methodsFor: 'operations' stamp: 'dtl 1/11/2011 23:30'!
unregisterSubpackages
	(self class registry keys
		select: [:p | self packageName , '-*' match: p name])
		do: [:k | self class registry removeKey: k]! !

!MCPackageManager methodsFor: 'system changes' stamp: ''!
update: t1 
	InMidstOfFileinNotification signal
		ifFalse: [[(t1 = #recentMethodSubmissions
					and: [self packageInfo includesMethodReference: Utilities recentMethodSubmissions last])
				ifTrue: [self modified: true]]
				on: Error
				do: []]! !

MCPackageManager subclass: #MCWorkingCopy
	instanceVariableNames: 'versionInfo ancestry counter repositoryGroup requiredPackages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCWorkingCopy class methodsFor: 'as yet unclassified' stamp: ''!
adoptVersionInfoFrom: t1 
	| t2 |
	t2 := Dictionary new.
	t1 versionInfo
		keysAndValuesDo: [:t3 :t4 | (self
				forPackage: (MCPackage named: t3))
				versionInfo: (self infoFromDictionary: t4 cache: t2)].
	[t1 clearVersionInfo]
		on: Error
		do: []! !

!MCWorkingCopy class methodsFor: 'as yet unclassified' stamp: ''!
ancestorsFromArray: t1 cache: t2 
	^ t1
		ifNotNil: [t1
				collect: [:t3 | self infoFromDictionary: t3 cache: t2]]! !

!MCWorkingCopy class methodsFor: 'class initialization' stamp: 'bp 1/7/2011 22:44'!
cleanUp: aggressive
	"Remove all PackageInfos that are not associated with an MCWorkingCopy when aggressively cleaning up"

	aggressive ifTrue: [self flushObsoletePackageInfos]! !

!MCWorkingCopy class methodsFor: 'cleanup' stamp: 'bp 1/7/2011 22:48'!
flushObsoletePackageInfos
	"Flush any and all PackageInfos that are not associated with an MCWorkingCopy."

	| pkgNames |
	pkgNames := self allManagers collect:[:wcs| wcs packageName] as: Set.
	PackageOrganizer default flushObsoletePackages:[:p|
		p class isObsolete or:[(pkgNames includes: p packageName) not].
	].! !

!MCWorkingCopy class methodsFor: 'as yet unclassified' stamp: 'bf 4/19/2010 00:39'!
infoFromDictionary: aDictionary cache: cache
	| id |
	id := (aDictionary at: #id) asString.
	^ cache at: id ifAbsentPut:
		[MCVersionInfo
			name: (aDictionary at: #name ifAbsent: [''])
			id: (UUID fromString: id)
			message: (aDictionary at: #message ifAbsent: [''])
			date: ([Date fromString: (aDictionary at: #date)] ifError: [nil])
			time: ([Time fromString: (aDictionary at: #time)] ifError: [nil])
			author: (aDictionary at: #author ifAbsent: [''])
			ancestors: (self ancestorsFromArray: (aDictionary at: #ancestors ifAbsent: []) cache: cache)
			stepChildren: (self ancestorsFromArray: (aDictionary at: #stepChildren ifAbsent: []) cache: cache)]! !

!MCWorkingCopy class methodsFor: 'as yet unclassified' stamp: 'eem 7/3/2009 11:21'!
initialize
	Smalltalk 
		at: #MczInstaller
		ifPresent: [:installer | self adoptVersionInfoFrom: installer].
	self updateInstVars.
	"Temporary conversion code -- remove later"
	registry ifNotNil:[registry rehash]. "changed #="
	self allInstancesDo:[:each| "moved notifications"
		Smalltalk at: #SystemChangeNotifier ifPresent:[:cls|
			cls uniqueInstance noMoreNotificationsFor: each.
		].
	].
	self registerForNotifications.
	Smalltalk addToStartUpList: self! !

!MCWorkingCopy class methodsFor: 'system startup' stamp: 'eem 7/3/2009 11:34'!
startUp: resuming
	"Ensure Monticello is receiving system change notifications."

	resuming ifTrue:
		[Smalltalk
			at: #SystemChangeNotifier
			ifPresent: [:scn| self reregisterForNotificationsWith: scn uniqueInstance]]
! !

!MCWorkingCopy class methodsFor: 'as yet unclassified' stamp: ''!
updateInstVars
	self allInstances
		do: [:t1 | t1 updateInstVars]! !

!MCWorkingCopy methodsFor: 'operations' stamp: ''!
adopt: t1 
	ancestry addAncestor: t1 info.
	self changed! !

!MCWorkingCopy methodsFor: 'accessing' stamp: ''!
ancestors
	^ ancestry ancestors! !

!MCWorkingCopy methodsFor: 'accessing' stamp: ''!
ancestry
	^ ancestry! !

!MCWorkingCopy methodsFor: 'operations' stamp: ''!
backportChangesTo: t1 
	| t2 t3 t4 t5 t6 t7 |
	t4 := self currentVersionInfo.
	t2 := self repositoryGroup versionWithInfo: t1.
	t5 := self repositoryGroup versionWithInfo: t4.
	t3 := t5 snapshot patchRelativeToBase: t2 snapshot.
	(MCChangeSelectionRequest new patch: t3;
		 label: 'Changes to Backport';
		 signal)
		ifNotNil: [:t8 | 
			t6 := MCPatcher apply: t8 to: t2 snapshot.
			t7 := MCWorkingAncestry new addAncestor: t1;
						 addStepChild: t4;
						 yourself.
			MCPackageLoader updatePackage: package withSnapshot: t6.
			ancestry := t7.
			self modified: false;
				 modified: true]! !

!MCWorkingCopy methodsFor: 'operations' stamp: ''!
changesRelativeToRepository: t1 
	| t2 t3 |
	t2 := t1
				closestAncestorVersionFor: ancestry
				ifNone: [].
	t3 := t2
				ifNil: [MCSnapshot empty]
				ifNotNil: [t2 snapshot].
	^ package snapshot patchRelativeToBase: t3! !

!MCWorkingCopy methodsFor: 'accessing' stamp: ''!
clearRequiredPackages
	requiredPackages := nil! !

!MCWorkingCopy methodsFor: 'accessing' stamp: ''!
currentVersionInfo
	^ (self needsSaving
			or: [ancestry ancestors isEmpty])
		ifTrue: [self newVersion info]
		ifFalse: [ancestry ancestors first]! !

!MCWorkingCopy methodsFor: 'accessing' stamp: 'bp 11/21/2010 18:33'!
description
	^ self packageNameWithStar, ' (', (ancestry ancestorStringWithout: self packageName), ')'! !

!MCWorkingCopy methodsFor: 'private' stamp: ''!
findSnapshotWithVersionInfo: t1 
	^ t1
		ifNil: [MCSnapshot empty]
		ifNotNil: [(self repositoryGroup versionWithInfo: t1)
				ifNil: [MCSnapshot empty]
				ifNotNil: [:t2 | t2 snapshot]]! !

!MCWorkingCopy methodsFor: 'private' stamp: ''!
initialize
	super initialize.
	ancestry := MCWorkingAncestry new! !

!MCWorkingCopy methodsFor: 'operations' stamp: ''!
loaded: t1 
	ancestry := MCWorkingAncestry new addAncestor: t1 info.
	requiredPackages := OrderedCollection
				withAll: (t1 dependencies
						collect: [:t2 | t2 package]).
	self modified: false.
	self changed! !

!MCWorkingCopy methodsFor: 'operations' stamp: ''!
merge: t1 
	| t2 t3 t4 t5 |
	t1 dependencies
		do: [:t6 | t6 resolve merge].
	t2 := t1 info commonAncestorWith: ancestry.
	t2 = t1 info
		ifTrue: [^ MCNoChangesException signal].
	t5 := package snapshot.
	t4 := t2
				ifNil: [self notifyNoCommonAncestorWith: t1.
					MCSnapshot empty]
				ifNotNil: [self findSnapshotWithVersionInfo: t2].
	(ancestry ancestors size = 1
			and: [ancestry ancestors first = t2
					and: [(t5 patchRelativeToBase: t4) isEmpty]])
		ifTrue: [^ t1 load].
	t3 := MCThreeWayMerger
				base: t5
				target: t1 snapshot
				ancestor: t4.
	((MCMergeResolutionRequest new merger: t3)
			signal: 'Merging ' , t1 info name)
			= true
		ifTrue: [t3 loadWithNameLike: t1 info name.
			ancestry addAncestor: t1 info].
	self changed! !

!MCWorkingCopy methodsFor: 'operations' stamp: ''!
merged: t1 
	ancestry addAncestor: t1 info.
	self changed! !

!MCWorkingCopy methodsFor: 'accessing' stamp: ''!
needsSaving
	^ self modified
		or: [self requiredPackages
				anySatisfy: [:t1 | t1 workingCopy needsSaving]]! !

!MCWorkingCopy methodsFor: 'repositories' stamp: 'bf 11/16/2011 19:20'!
newRepositoryGroupIfDefault
	repositoryGroup == MCRepositoryGroup default
		ifTrue: [repositoryGroup := MCRepositoryGroup new]! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'bf 9/7/2012 13:42'!
newVersion
	^ (self requestVersionNameAndMessageWithSuggestion: self uniqueVersionName
		initialMessage: self patchMessageSuggestion) ifNotNil:
			[:pair |
			self newVersionWithName: pair first withBlanksTrimmed
				message: (self patchMessageStripped: pair last)].
! !

!MCWorkingCopy methodsFor: 'operations' stamp: ''!
newVersionWithName: t1 message: t2 
	| t3 t4 |
	t3 := ancestry infoWithName: t1 message: t2.
	ancestry := MCWorkingAncestry new addAncestor: t3.
	self modified: true;
		 modified: false.
	t4 := self requiredPackages
				collect: [:t5 | MCVersionDependency package: t5 info: t5 workingCopy currentVersionInfo].
	^ MCVersion
		package: package
		info: t3
		snapshot: package snapshot
		dependencies: t4! !

!MCWorkingCopy methodsFor: 'private' stamp: 'bf 3/8/2012 18:30'!
nextVersionName
	| branch oldName |
	ancestry ancestors isEmpty
		ifTrue:
			[ counter ifNil: [ counter := 0 ].
			branch := package name ]
		ifFalse:
			[ oldName := ancestry ancestors first versionName.
			branch := oldName packageAndBranchName.
			counter ifNil:
				[ counter := (ancestry ancestors detectMax:
					[ : eachVersionInfo | eachVersionInfo versionNumber ])
					ifNil: [ 0 ]
					ifNotNil:
						[ : highestNumbered | highestNumbered versionNumber ] ] ].
	counter := counter + 1.
	^ branch , '-' , Utilities authorInitials , '.' , counter asString! !

!MCWorkingCopy methodsFor: 'operations' stamp: ''!
notifyNoCommonAncestorWith: t1 
	self notify: 'Could not find a common ancestor between (' , t1 info name , ') and (' , ancestry ancestorString , ').
Proceeding with this merge may cause spurious conflicts.'! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'bf 9/4/2010 18:31'!
patchMessageChanges
	| changes parentInfo parentSnapshot |
	parentInfo := self ancestors
		ifEmpty: [nil]
		ifNotEmpty: [self ancestors first].
	parentSnapshot := 	self findSnapshotWithVersionInfo: parentInfo.
	changes := package snapshot patchRelativeToBase: parentSnapshot.
	^ (MCPatchMessage new patch: changes) message! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'bf 9/4/2010 19:00'!
patchMessageChangesDelimiter
	^'=== text below is ignored ==='! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'bf 9/4/2010 19:04'!
patchMessageChangesHeader
	^ancestry summary, String cr,
	'Added, Modified, Deleted',
	(self ancestors ifEmpty: [''] ifNotEmpty: [' vs. ', self ancestors first name]), ':'! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'bf 9/4/2010 18:15'!
patchMessageDefault
	^ 'empty log message'! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'bf 9/4/2010 18:31'!
patchMessageStripped: aString
	| pos |
	pos := aString findString: self patchMessageChangesDelimiter.
	^ (pos > 0
		ifTrue: [aString first: pos - 1]
		ifFalse: [aString]) withBlanksTrimmed! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'bf 9/4/2010 18:35'!
patchMessageSuggestion
	^	self patchMessageDefault, String cr, String cr,
		self patchMessageChangesDelimiter, String cr,
		self patchMessageChangesHeader, String cr,
		self patchMessageChanges! !

!MCWorkingCopy methodsFor: 'private' stamp: ''!
possiblyNewerVersions
	^ Array
		streamContents: [:t1 | self repositoryGroup repositories
				do: [:t2 | t1
						nextPutAll: (self possiblyNewerVersionsIn: t2)]]! !

!MCWorkingCopy methodsFor: 'private' stamp: 'cmm 3/3/2011 15:24'!
possiblyNewerVersionsIn: aRepository 
	^ aRepository possiblyNewerVersionsOfAnyOf:
		(self ancestors collect:
			[ : each | each versionName ])! !

!MCWorkingCopy methodsFor: 'accessing' stamp: 'bp 11/21/2010 17:12'!
printOn: stream
	super printOn: stream.
	stream
		nextPut: $(;
		nextPutAll: self packageName;
		nextPut: $)! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'cmm 6/8/2011 14:25'!
renameToBe: newPackageName 
	| newWorkingCopy definitions |
	self modified ifTrue: [ self error: 'Should only rename an unmodified package.' ].
	(MCWorkingCopy allManagers anySatisfy:
		[ : each | each packageName = newPackageName ]) ifTrue: [ self error: newPackageName , ' is already taken.' ].
	definitions := self package snapshot definitions.
	PackageInfo registerPackageName: newPackageName.
	newWorkingCopy := (MCWorkingCopy forPackage: (MCPackage new name: newPackageName))
		 repositoryGroup: self repositoryGroup ;
		 requiredPackages: self requiredPackages copy ;
		 modified: true ;
		 yourself.
	definitions do:
		[ : each | each
			handlePackageRename: self package name
			to: newPackageName ].
	self ancestors do:
		[ : each | newWorkingCopy ancestry addAncestor: each ].
	newWorkingCopy package snapshot definitions size = definitions size ifTrue:
		[ PackageOrganizer default unregisterPackage: (PackageInfo named: self packageName).
		self unregister ].
	^ newWorkingCopy! !

!MCWorkingCopy methodsFor: 'repositories' stamp: ''!
repositoryGroup
	^ repositoryGroup
		ifNil: [repositoryGroup := MCRepositoryGroup new]! !

!MCWorkingCopy methodsFor: 'repositories' stamp: ''!
repositoryGroup: t1 
	repositoryGroup := t1! !

!MCWorkingCopy methodsFor: 'private' stamp: 'bf 9/4/2010 15:29'!
requestVersionNameAndMessageWithSuggestion: nameString initialMessage: msgString
	^ (MCVersionNameAndMessageRequest new
		suggestedName: nameString;
		initialMessage: msgString
		) signal! !

!MCWorkingCopy methodsFor: 'accessing' stamp: ''!
requirePackage: t1 
	(self requiredPackages includes: t1)
		ifFalse: [requiredPackages add: t1]! !

!MCWorkingCopy methodsFor: 'accessing' stamp: ''!
requiredPackages
	^ requiredPackages
		ifNil: [requiredPackages := OrderedCollection new]! !

!MCWorkingCopy methodsFor: 'private' stamp: 'cmm 6/6/2011 19:26'!
requiredPackages: aCollection
	requiredPackages := aCollection! !

!MCWorkingCopy methodsFor: 'private' stamp: ''!
uniqueVersionName
	| t1 |
	counter := nil.
	[t1 := self nextVersionName.
	self repositoryGroup includesVersionNamed: t1] whileTrue.
	^ t1! !

!MCWorkingCopy methodsFor: 'operations' stamp: 'dtl 1/11/2011 23:30'!
unload
	MCPackageLoader unloadPackage: self package.
	self unregisterSubpackages.
	self unregister.! !

!MCWorkingCopy methodsFor: 'migration' stamp: ''!
updateInstVars
	ancestry
		ifNil: [ancestry := MCWorkingAncestry new.
			versionInfo
				ifNotNil: [versionInfo ancestors
						do: [:t1 | ancestry addAncestor: t1].
					versionInfo := nil]]! !

!MCWorkingCopy methodsFor: 'accessing' stamp: ''!
versionInfo: t1 
	ancestry := MCWorkingAncestry new addAncestor: t1! !

!MCWorkingCopy methodsFor: 'private' stamp: ''!
versionSeparator
	^ $_! !

Object subclass: #MCPatch
	instanceVariableNames: 'operations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCPatch class methodsFor: 'as yet unclassified' stamp: ''!
fromBase: t1 target: t2 
	^ self new initializeWithBase: t1 target: t2! !

!MCPatch class methodsFor: 'as yet unclassified' stamp: ''!
operations: t1 
	^ self basicNew initializeWithOperations: t1! !

!MCPatch methodsFor: 'applying' stamp: ''!
applyTo: t1 
	operations
		do: [:t2 | t2 applyTo: t1]! !

!MCPatch methodsFor: 'ui' stamp: ''!
browse
	^ (MCPatchBrowser forPatch: self) show! !

!MCPatch methodsFor: 'intializing' stamp: ''!
initializeWithBase: t1 target: t2 
	| t3 t4 |
	operations := OrderedCollection new.
	t3 := MCDefinitionIndex definitions: t1 definitions.
	t4 := MCDefinitionIndex definitions: t2 definitions.
	t4 definitions
		do: [:t5 | t3
				definitionLike: t5
				ifPresent: [:t6 | (t6 isSameRevisionAs: t5)
						ifFalse: [operations
								add: (MCModification of: t6 to: t5)]]
				ifAbsent: [operations
						add: (MCAddition of: t5)]]
		displayingProgress: 'Diffing...'.
	t3 definitions
		do: [:t5 | t4
				definitionLike: t5
				ifPresent: [:t6 | t6]
				ifAbsent: [operations
						add: (MCRemoval of: t5)]]! !

!MCPatch methodsFor: 'intializing' stamp: ''!
initializeWithOperations: t1 
	operations := t1! !

!MCPatch methodsFor: 'querying' stamp: ''!
isEmpty
	^ operations isEmpty! !

!MCPatch methodsFor: 'accessing' stamp: ''!
operations
	^ operations! !

Object subclass: #MCPatchMessage
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCPatchMessage methodsFor: 'patch operations' stamp: 'bf 9/4/2010 18:48'!
addDefinition: aDefinition
	stream nextPutAll: 'A'; tab; nextPutAll: aDefinition summary; cr! !

!MCPatchMessage methodsFor: 'accessing' stamp: 'bf 9/4/2010 16:29'!
message
	^stream contents
! !

!MCPatchMessage methodsFor: 'patch operations' stamp: 'bf 9/4/2010 18:57'!
modifyDefinition: oldDefinition to: newDefinition
	stream nextPutAll: 'M'; tab; nextPutAll: newDefinition summary; cr! !

!MCPatchMessage methodsFor: 'accessing' stamp: 'bf 9/4/2010 17:44'!
patch: aPatch
	stream ifNil: [stream := WriteStream on: (String new: 100)].
	aPatch operations asSortedCollection
		do: [:op | op applyTo: self]! !

!MCPatchMessage methodsFor: 'patch operations' stamp: 'bf 9/4/2010 18:57'!
removeDefinition: aDefinition
	stream nextPutAll: 'D'; tab; nextPutAll: aDefinition summary; cr! !

Object subclass: #MCPatchOperation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

MCPatchOperation subclass: #MCAddition
	instanceVariableNames: 'definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCAddition class methodsFor: 'as yet unclassified' stamp: ''!
of: t1 
	^ self new intializeWithDefinition: t1! !

!MCAddition methodsFor: 'accessing' stamp: ''!
applyTo: t1 
	t1 addDefinition: definition! !

!MCAddition methodsFor: 'accessing' stamp: ''!
baseDefinition
	^ nil! !

!MCAddition methodsFor: 'accessing' stamp: ''!
definition
	^ definition! !

!MCAddition methodsFor: 'accessing' stamp: ''!
fromSource
	^ ''! !

!MCAddition methodsFor: 'initializing' stamp: ''!
intializeWithDefinition: t1 
	definition := t1! !

!MCAddition methodsFor: 'as yet unclassified' stamp: ''!
inverse
	^ MCRemoval of: definition! !

!MCAddition methodsFor: 'testing' stamp: ''!
isAddition
	^ true! !

!MCAddition methodsFor: 'as yet unclassified' stamp: ''!
isClassPatch
	^ definition isClassDefinition! !

!MCAddition methodsFor: 'accessing' stamp: ''!
sourceString
	^ self toSource asText addAttribute: TextColor red;
		 yourself! !

!MCAddition methodsFor: 'accessing' stamp: ''!
summary
	^ definition summary! !

!MCAddition methodsFor: 'accessing' stamp: ''!
targetClass
	^ definition actualClass! !

!MCAddition methodsFor: 'accessing' stamp: ''!
targetDefinition
	^ definition! !

!MCAddition methodsFor: 'accessing' stamp: ''!
toSource
	^ definition source! !

MCPatchOperation subclass: #MCModification
	instanceVariableNames: 'obsoletion modification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCModification class methodsFor: 'as yet unclassified' stamp: ''!
of: t1 to: t2 
	^ self new initializeWithBase: t1 target: t2! !

!MCModification methodsFor: 'accessing' stamp: ''!
applyTo: t1 
	t1 modifyDefinition: obsoletion to: modification! !

!MCModification methodsFor: 'accessing' stamp: ''!
baseDefinition
	^ obsoletion! !

!MCModification methodsFor: 'accessing' stamp: ''!
definition
	^ modification! !

!MCModification methodsFor: 'accessing' stamp: ''!
fromSource
	^ obsoletion source! !

!MCModification methodsFor: 'initializing' stamp: ''!
initializeWithBase: t1 target: t2 
	obsoletion := t1.
	modification := t2! !

!MCModification methodsFor: 'as yet unclassified' stamp: ''!
inverse
	^ MCModification of: modification to: obsoletion! !

!MCModification methodsFor: 'as yet unclassified' stamp: ''!
isClassPatch
	^ obsoletion isClassDefinition! !

!MCModification methodsFor: 'testing' stamp: ''!
isModification
	^ true! !

!MCModification methodsFor: 'as yet unclassified' stamp: 'bf 6/13/2011 16:27'!
isUnchangedMethod
	"true if this is a modification of a method where only the timestamp changed"
	^ obsoletion isMethodDefinition
		and: [obsoletion source = modification source
			and: [obsoletion category = modification category] ]! !

!MCModification methodsFor: 'accessing' stamp: ''!
modification
	^ modification! !

!MCModification methodsFor: 'accessing' stamp: ''!
obsoletion
	^ obsoletion! !

!MCModification methodsFor: 'as yet unclassified' stamp: ''!
printAnnotations: t1 on: t2 
	t2 nextPutAll: 'old: '.
	obsoletion printAnnotations: t1 on: t2.
	t2 cr.
	t2 nextPutAll: 'new: '.
	modification printAnnotations: t1 on: t2! !

!MCModification methodsFor: 'accessing' stamp: 'bf 11/1/2011 11:42'!
summarySuffix
	^ modification summarySuffixOver: obsoletion
! !

!MCModification methodsFor: 'accessing' stamp: ''!
targetClass
	^ obsoletion actualClass! !

!MCModification methodsFor: 'accessing' stamp: ''!
targetDefinition
	^ modification! !

!MCModification methodsFor: 'accessing' stamp: ''!
toSource
	^ modification source! !

!MCPatchOperation methodsFor: 'comparing' stamp: ''!
<= t1 
	^ self definition <= t1 definition! !

!MCPatchOperation methodsFor: 'accessing' stamp: ''!
annotations
	^ self annotations: Preferences defaultAnnotationRequests! !

!MCPatchOperation methodsFor: 'accessing' stamp: ''!
annotations: t1 
	^ String
		streamContents: [:t2 | self printAnnotations: t1 on: t2]! !

!MCPatchOperation methodsFor: 'accessing' stamp: ''!
definition
	^ self subclassResponsibility! !

!MCPatchOperation methodsFor: 'accessing' stamp: ''!
inverse
	self subclassResponsibility! !

!MCPatchOperation methodsFor: 'testing' stamp: ''!
isAddition
	^ false! !

!MCPatchOperation methodsFor: 'as yet unclassified' stamp: ''!
isClassPatch
	^ false! !

!MCPatchOperation methodsFor: 'testing' stamp: ''!
isModification
	^ false! !

!MCPatchOperation methodsFor: 'testing' stamp: ''!
isRemoval
	^ false! !

!MCPatchOperation methodsFor: 'as yet unclassified' stamp: 'bf 6/13/2011 16:24'!
isUnchangedMethod
	"true if this is a modification of a method where only the timestamp changed"
	^false! !

!MCPatchOperation methodsFor: 'accessing' stamp: ''!
prefixForOperation: t1 
	t1 == #insert
		ifTrue: [^ '+'].
	t1 == #remove
		ifTrue: [^ '-'].
	^ ' '! !

!MCPatchOperation methodsFor: 'accessing' stamp: ''!
printAnnotations: t1 on: t2 
	self definition printAnnotations: t1 on: t2! !

!MCPatchOperation methodsFor: 'accessing' stamp: ''!
source
	^ self sourceText! !

!MCPatchOperation methodsFor: 'accessing' stamp: ''!
sourceString
	^ self sourceText asString! !

!MCPatchOperation methodsFor: 'accessing' stamp: 'ul 11/6/2010 05:55'!
sourceText

	^(self isClassPatch
		ifFalse: [ TextDiffBuilder ]
		ifTrue: [ ClassDiffBuilder ])
			buildDisplayPatchFrom: self fromSource
			to: self toSource
			inClass: self targetClass
			prettyDiffs: (
				Preferences diffsWithPrettyPrint and: [
					self targetClass notNil and: [
					self isClassPatch not ] ])! !

!MCPatchOperation methodsFor: 'accessing' stamp: ''!
summary
	^ self definition summary , self summarySuffix! !

!MCPatchOperation methodsFor: 'accessing' stamp: ''!
summarySuffix
	^ ''! !

!MCPatchOperation methodsFor: 'as yet unclassified' stamp: ''!
targetClass
	self subclassResponsibility! !

MCPatchOperation subclass: #MCRemoval
	instanceVariableNames: 'definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCRemoval class methodsFor: 'as yet unclassified' stamp: ''!
of: t1 
	^ self new intializeWithDefinition: t1! !

!MCRemoval methodsFor: 'accessing' stamp: ''!
applyTo: t1 
	t1 removeDefinition: definition! !

!MCRemoval methodsFor: 'accessing' stamp: ''!
baseDefinition
	^ definition! !

!MCRemoval methodsFor: 'accessing' stamp: ''!
definition
	^ definition! !

!MCRemoval methodsFor: 'accessing' stamp: ''!
fromSource
	^ definition source! !

!MCRemoval methodsFor: 'initializing' stamp: ''!
intializeWithDefinition: t1 
	definition := t1! !

!MCRemoval methodsFor: 'as yet unclassified' stamp: ''!
inverse
	^ MCAddition of: definition! !

!MCRemoval methodsFor: 'as yet unclassified' stamp: ''!
isClassPatch
	^ definition isClassDefinition! !

!MCRemoval methodsFor: 'testing' stamp: ''!
isRemoval
	^ true! !

!MCRemoval methodsFor: 'accessing' stamp: ''!
sourceString
	^ self fromSource asText addAttribute: TextEmphasis struckOut;
		 addAttribute: TextColor blue;
		 yourself! !

!MCRemoval methodsFor: 'accessing' stamp: ''!
summarySuffix
	^ ' (removed)'! !

!MCRemoval methodsFor: 'accessing' stamp: ''!
targetClass
	^ definition actualClass! !

!MCRemoval methodsFor: 'accessing' stamp: ''!
targetDefinition
	^ nil! !

!MCRemoval methodsFor: 'accessing' stamp: ''!
toSource
	^ ''! !

Object subclass: #MCPatcher
	instanceVariableNames: 'definitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Patching'!

!MCPatcher class methodsFor: 'as yet unclassified' stamp: ''!
apply: t1 to: t2 
	| t3 |
	t3 := self snapshot: t2.
	t1 applyTo: t3.
	^ t3 patchedSnapshot! !

!MCPatcher class methodsFor: 'as yet unclassified' stamp: ''!
snapshot: t1 
	^ self new initializeWithSnapshot: t1! !

!MCPatcher methodsFor: 'as yet unclassified' stamp: ''!
addDefinition: t1 
	definitions add: t1! !

!MCPatcher methodsFor: 'as yet unclassified' stamp: ''!
initializeWithSnapshot: t1 
	definitions := MCDefinitionIndex definitions: t1 definitions! !

!MCPatcher methodsFor: 'as yet unclassified' stamp: ''!
modifyDefinition: t1 to: t2 
	self addDefinition: t2! !

!MCPatcher methodsFor: 'as yet unclassified' stamp: ''!
patchedSnapshot
	^ MCSnapshot fromDefinitions: definitions definitions! !

!MCPatcher methodsFor: 'as yet unclassified' stamp: ''!
removeDefinition: t1 
	definitions remove: t1! !

Object subclass: #MCReader
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCReader class methodsFor: 'testing' stamp: ''!
canReadFileNamed: t1 
	^ t1 endsWith: self extension! !

!MCReader class methodsFor: 'testing' stamp: 'ul 3/22/2011 22:34'!
concreteSubclassesDo: aBlock

	self allSubclassesDo: [ :each |
		each isAbstract ifFalse: [ aBlock value: each ] ]! !

!MCReader class methodsFor: 'testing' stamp: ''!
isAbstract
	^ (self respondsTo: #extension) not! !

!MCReader class methodsFor: 'instance creation' stamp: ''!
new
	^ self basicNew initialize! !

!MCReader class methodsFor: 'instance creation' stamp: ''!
on: t1 
	^ self new stream: t1! !

!MCReader class methodsFor: 'instance creation' stamp: ''!
on: t1 name: t2 
	| t3 |
	t3 := self readerClassForFileNamed: t2.
	^ t3
		ifNil: [self error: 'Unsupported format: ' , t2]
		ifNotNil: [t3 on: t1]! !

!MCReader class methodsFor: 'testing' stamp: 'ul 3/22/2011 21:23'!
readerClassForFileNamed: fileName
	
	self concreteSubclassesDo: [ :each |
		(each canReadFileNamed: fileName) ifTrue: [ ^each ] ].
	^nil! !

!MCReader methodsFor: 'lifecycle' stamp: ''!
initialize
	^ self! !

!MCReader methodsFor: 'accessing' stamp: ''!
stream: t1 
	stream := t1! !

MCReader subclass: #MCSnapshotReader
	instanceVariableNames: 'definitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCSnapshotReader class methodsFor: 'as yet unclassified' stamp: ''!
snapshotFromStream: t1 
	^ (self on: t1) snapshot! !

!MCSnapshotReader methodsFor: 'as yet unclassified' stamp: ''!
definitions
	definitions
		ifNil: [self loadDefinitions].
	^ definitions! !

!MCSnapshotReader methodsFor: 'as yet unclassified' stamp: ''!
snapshot
	^ MCSnapshot fromDefinitions: self definitions! !

MCSnapshotReader subclass: #MCStReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Chunk Format'!

!MCStReader class methodsFor: 'as yet unclassified' stamp: ''!
extension
	^ 'st'! !

!MCStReader methodsFor: 'as yet unclassified' stamp: ''!
addDefinitionsFromDoit: t1 
	(MCDoItParser forDoit: t1)
		ifNotNil: [:t2 | t2 addDefinitionsTo: definitions]! !

!MCStReader methodsFor: 'as yet unclassified' stamp: ''!
categoryFromDoIt: t1 
	| t2 |
	t2 := Scanner new scanTokens: t1.
	t2 size = 3
		ifFalse: [self error: 'Unrecognized category definition'].
	^ t2 at: 3! !

!MCStReader methodsFor: 'as yet unclassified' stamp: ''!
classDefinitionFrom: t1 
	| t2 t3 t4 t5 |
	t2 := Scanner new scanTokens: t1 definition.
	t3 := ((ReadStream on: t1 definition) match: 'uses:';
				 upToAll: 'instanceVariableNames:') withBlanksTrimmed.
	t5 := ((ReadStream on: t1 metaClass definition asString) match: 'uses:';
				 upToAll: 'instanceVariableNames:') withBlanksTrimmed.
	t3 isEmpty
		ifTrue: [t3 := '{}'].
	t5 isEmpty
		ifTrue: [t5 := '{}'].
	t4 := t2 size.
	^ MCClassDefinition
		name: (t2 at: 3)
		superclassName: (t2 at: 1)
		traitComposition: t3
		classTraitComposition: t5
		category: (t2 at: t4)
		instVarNames: ((t2 at: t4 - 6)
				findTokens: ' ')
		classVarNames: ((t2 at: t4 - 4)
				findTokens: ' ')
		poolDictionaryNames: ((t2 at: t4 - 2)
				findTokens: ' ')
		classInstVarNames: (self classInstVarNamesFor: t1)
		type: (self
				typeOfSubclass: (t2 at: 2))
		comment: (self commentFor: t1)
		commentStamp: (self commentStampFor: t1)! !

!MCStReader methodsFor: 'as yet unclassified' stamp: ''!
classInstVarNamesFor: t1 
	| t2 |
	self flag: #traits.
	t1 metaClass hasDefinition
		ifFalse: [^ #()].
	t2 := Scanner new scanTokens: t1 metaClass definition.
	^ t2 last findTokens: ' '! !

!MCStReader methodsFor: 'as yet unclassified' stamp: ''!
commentFor: t1 
	| t2 |
	t2 := t1 organization classComment.
	^ t2 asString = ''
		ifTrue: [t2]
		ifFalse: [t2 string]! !

!MCStReader methodsFor: 'as yet unclassified' stamp: ''!
commentStampFor: t1 
	| t2 |
	t2 := t1 organization classComment.
	^ [t2 stamp]
		on: MessageNotUnderstood
		do: []! !

!MCStReader methodsFor: 'evaluating' stamp: ''!
loadDefinitions
	| t1 |
	t1 := FilePackage new fullName: 'ReadStream';
				 fileInFrom: self readStream.
	definitions := OrderedCollection new.
	t1 classes
		do: [:t2 | 
			t2 hasDefinition
				ifTrue: [definitions
						add: (self classDefinitionFrom: t2)].
			definitions
				addAll: (self methodDefinitionsFor: t2).
			definitions
				addAll: (self methodDefinitionsFor: t2 metaClass)].
	t1 doIts
		do: [:t2 | self addDefinitionsFromDoit: t2 string]! !

!MCStReader methodsFor: 'as yet unclassified' stamp: ''!
methodDefinitionsFor: t1 
	^ t1 selectors
		collect: [:t2 | MCMethodDefinition
				className: t1 name
				classIsMeta: t1 isMeta
				selector: t2
				category: (t1 organization categoryOfElement: t2)
				timeStamp: (t1 stampAt: t2)
				source: (t1 sourceCodeAt: t2)]! !

!MCStReader methodsFor: 'evaluating' stamp: ''!
readStream
	^ ('!!!!

' , stream contents) readStream! !

!MCStReader methodsFor: 'as yet unclassified' stamp: ''!
systemOrganizationFromRecords: t1 
	| t2 |
	t2 := t1
				select: [:t3 | 'SystemOrganization*' match: t3 string]
				thenCollect: [:t3 | self categoryFromDoIt: t3 string].
	^ t2 isEmpty
		ifFalse: [MCOrganizationDefinition categories: t2 asArray]! !

!MCStReader methodsFor: 'as yet unclassified' stamp: ''!
typeOfSubclass: t1 
	#(#(#subclass: #normal ) #(#variableSubclass: #variable ) #(#variableByteSubclass: #bytes ) #(#variableWordSubclass: #words ) #(#weakSubclass: #weak ) )
		do: [:t2 | 
			t2 first = t1
				ifTrue: [^ t2 second].
			nil].
	self error: 'Unrecognized class definition'! !

MCReader subclass: #MCVersionReader
	instanceVariableNames: 'package info definitions dependencies stepChildren'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

MCVersionReader subclass: #MCMczReader
	instanceVariableNames: 'zip infoCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

MCMczReader subclass: #MCMcdReader
	instanceVariableNames: 'baseInfo patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCMcdReader class methodsFor: 'as yet unclassified' stamp: ''!
extension
	^ 'mcd'! !

!MCMcdReader methodsFor: 'as yet unclassified' stamp: ''!
baseInfo
	^ baseInfo
		ifNil: [self loadBaseInfo]! !

!MCMcdReader methodsFor: 'as yet unclassified' stamp: ''!
basicVersion
	^ MCDiffyVersion
		package: self package
		info: self info
		dependencies: self dependencies
		baseInfo: self baseInfo
		patch: self patch! !

!MCMcdReader methodsFor: 'as yet unclassified' stamp: ''!
buildPatchFrom: t1 to: t2 
	^ MCPatch
		fromBase: (MCSnapshot fromDefinitions: t1)
		target: (MCSnapshot fromDefinitions: t2)! !

!MCMcdReader methodsFor: 'as yet unclassified' stamp: ''!
loadBaseInfo
	^ baseInfo := self
				extractInfoFrom: (self parseMember: 'base')! !

!MCMcdReader methodsFor: 'as yet unclassified' stamp: ''!
loadPatch
	| t1 t2 |
	(self zip memberNamed: 'patch.bin')
		ifNotNil: [:t3 | [^ patch := (DataStream on: t3 contentStream) next]
				on: Error
				do: [:t4 | t4]].
	definitions := OrderedCollection new.
	(self zip membersMatching: 'old/*')
		do: [:t4 | self extractDefinitionsFrom: t4].
	t1 := definitions asArray.
	definitions := OrderedCollection new.
	(self zip membersMatching: 'new/*')
		do: [:t4 | self extractDefinitionsFrom: t4].
	t2 := definitions asArray.
	^ patch := self buildPatchFrom: t1 to: t2! !

!MCMcdReader methodsFor: 'as yet unclassified' stamp: ''!
patch
	^ patch
		ifNil: [self loadPatch]! !

!MCMczReader class methodsFor: 'accessing' stamp: ''!
extension
	^ 'mcz'! !

!MCMczReader class methodsFor: 'testing' stamp: ''!
supportsDependencies
	^ true! !

!MCMczReader class methodsFor: 'testing' stamp: ''!
supportsVersions
	^ true! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
associate: t1 
	| t2 |
	t2 := Dictionary new.
	t1
		pairsDo: [:t3 :t4 | t2
				at: t3
				put: (t4 isString
						ifTrue: [t4]
						ifFalse: [t4
								collect: [:t5 | self associate: t5]])].
	^ t2! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
extractDefinitionsFrom: t1 
	| t2 |
	(MCSnapshotReader readerClassForFileNamed: t1 fileName)
		ifNotNil: [:t3 | 
			t2 := t3 on: t1 contentStream text.
			definitions addAll: t2 definitions]! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
extractDependencyFrom: t1 
	^ MCVersionDependency
		package: (MCPackage
				named: (t1 fileName copyAfterLast: $/))
		info: (self
				extractInfoFrom: (self parseMember: t1 fileName))! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: 'bf 4/18/2010 18:38'!
extractInfoFrom: dict
	^MCWorkingCopy infoFromDictionary: dict cache: self infoCache! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
infoCache
	^ infoCache
		ifNil: [infoCache := Dictionary new]! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
loadDefinitions
	definitions := OrderedCollection new.
	(self zip memberNamed: 'snapshot.bin')
		ifNotNil: [:t1 | [^ definitions := (DataStream on: t1 contentStream) next definitions]
				on: Error
				do: [:t2 | t2]].
	(self zip membersMatching: 'snapshot/*')
		do: [:t2 | self extractDefinitionsFrom: t2]! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
loadDependencies
	dependencies := (self zip membersMatching: 'dependencies/*')
				collect: [:t1 | self extractDependencyFrom: t1].
	dependencies := dependencies asArray! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
loadPackage
	| t1 |
	t1 := self parseMember: 'package'.
	package := MCPackage
				named: (t1 at: #name)! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
loadVersionInfo
	info := self
				extractInfoFrom: (self parseMember: 'version')! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
parseMember: t1 
	| t2 |
	t2 := (self scanner
				scanTokens: (self zip contentsOf: t1)) first.
	^ self associate: t2! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
scanner
	^ MCScanner! !

!MCMczReader methodsFor: 'as yet unclassified' stamp: ''!
zip
	zip
		ifNil: [zip := ZipArchive new.
			zip readFrom: stream].
	^ zip! !

!MCVersionReader class methodsFor: 'testing' stamp: ''!
canReadFileNamed: t1 
	^ t1 endsWith: self extension! !

!MCVersionReader class methodsFor: 'reading' stamp: 'ul 8/2/2011 20:03'!
file: fileName streamDo: aBlock

	^FileStream readOnlyFileNamed: fileName do: aBlock! !

!MCVersionReader class methodsFor: 'file services' stamp: ''!
fileReaderServicesForFile: t1 suffix: t2 
	self isAbstract
		ifTrue: [^ #()].
	^ (t2 = self extension
			or: [t2 = '*'])
		ifTrue: [self services]
		ifFalse: [Array new: 0]! !

!MCVersionReader class methodsFor: 'file services' stamp: 'ul 3/22/2011 21:23'!
initialize
	"MCVersionReader initialize"
	Smalltalk 
		at: #MczInstaller
		ifPresent: [:installer | FileList unregisterFileReader: installer].
	self concreteSubclassesDo: [:aClass | FileList registerFileReader: aClass].

	"get rid of AnObsoleteMCMcReader and AnObsoleteMCMcvReader"
	(FileList registeredFileReaderClasses  select: [ :ea | ea isObsolete ]) do: 
		[ :ea | FileList unregisterFileReader: ea ]
! !

!MCVersionReader class methodsFor: 'file services' stamp: 'cmm 4/22/2011 16:54'!
loadVersionFile: fileName 
	| version |
	version := self versionFromFile: fileName.
	version workingCopy repositoryGroup addRepository: (MCDirectoryRepository path: (FileDirectory dirPathFor: fileName)).
	version load! !

!MCVersionReader class methodsFor: '*monticello-file services' stamp: 'cmm 4/22/2011 16:55'!
loadVersionStream: stream fromDirectory: directory
	| version |
	version := self versionFromStream: stream.
	directory isRemoteDirectory ifFalse: [
	version workingCopy repositoryGroup addRepository:
		(MCDirectoryRepository directory: directory). ].
	version load.
! !

!MCVersionReader class methodsFor: 'file services' stamp: ''!
mergeVersionFile: t1 
	(self versionFromFile: t1) merge! !

!MCVersionReader class methodsFor: '*monticello-file services' stamp: ''!
mergeVersionStream: t1 
	(self versionFromStream: t1) merge! !

!MCVersionReader class methodsFor: 'reading' stamp: ''!
on: t1 fileName: t2 
	^ self on: t1! !

!MCVersionReader class methodsFor: 'file services' stamp: ''!
openVersionFile: t1 
	(self versionFromFile: t1) open! !

!MCVersionReader class methodsFor: '*monticello-file services' stamp: ''!
openVersionFromStream: t1 
	(self versionFromStream: t1) open! !

!MCVersionReader class methodsFor: '*monticello-file services-override-override' stamp: ''!
serviceLoadVersion
	^ (SimpleServiceEntry
		provider: self
		label: 'load version'
		selector: #loadVersionStream:fromDirectory:
		description: 'load a package version'
		buttonLabel: 'load')
		argumentGetter: [:t1 | {t1 readOnlyStream. t1 directory}]! !

!MCVersionReader class methodsFor: '*monticello-file services-override-override' stamp: ''!
serviceMergeVersion
	^ (SimpleServiceEntry
		provider: self
		label: 'merge version'
		selector: #mergeVersionStream:
		description: 'merge a package version into the image'
		buttonLabel: 'merge')
		argumentGetter: [:t1 | t1 readOnlyStream]! !

!MCVersionReader class methodsFor: '*monticello-file services-override-override' stamp: ''!
serviceOpenVersion
	^ (SimpleServiceEntry
		provider: self
		label: 'open version'
		selector: #openVersionFromStream:
		description: 'open a package version'
		buttonLabel: 'open')
		argumentGetter: [:t1 | t1 readOnlyStream]! !

!MCVersionReader class methodsFor: 'file services' stamp: ''!
services
	^ Array
		with: self serviceLoadVersion
		with: self serviceMergeVersion
		with: self serviceOpenVersion! !

!MCVersionReader class methodsFor: 'file services' stamp: ''!
unload
	FileList unregisterFileReader: self! !

!MCVersionReader class methodsFor: 'reading' stamp: ''!
versionFromFile: t1 
	^ self
		file: t1
		streamDo: [:t2 | self versionFromStream: t2]! !

!MCVersionReader class methodsFor: 'reading' stamp: ''!
versionFromStream: t1 
	^ (self on: t1) version! !

!MCVersionReader class methodsFor: 'reading' stamp: ''!
versionInfoFromStream: t1 
	^ (self on: t1) info! !

!MCVersionReader methodsFor: 'accessing' stamp: ''!
basicVersion
	^ MCVersion
		package: self package
		info: self info
		snapshot: self snapshot
		dependencies: self dependencies! !

!MCVersionReader methodsFor: 'accessing' stamp: ''!
definitions
	definitions
		ifNil: [self loadDefinitions].
	^ definitions! !

!MCVersionReader methodsFor: 'accessing' stamp: ''!
dependencies
	dependencies
		ifNil: [self loadDependencies].
	^ dependencies! !

!MCVersionReader methodsFor: 'accessing' stamp: ''!
info
	info
		ifNil: [self loadVersionInfo].
	^ info! !

!MCVersionReader methodsFor: 'lifecycle' stamp: ''!
initialize
	^ self! !

!MCVersionReader methodsFor: 'loading' stamp: ''!
loadDefinitions
	self subclassResponsibility! !

!MCVersionReader methodsFor: 'loading' stamp: ''!
loadDependencies
	self subclassResponsibility! !

!MCVersionReader methodsFor: 'loading' stamp: ''!
loadPackage
	self subclassResponsibility! !

!MCVersionReader methodsFor: 'loading' stamp: ''!
loadVersionInfo
	self subclassResponsibility! !

!MCVersionReader methodsFor: 'accessing' stamp: ''!
package
	package
		ifNil: [self loadPackage].
	^ package! !

!MCVersionReader methodsFor: 'accessing' stamp: ''!
snapshot
	^ MCSnapshot fromDefinitions: self definitions! !

!MCVersionReader methodsFor: 'accessing' stamp: ''!
version
	^ self basicVersion! !

Object subclass: #MCRepository
	instanceVariableNames: 'creationTemplate storeDiffs'
	classVariableNames: 'Settings'
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

MCRepository subclass: #MCDictionaryRepository
	instanceVariableNames: 'description dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
= t1 
	^ self == t1! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
allVersionInfos
	^ dict values
		collect: [:t1 | t1 info]! !

!MCDictionaryRepository methodsFor: 'versions' stamp: 'ar 12/15/2010 21:59'!
allVersionNames
	"Answers all the version names in this repository"

	^ dict values collect: [:ea | ea info name]
	! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
basicStoreVersion: t1 
	dict at: t1 info put: t1! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
closestAncestorVersionFor: t1 ifNone: t2 
	| t3 |
	t3 := t1 breadthFirstAncestors
				detect: [:t4 | self includesVersionWithInfo: t4]
				ifNone: [^ t2 value].
	^ self versionWithInfo: t3! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
description
	^ description
		ifNil: ['cache']! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
description: t1 
	description := t1! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
dictionary
	^ dict! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
dictionary: t1 
	dict := t1! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: 'cmm 3/5/2011 18:32'!
includesVersionNamed: aString 
	| mcVersionName |
	mcVersionName := aString asMCVersionName.
	^ dict anySatisfy:
		[ : ea | ea info versionName = mcVersionName ]! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
includesVersionWithInfo: t1 
	^ dict includesKey: t1! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
initialize
	dict := Dictionary new! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
morphicOpen: t1 
	| t2 t3 t4 |
	t4 := self sortedVersionInfos.
	t4 isEmpty
		ifTrue: [^ self inform: 'No versions'].
	t2 := t4
				collect: [:t5 | t5 name].
	t3 := UIManager default chooseFrom: t2 title: 'Open version:'.
	t3 = 0
		ifFalse: [(self
				versionWithInfo: (t4 at: t3)) open]! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
sortedVersionInfos
	| t1 |
	t1 := MCVersionSorter new.
	self allVersionInfos
		do: [:t2 | t1 addVersionInfo: t2].
	^ t1 sortedVersionInfos! !

!MCDictionaryRepository methodsFor: 'as yet unclassified' stamp: ''!
versionWithInfo: t1 ifAbsent: t2 
	^ dict at: t1 ifAbsent: t2! !

MCRepository subclass: #MCFileBasedRepository
	instanceVariableNames: 'cache allFileNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

MCFileBasedRepository subclass: #MCDirectoryRepository
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

MCDirectoryRepository subclass: #MCCacheRepository
	instanceVariableNames: 'packageCaches seenFiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

MCCacheRepository class
	instanceVariableNames: 'default'!

MCCacheRepository class
	instanceVariableNames: 'default'!

!MCCacheRepository class methodsFor: 'as yet unclassified' stamp: ''!
cacheDirectory
	^ (FileDirectory default directoryNamed: 'package-cache') assureExistence; yourself! !

!MCCacheRepository class methodsFor: 'as yet unclassified' stamp: ''!
checkCacheDirectory
	default notNil
		and: [default directory exists
				ifFalse: [default := nil]]! !

!MCCacheRepository class methodsFor: 'as yet unclassified' stamp: ''!
default
	self checkCacheDirectory.
	^ default
		ifNil: [default := self new directory: self cacheDirectory]! !

!MCCacheRepository class methodsFor: 'as yet unclassified' stamp: ''!
description
	^ nil! !

!MCCacheRepository class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self checkCacheDirectory! !

!MCCacheRepository methodsFor: 'as yet unclassified' stamp: 'bf 3/28/2011 16:07'!
basicStoreVersion: aVersion
	(aVersion isCacheable not or: [self allFileNames includes: aVersion fileName])
		ifFalse: [super basicStoreVersion: aVersion]
! !

!MCCacheRepository methodsFor: 'as yet unclassified' stamp: ''!
cacheForPackage: t1 
	packageCaches
		ifNil: [packageCaches := Dictionary new].
	^ packageCaches
		at: t1
		ifAbsentPut: [MCPackageCache new]! !

!MCCacheRepository methodsFor: 'as yet unclassified' stamp: ''!
newFileNames
	^ self allFileNames difference: self seenFileNames! !

!MCCacheRepository methodsFor: 'as yet unclassified' stamp: ''!
packageForFileNamed: t1 
	^ self packageCache
		at: t1
		ifAbsentPut: [self
				versionReaderForFileNamed: t1
				do: [:t2 | t2 package]]! !

!MCCacheRepository methodsFor: 'as yet unclassified' stamp: ''!
rescan
	self newFileNames
		do: [:t1 | self
				versionReaderForFileNamed: t1
				do: [:t2 | 
					(self cacheForPackage: t2 package)
						recordVersionInfo: t2 info
						forFileNamed: t1.
					self seenFileNames add: t1]]
		displayingProgress: 'Scanning cache...'! !

!MCCacheRepository methodsFor: 'as yet unclassified' stamp: ''!
seenFileNames
	^ seenFiles
		ifNil: [seenFiles := OrderedCollection new]! !

!MCCacheRepository methodsFor: 'as yet unclassified' stamp: ''!
versionInfoForFileNamed: t1 
	^ self infoCache
		at: t1
		ifAbsentPut: [self
				versionReaderForFileNamed: t1
				do: [:t2 | t2 info]]! !

!MCDirectoryRepository class methodsFor: 'configuring' stamp: 'cmm 4/22/2011 16:13'!
creationTemplateLocation: location 
	^ self name , ' path: {1}' format: {location printString}! !

!MCDirectoryRepository class methodsFor: 'configuring' stamp: 'ab 7/24/2003 21:20'!
description
	^ 'directory'! !

!MCDirectoryRepository class methodsFor: 'instance creation' stamp: 'cmm 4/22/2011 16:54'!
directory: aFileDirectory 
	^ self new
		 directory: aFileDirectory ;
		 yourself! !

!MCDirectoryRepository class methodsFor: 'configuring' stamp: 'cmm 4/22/2011 16:00'!
fillInTheBlankRequest
	^ 'Directory Location:'! !

!MCDirectoryRepository class methodsFor: 'configuring' stamp: 'ul 12/12/2009 14:10'!
morphicConfigure
	^ FileList2 modalFolderSelector ifNotNil:
		[:directory |
		self new directory: directory]! !

!MCDirectoryRepository class methodsFor: 'instance creation' stamp: 'cmm 4/22/2011 16:58'!
path: fullyQualifiedName 
	^ self directory: (FileDirectory on: fullyQualifiedName)! !

!MCDirectoryRepository methodsFor: 'accessing' stamp: 'ul 4/26/2011 04:11'!
allFileNames

	^directory entries 
		sort: [ :a :b | a modificationTime >= b modificationTime ];
		replace: [ :ea | ea name asMCVersionName ]! !

!MCDirectoryRepository methodsFor: 'accessing' stamp: 'cmm 4/22/2011 16:59'!
creationTemplate
	^ super creationTemplate
		ifNil:
			[ self creationTemplate: (self class creationTemplateLocation: self directory pathName).
			creationTemplate ]! !

!MCDirectoryRepository methodsFor: 'accessing' stamp: 'avi 10/9/2003 12:57'!
description
	^ directory pathName! !

!MCDirectoryRepository methodsFor: 'accessing' stamp: 'ab 7/6/2003 17:49'!
directory
	^ directory! !

!MCDirectoryRepository methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
directory: aDirectory
	directory := aDirectory! !

!MCDirectoryRepository methodsFor: 'comparing' stamp: ''!
hash
	^ directory pathName hash! !

!MCDirectoryRepository methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
initialize
	directory := FileDirectory default! !

!MCDirectoryRepository methodsFor: 'accessing' stamp: 'nk 11/2/2003 10:55'!
isValid
	^directory exists! !

!MCDirectoryRepository methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
readStreamForFileNamed: aString do: aBlock
	| file val |
	file := FileStream readOnlyFileNamed: (directory fullNameFor: aString).
	val := aBlock value: file.
	file close.
	^ val! !

!MCDirectoryRepository methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
writeStreamForFileNamed: aString replace: aBoolean do: aBlock
	| file sel |
	sel := aBoolean ifTrue: [#forceNewFileNamed:] ifFalse: [#newFileNamed:].
	file := FileStream perform: sel with: (directory fullNameFor: aString).
	aBlock value: file.
	file close.! !

MCDirectoryRepository subclass: #MCSubDirectoryRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCSubDirectoryRepository class methodsFor: 'user interface' stamp: ''!
description
	^ 'directory with subdirectories'! !

!MCSubDirectoryRepository methodsFor: 'enumeration' stamp: ''!
allDirectories
	| t1 t2 t3 |
	t1 := OrderedCollection new.
	t2 := OrderedCollection new.
	t1 addLast: directory.
	[t1 isEmpty]
		whileFalse: [t3 := t1 removeFirst.
			t2 add: t3.
			t3 entries
				do: [:t5 | t5 isDirectory
						ifTrue: [t1
								addLast: (t3 directoryNamed: t5 name)]]].
	^ t2! !

!MCSubDirectoryRepository methodsFor: 'enumeration' stamp: 'nsh 11/20/2011 00:52'!
allFileNames
	"sorting {entry. dirName. name}"

	| sorted |
	sorted := SortedCollection sortBlock: [:a :b |
		a first modificationTime >= b first modificationTime ].
	self allDirectories
		do: [:dir | dir entries
				do: [:ent | ent isDirectory
						ifFalse: [sorted add: {ent. dir fullName. ent name}]]].
	^ sorted
		collect: [:ea | ea third asMCVersionName]! !

!MCSubDirectoryRepository methodsFor: 'user interface' stamp: 'ul 3/23/2011 07:21'!
description
	^ directory pathName, FileDirectory slash, '*'! !

!MCSubDirectoryRepository methodsFor: 'as yet unclassified' stamp: ''!
findFullNameForReading: t1 
	| t2 |
	t2 := SortedCollection
				sortBlock: [:t3 :t4 | t4 first modificationTime < t3 first modificationTime].
	self allDirectories
		do: [:t3 | t3 entries
				do: [:t4 | t4 isDirectory
						ifFalse: [t4 name = t1
								ifTrue: [t2 add: {t4. t3 fullNameFor: t4 name}]]]].
	^ (t2
		at: 1
		ifAbsent: [^ nil]) second! !

!MCSubDirectoryRepository methodsFor: 'as yet unclassified' stamp: ''!
findFullNameForWriting: t1 
	| t2 t3 t4 t5 t6 |
	t3 := directory splitNameVersionExtensionFor: t1.
	t5 := t3 first , '*'.
	t2 := SortedCollection
				sortBlock: [:t7 :t8 | t7 first = t8 first
						ifTrue: [t7 second = t8 second
								ifTrue: [t7 third fullName size < t8 third fullName size]
								ifFalse: [t7 second < t8 second]]
						ifFalse: [t7 first > t8 first]].
	t6 := Time totalSeconds.
	t4 := directory pathParts size.
	self allDirectories
		do: [:t7 | 
			| t8 t9 t10 |
			t8 := t7 pathParts allButFirst: t4.
			t9 := (t8
						select: [:t11 | t5 match: t11]) size.
			t10 := t7 entries
						collect: [:t11 | (t11 isDirectory not
									and: [t5 match: t11 name])
								ifTrue: [t6 - t11 modificationTime]
								ifFalse: [SmallInteger maxVal]].
			t10 := t10 isEmpty
						ifTrue: [SmallInteger maxVal]
						ifFalse: [t10 min].
			t2 add: {t9. t10. t7}].
	^ t2 first third fullNameFor: t1! !

!MCSubDirectoryRepository methodsFor: 'as yet unclassified' stamp: ''!
readStreamForFileNamed: t1 do: t2 
	| t3 t4 |
	t3 := FileStream
				readOnlyFileNamed: (self findFullNameForReading: t1).
	t4 := t2 value: t3.
	t3 close.
	^ t4! !

!MCSubDirectoryRepository methodsFor: 'as yet unclassified' stamp: ''!
writeStreamForFileNamed: t1 replace: t2 do: t3 
	| t4 |
	t4 := t2
				ifTrue: [FileStream
						forceNewFileNamed: (self findFullNameForReading: t1)]
				ifFalse: [FileStream
						newFileNamed: (self findFullNameForWriting: t1)].
	t3 value: t4.
	t4 close! !

!MCFileBasedRepository class methodsFor: 'release' stamp: 'ar 2/26/2010 23:03'!
cleanUp
	"Flush caches"

	self flushAllCaches.! !

!MCFileBasedRepository class methodsFor: 'release' stamp: 'avi 2/3/2005 00:43'!
flushAllCaches
	self allSubInstancesDo: [:ea | ea flushCache]! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'ab 8/21/2003 00:35'!
allFileNames
	self subclassResponsibility! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'cmm 3/6/2011 16:24'!
allFileNamesForVersionNamed: aMCVersionName 
	^ self
		filterFileNames: self readableFileNames
		forVersionNamed: aMCVersionName! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'avi 9/17/2005 16:40'!
allFileNamesOrCache
	^ allFileNames ifNil: [self allFileNames]! !

!MCFileBasedRepository methodsFor: 'overriding' stamp: 'cmm 8/8/2012 14:34'!
allPackageAndBranchNames
	^ self validNames: #packageAndBranchName! !

!MCFileBasedRepository methodsFor: 'overriding' stamp: 'cmm 8/8/2012 14:34'!
allPackageNames
	^ self validNames: #packageName! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'ul 3/22/2011 22:02'!
allVersionNames

	^self readableFileNames collect: [ :each | each versionName ]! !

!MCFileBasedRepository methodsFor: 'overriding' stamp: 'cmm 4/24/2011 18:41'!
basicStoreVersion: aMCVersionOrConfiguration 
	self
		writeStreamForFileNamed: aMCVersionOrConfiguration fileName
		do: [ : s | aMCVersionOrConfiguration fileOutOn: s ].
	aMCVersionOrConfiguration isCacheable ifTrue:
		[ cache ifNil: [ cache := Dictionary new ].
		self resizeCache: cache.
		cache
			at: aMCVersionOrConfiguration fileName
			put: aMCVersionOrConfiguration ]! !

!MCFileBasedRepository methodsFor: 'private' stamp: 'stephaneducasse 2/4/2006 20:47'!
cache
	^ cache ifNil: [cache := Dictionary new]! !

!MCFileBasedRepository methodsFor: 'private' stamp: 'ar 1/4/2010 17:21'!
cacheAllFileNamesDuring: aBlock
	allFileNames ifNotNil:[^aBlock value].
	allFileNames := self allFileNames.
	^ aBlock ensure: [allFileNames := nil]! !

!MCFileBasedRepository methodsFor: 'private' stamp: 'bf 6/9/2005 15:47'!
cachedFileNames
	^cache == nil
		ifTrue: [#()]
		ifFalse: [cache keys]! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'stephaneducasse 2/4/2006 20:47'!
canReadFileNamed: aString
	| reader |
	reader := MCVersionReader readerClassForFileNamed: aString.
	^ reader notNil! !

!MCFileBasedRepository methodsFor: 'overriding' stamp: 'avi 9/17/2005 16:40'!
closestAncestorVersionFor: anAncestry ifNone: errorBlock
	^ self cacheAllFileNamesDuring:
		[super closestAncestorVersionFor: anAncestry ifNone: errorBlock]! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'cmm 3/6/2011 16:24'!
filterFileNames: aCollection forVersionNamed: aMCVersionName 
	^ aCollection select:
		[ : ea | aMCVersionName = ea ]! !

!MCFileBasedRepository methodsFor: 'private' stamp: 'cmm 4/7/2011 12:37'!
flushCache
	cache := allFileNames := nil! !

!MCFileBasedRepository methodsFor: 'versions' stamp: 'cmm 8/9/2012 21:16'!
includesVersionNamed: aString 
	| comparable |
	comparable := ((aString endsWith: '.mcz') and: [ aString size > 4 ])
		ifTrue:
			[ aString
				copyFrom: 1
				to: aString size - 4 ]
		ifFalse: [ aString ].
	^ self allVersionNames includes: comparable! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'avi 1/22/2004 13:34'!
loadVersionFromFileNamed: aString
	^ self versionReaderForFileNamed: aString do: [:r | r version]! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'avi 9/17/2005 18:37'!
loadVersionInfoFromFileNamed: aString
	^ self versionReaderForFileNamed: aString do: [:r | r info]
	! !

!MCFileBasedRepository methodsFor: 'private' stamp: 'avi 9/17/2005 16:52'!
maxCacheSize
	^ 8! !

!MCFileBasedRepository methodsFor: 'overriding' stamp: 'avi 2/28/2004 18:32'!
morphicOpen: aWorkingCopy
	(MCFileRepositoryInspector repository: self workingCopy: aWorkingCopy)
		show! !

!MCFileBasedRepository methodsFor: 'overriding' stamp: 'nice 6/11/2010 21:51'!
notifyList
	(self allFileNames includes: 'notify') ifFalse: [^ #()].
	^ self readStreamForFileNamed: 'notify' do:
		[:s |
		s upToEnd lines]! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'ul 5/8/2011 03:26'!
readableFileNames
	"Answer an Array of MCVersionNames representing every file in this repository; first the ones from the cache (whether or not they still exist in the repository) followed by every other file in this repository that Monticello can read."
	| all cached new |
	all := self allFileNamesOrCache.	"from repository"
	cached := self cachedFileNames.	"in memory"
	"Create a sparse Set, so we can avoid #= for MCVersionNames during the difference calculation."
	new := all difference: (
		(Set new: (cached size * 8 min: all size))
			addAll: cached;
			yourself).
	^ (cached asArray, new)
		select: [:ea | self canReadFileNamed: ea]! !

!MCFileBasedRepository methodsFor: 'private' stamp: 'avi 9/18/2005 22:43'!
resizeCache: aDictionary
	[aDictionary size <= self maxCacheSize] whileFalse:
		[aDictionary removeKey: aDictionary keys atRandom]! !

!MCFileBasedRepository methodsFor: 'overriding' stamp: 'cmm 8/8/2012 14:33'!
validNames: selectorSymbol
	| answer |
	answer := Set new.
	self allFileNamesOrCache do:
		[ : each | | versionName |
		versionName := each asMCVersionName.
		versionName isValid ifTrue: [ answer add: (versionName perform: selectorSymbol) ] ].
	^ answer! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'avi 9/17/2005 18:37'!
versionInfoFromFileNamed: aString
	self cache at: aString ifPresent: [:v | ^ v info].
	^ self loadVersionInfoFromFileNamed: aString! !

!MCFileBasedRepository methodsFor: 'versions' stamp: 'cmm 3/6/2011 16:18'!
versionNamed: aMCVersionName
	"For FileBased repositories, aMCVersionName must have the appropriate extension!!  :-("
	| v |
	v := self cache at: aMCVersionName ifAbsent: [self loadVersionFromFileNamed: aMCVersionName].
	self resizeCache: cache.
	(v notNil and: [v isCacheable]) ifTrue: [cache at: aMCVersionName asMCVersionName put: v].
	^ v! !

!MCFileBasedRepository methodsFor: 'versions' stamp: 'bf 5/29/2012 12:02'!
versionNamesForPackageNamed: packageName
	^ Array streamContents:
		[ : stream | | wantBranch |
		wantBranch := packageName includes: $..
		self allFileNamesOrCache do:
			[ : each | | mcVersionName branchName |
			mcVersionName := each asMCVersionName.
			branchName := wantBranch
				ifTrue: [mcVersionName packageAndBranchName]
				ifFalse: [mcVersionName packageName].
			packageName = branchName ifTrue: [ stream nextPut: mcVersionName ] ] ]! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'ul 12/12/2009 14:10'!
versionReaderForFileNamed: aString do: aBlock
	^ self
		readStreamForFileNamed: aString
		do: [:s |
			(MCVersionReader readerClassForFileNamed: aString) ifNotNil:
				[:class | aBlock value: (class on: s fileName: aString)]]
! !

!MCFileBasedRepository methodsFor: 'versions' stamp: 'cmm 3/6/2011 16:27'!
versionWithInfo: aVersionInfo ifAbsent: errorBlock
	(self allFileNamesForVersionNamed: aVersionInfo versionName) do:
		[:fileName | | version |
		version := self versionNamed: fileName.
		version info = aVersionInfo ifTrue: [^ version]].
	^ errorBlock value! !

!MCFileBasedRepository methodsFor: 'private-files' stamp: 'avi 10/31/2003 14:32'!
writeStreamForFileNamed: aString do: aBlock
	^ self writeStreamForFileNamed: aString replace: false do: aBlock! !

MCFileBasedRepository subclass: #MCFtpRepository
	instanceVariableNames: 'host directory user password connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCFtpRepository class methodsFor: 'as yet unclassified' stamp: ''!
creationTemplate
	^ 'MCFtpRepository
	host: ''modules.squeakfoundation.org''
	directory: ''mc''
	user: ''squeak''
	password: ''squeak'''! !

!MCFtpRepository class methodsFor: 'as yet unclassified' stamp: ''!
description
	^ 'FTP'! !

!MCFtpRepository class methodsFor: 'as yet unclassified' stamp: ''!
fillInTheBlankRequest
	^ 'FTP Repository:'! !

!MCFtpRepository class methodsFor: 'as yet unclassified' stamp: ''!
host: t1 directory: t2 user: t3 password: t4 
	^ self new host: t1;
		 directory: t2;
		 user: t3;
		 password: t4! !

!MCFtpRepository class methodsFor: 'as yet unclassified' stamp: ''!
morphicConfigure
	^ self fillInTheBlankConfigure! !

!MCFtpRepository class methodsFor: 'as yet unclassified' stamp: ''!
templateCreationSelector
	^ #host:directory:user:password:! !

!MCFtpRepository methodsFor: 'required' stamp: ''!
allFileNames
	^ self
		clientDo: [:t1 | self parseDirectoryListing: t1 getDirectory]! !

!MCFtpRepository methodsFor: 'as yet unclassified' stamp: ''!
clientDo: t1 
	| t2 |
	t2 := FTPClient openOnHostNamed: host.
	t2 loginUser: user password: password.
	directory isEmpty
		ifFalse: [t2 changeDirectoryTo: directory].
	^ [t1 value: t2]
		ensure: [t2 close]! !

!MCFtpRepository methodsFor: 'required' stamp: ''!
description
	^ 'ftp://' , user , '@' , host , '/' , directory! !

!MCFtpRepository methodsFor: 'as yet unclassified' stamp: ''!
directory: t1 
	directory := t1! !

!MCFtpRepository methodsFor: 'as yet unclassified' stamp: ''!
host: t1 
	host := t1! !

!MCFtpRepository methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2011 14:54'!
parseDirectoryListing: aString
	| stream files line tokens |
	stream := aString readStream.
	files := OrderedCollection new.
	[stream atEnd] whileFalse:
		[line := stream nextLine.
		tokens := line findTokens: ' '.
		tokens size > 2 ifTrue: [files add: tokens last asMCVersionName]].
	^ files! !

!MCFtpRepository methodsFor: 'as yet unclassified' stamp: ''!
password: t1 
	password := t1! !

!MCFtpRepository methodsFor: 'required' stamp: ''!
readStreamForFileNamed: t1 do: t2 
	^ self
		clientDo: [:t3 | 
			| t4 |
			t3 binary.
			t4 := RWBinaryOrTextStream on: String new.
			t4
				nextPutAll: (t3 getFileNamed: t1).
			t2 value: t4 reset]! !

!MCFtpRepository methodsFor: 'as yet unclassified' stamp: ''!
user: t1 
	user := t1! !

!MCFtpRepository methodsFor: 'required' stamp: ''!
writeStreamForFileNamed: t1 replace: t2 do: t3 
	| t4 |
	t4 := RWBinaryOrTextStream on: String new.
	t3 value: t4.
	self
		clientDo: [:t5 | 
			t5 binary.
			t5 putFileStreamContents: t4 reset as: t1]! !

MCFileBasedRepository subclass: #MCHttpRepository
	instanceVariableNames: 'location user password readerCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCHttpRepository class methodsFor: 'class initialization' stamp: ''!
clearPasswords
	self
		allSubInstancesDo: [:t1 | t1 password: '']! !

!MCHttpRepository class methodsFor: 'ui-support' stamp: 'cmm 1/25/2011 13:00'!
creationTemplate
	^self creationTemplateLocation: 'http://www.squeaksource.com/ProjectName'
		user: 'squeak'
		password: 'squeak'
! !

!MCHttpRepository class methodsFor: 'ui-support' stamp: 'bf 4/14/2005 15:27'!
creationTemplateLocation: location user: user password: password
	^
'MCHttpRepository
	location: {1}
	user: {2}
	password: {3}' format: {location printString. user printString. password printString}! !

!MCHttpRepository class methodsFor: 'ui-support' stamp: 'ab 7/24/2003 21:20'!
description
	^ 'HTTP'! !

!MCHttpRepository class methodsFor: 'ui-support' stamp: 'bkv 2/18/2004 21:00'!
fillInTheBlankRequest
	^ 'HTTP Repository:'
			! !

!MCHttpRepository class methodsFor: 'ui-support' stamp: 'ab 7/24/2003 21:32'!
location: location user: user password: password
	^ self new
		location: location;
		user: user;
		password: password! !

!MCHttpRepository class methodsFor: 'ui-support' stamp: 'bkv 2/18/2004 21:01'!
morphicConfigure
	^ self fillInTheBlankConfigure! !

!MCHttpRepository methodsFor: 'required' stamp: 'fbs 6/9/2011 07:42'!
allFileNames
	| index |
	[self displayProgress: 'Updating ', self description during:[
		index := HTTPSocket httpGet: self locationWithTrailingSlash, '?C=M;O=D' args: nil user: self user passwd: self password.
	]] on: NetworkError do: [ :e | self error: 'Could not access ', location, '(', e className, ')'].
	index isString ifTrue: [self error: 'Could not access ', location].
	^ self parseFileNamesFromStream: index	! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
asCreationTemplate
	^ self class
		creationTemplateLocation: location
		user: user
		password: password! !

!MCHttpRepository methodsFor: 'required' stamp: ''!
description
	^ location! !

!MCHttpRepository methodsFor: 'required' stamp: 'ul 8/2/2011 20:03'!
displayProgress: label during: workBlock
	| nextUpdateTime |
	nextUpdateTime := 0.
	^label displayProgressFrom: 0.0 to: 1.0 during:[:bar|
			workBlock on: HTTPProgress do:[:ex|
				(ex total == nil or:[ex amount == nil]) ifFalse:[
					(nextUpdateTime < Time millisecondClockValue 
						or:[ex total = ex amount]) ifTrue:[
							bar value: ex amount asFloat / ex total asFloat.
							nextUpdateTime := Time millisecondClockValue + 100.
					].
				].
				ex resume.
			]
		].
! !

!MCHttpRepository methodsFor: 'required' stamp: ''!
flushCache
	super flushCache.
	readerCache := nil! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
location: t1 
	location := t1! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
locationWithTrailingSlash
	^ (location endsWith: '/')
		ifTrue: [location]
		ifFalse: [location , '/']! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2011 14:53'!
parseFileNamesFromStream: aStream
	| names fullName |
	names := OrderedCollection new.
	[aStream atEnd] whileFalse:
		[[aStream upTo: $<. {$a. $A. nil} includes: aStream next] whileFalse.
		aStream upTo: $".
		aStream atEnd ifFalse: [
			fullName := aStream upTo: $".
			names add: fullName unescapePercents asMCVersionName ]].
	^ names! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
password
	| t1 |
	self
		userAndPasswordFromSettingsDo: [:t2 :t3 | ^ t3].
	self user isEmpty
		ifTrue: [^ password
				ifNil: ['']].
	[password isEmptyOrNil]
		whileTrue: [t1 := UIManager default request: 'User name for ' , String cr , location initialAnswer: self user.
			t1 isEmpty
				ifTrue: [^ password].
			self user: t1.
			password := UIManager default requestPassword: 'Password for "' , self user , '" at ' , String cr , location].
	^ password! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
password: t1 
	password := t1! !

!MCHttpRepository methodsFor: 'required' stamp: ''!
readStreamForFileNamed: t1 do: t2 
	| t3 |
	self
		displayProgress: 'Downloading ' , t1
		during: [t3 := HTTPSocket
						httpGet: (self urlForFileNamed: t1)
						args: nil
						user: self user
						passwd: self password].
	^ t3 isString
		ifFalse: [t2 value: t3]! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
urlForFileNamed: t1 
	^ self locationWithTrailingSlash , t1 encodeForHTTP! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
user
	self
		userAndPasswordFromSettingsDo: [:t1 :t2 | ^ t1].
	^ user
		ifNil: ['']! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
user: t1 
	user := t1! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
userAndPasswordFromSettingsDo: t1 
	Settings
		ifNotNil: [Settings
				keysAndValuesDo: [:t2 :t3 | | t4 t5 | (t2 asLowercase beginsWith: 'account')
						ifTrue: [t5 := t3 findTokens: '	 '.
							(t5 first match: location)
								ifTrue: [t4 := t5 second.
									(t4 includes: $:)
										ifFalse: [t4 := (Base64MimeConverter mimeDecodeToChars: t4 readStream) contents].
									t4 := t4 findTokens: $:.
									^ t1 value: t4 first value: t4 second]]]].
	^ nil! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
versionReaderForFileNamed: t1 
	readerCache
		ifNil: [readerCache := Dictionary new].
	^ readerCache
		at: t1
		ifAbsent: [self resizeCache: readerCache.
			super
				versionReaderForFileNamed: t1
				do: [:t2 | t2
						ifNotNil: [readerCache at: t1 put: t2]]]! !

!MCHttpRepository methodsFor: 'as yet unclassified' stamp: ''!
versionReaderForFileNamed: t1 do: t2 
	^ (self versionReaderForFileNamed: t1)
		ifNotNil: t2! !

!MCHttpRepository methodsFor: 'required' stamp: 'ar 7/21/2010 19:53'!
writeStreamForFileNamed: aString replace: ignoreBoolean do: aBlock
	| stream response statusLine code |
	stream := RWBinaryOrTextStream on: String new.
	aBlock value: stream.
	self displayProgress: 'Uploading ', aString during:[
		response := HTTPSocket
					httpPut: stream contents
					to: (self urlForFileNamed: aString)
					user: self user
					passwd: self password.
	].
	"More robust handling of HTTP responses. Instead of enumerating
	all possible return codes and http versions, do a quick parse"
	(response beginsWith: 'HTTP/') ifTrue:[
		"Looks like an HTTP header, not some error message"
		statusLine := response copyUpTo: Character cr.
		code := [(statusLine findTokens: ' ') second asInteger] on: Error do:[].
	].
	(code isInteger and:[code between: 200 and: 299]) 
		ifFalse:[self error: response].! !

MCFileBasedRepository subclass: #MCSMCacheRepository
	instanceVariableNames: 'smCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCSMCacheRepository class methodsFor: 'instance creation' stamp: ''!
description
	^ 'SqueakMap Cache'! !

!MCSMCacheRepository class methodsFor: 'instance creation' stamp: ''!
morphicConfigure
	^ self new! !

!MCSMCacheRepository methodsFor: 'accessing' stamp: ''!
allFullFileNames
	| t1 |
	t1 := smCache map installedPackages
				select: [:t2 | t2 isCached].
	^ Array
		streamContents: [:t2 | t1
				do: [:t3 | 
					| t4 |
					t4 := t3 cacheDirectory.
					(t4 fileNamesMatching: '*.mcz')
						do: [:t5 | t2
								nextPut: (t4 fullNameFor: t5)]]]! !

!MCSMCacheRepository methodsFor: 'accessing' stamp: ''!
description
	^ smCache directory pathName! !

!MCSMCacheRepository methodsFor: 'accessing' stamp: ''!
directory
	^ smCache directory! !

!MCSMCacheRepository methodsFor: 'accessing' stamp: ''!
directory: t1 
	^ self! !

!MCSMCacheRepository methodsFor: 'accessing' stamp: ''!
fullNameFor: t1 
	^ self allFullFileNames
		detect: [:t2 | (self directory localNameFor: t2)
				= t1]
		ifNone: []! !

!MCSMCacheRepository methodsFor: 'comparing' stamp: ''!
hash
	^ smCache hash! !

!MCSMCacheRepository methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	Smalltalk
		at: #SMSqueakMap
		ifPresent: [:t1 | smCache := t1 default cache]! !

!MCSMCacheRepository methodsFor: 'testing' stamp: ''!
isValid
	^ smCache notNil
		and: [self directory exists]! !

!MCSMCacheRepository methodsFor: 'file streaming' stamp: ''!
readStreamForFileNamed: t1 do: t2 
	| t3 t4 |
	t4 := self fullNameFor: t1.
	t4
		ifNil: [^ MCCacheRepository default readStreamForFileNamed: t1 do: t2].
	t3 := FileStream readOnlyFileNamed: t4.
	^ [t2 value: t3]
		ensure: [t3 close]! !

!MCSMCacheRepository methodsFor: 'accessing' stamp: ''!
smCache
	^ smCache! !

!MCSMCacheRepository methodsFor: 'accessing' stamp: ''!
smCache: t1 
	smCache := t1.
	self directory: t1 directory! !

!MCSMCacheRepository methodsFor: 'file streaming' stamp: ''!
writeStreamForFileNamed: t1 replace: t2 do: t3 
	^ MCCacheRepository default
		writeStreamForFileNamed: t1
		replace: t2
		do: t3! !

MCRepository subclass: #MCGOODSRepository
	instanceVariableNames: 'hostname port connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCGOODSRepository commentStamp: 'cmm 3/6/2011 16:56' prior: 0!
A MCGOODSRepository simply stores a Dictionary of aVersionInfo-> aMCVersion.!

!MCGOODSRepository class methodsFor: 'as yet unclassified' stamp: ''!
creationTemplate
	^ 'MCGOODSRepository
	host: ''localhost''
	port: 6100'! !

!MCGOODSRepository class methodsFor: 'as yet unclassified' stamp: ''!
description
	^ 'GOODS'! !

!MCGOODSRepository class methodsFor: 'as yet unclassified' stamp: ''!
fillInTheBlankRequest
	^ 'GOODS Repository:'! !

!MCGOODSRepository class methodsFor: 'as yet unclassified' stamp: ''!
host: t1 port: t2 
	^ self new host: t1;
		 port: t2! !

!MCGOODSRepository class methodsFor: 'as yet unclassified' stamp: ''!
morphicConfigure
	^ self fillInTheBlankConfigure! !

!MCGOODSRepository methodsFor: 'packages' stamp: 'cmm 3/6/2011 16:56'!
allPackageNames
	^ self root collect:
		[ : ea | ea package name ]! !

!MCGOODSRepository methodsFor: 'as yet unclassified' stamp: ''!
basicStoreVersion: t1 
	self root at: t1 info put: t1.
	self db commit! !

!MCGOODSRepository methodsFor: 'as yet unclassified' stamp: ''!
db
	(connection isNil
			or: [connection isConnected not])
		ifTrue: [connection := Smalltalk
						at: #KKDatabase
						ifPresent: [:t1 | t1 onHost: hostname port: port]].
	^ connection! !

!MCGOODSRepository methodsFor: 'as yet unclassified' stamp: ''!
description
	^ 'goods://' , hostname asString , ':' , port asString! !

!MCGOODSRepository methodsFor: 'as yet unclassified' stamp: ''!
host: t1 
	hostname := t1! !

!MCGOODSRepository methodsFor: 'as yet unclassified' stamp: 'cmm 3/6/2011 17:00'!
includesVersionNamed: aString 
	^ (self versionNamed: aString) notNil! !

!MCGOODSRepository methodsFor: 'as yet unclassified' stamp: ''!
port: t1 
	port := t1! !

!MCGOODSRepository methodsFor: 'as yet unclassified' stamp: ''!
root
	self db root
		ifNil: [self db root: Dictionary new].
	^ self db root! !

!MCGOODSRepository methodsFor: 'as yet unclassified' stamp: 'cmm 3/6/2011 17:00'!
versionNamed: aString 
	| versionName |
	versionName := aString asMCVersionName.
	self root keysDo:
		[ : each | each versionName = versionName ifTrue: [ ^ each ] ].
	^ nil! !

!MCGOODSRepository methodsFor: 'as yet unclassified' stamp: 'cmm 3/6/2011 17:03'!
versionNamesForPackageNamed: aString 
	^ Array streamContents:
		[ : stream | self root keysDo:
			[ : each | each versionName packageName = aString ifTrue: [ stream nextPut: each ] ] ]! !

!MCGOODSRepository methodsFor: 'as yet unclassified' stamp: ''!
versionWithInfo: t1 ifAbsent: t2 
	^ self root at: t1 ifAbsent: t2! !

!MCRepository class methodsFor: 'configuring' stamp: 'ab 8/21/2003 00:30'!
allConcreteSubclasses
	^ self withAllSubclasses reject: [:ea | ea isAbstract]! !

!MCRepository class methodsFor: 'configuring' stamp: 'bkv 2/18/2004 20:59'!
creationTemplate
	self subclassResponsibility.! !

!MCRepository class methodsFor: 'configuring' stamp: 'ab 8/21/2003 00:29'!
description
	^ nil! !

!MCRepository class methodsFor: 'external settings' stamp: ''!
fetchExternalSettingsIn: t1 
	| t2 |
	(t1 fileExists: self settingsFileName)
		ifFalse: [^ self].
	t2 := t1 readOnlyFileNamed: self settingsFileName.
	t2
		ifNotNil: [[Settings := ExternalSettings parseServerEntryArgsFrom: t2]
				ensure: [t2 close]]! !

!MCRepository class methodsFor: 'configuring' stamp: 'bkv 2/18/2004 21:05'!
fillInTheBlankConfigure
	^ self fillInTheBlankConfigure: self creationTemplate
			! !

!MCRepository class methodsFor: 'configuring' stamp: 'stephaneducasse 2/4/2006 20:47'!
fillInTheBlankConfigure: aTemplateString
	| chunk repo |
	
	aTemplateString ifNil: [ ^ false ].
	chunk := FillInTheBlankMorph 
			request: self fillInTheBlankRequest
			initialAnswer: aTemplateString
			centerAt: Sensor cursorPoint
			inWorld: World
			onCancelReturn: nil
			acceptOnCR: false
			answerExtent: 400@120.
			
	chunk 
		ifNotNil: [ 
			repo := self readFrom: chunk readStream.
			repo creationTemplate: chunk. 
	].

	^ repo! !

!MCRepository class methodsFor: 'configuring' stamp: 'bkv 2/18/2004 20:58'!
fillInTheBlankRequest
	self subclassResponsibility.! !

!MCRepository class methodsFor: 'class initialization' stamp: ''!
initialize
	ExternalSettings registerClient: self! !

!MCRepository class methodsFor: 'configuring' stamp: 'ab 8/21/2003 12:59'!
isAbstract
	^ self description isNil! !

!MCRepository class methodsFor: 'instance creation' stamp: 'ar 12/16/2010 09:41'!
location: urlOrPath
	"Answer an MCRepository for the given url or path. Accepted locations are:
		- http, and ftp urls (i.e., http://source.squeak.org/trunk)
		- directory paths (i.e., C:\Squeak\packages)
		- directory matches (i.e., C:\Squeak\packages\*)
	"

	^self location: urlOrPath username: '' password: ''! !

!MCRepository class methodsFor: 'instance creation' stamp: 'cmm 8/2/2012 15:17'!
location: urlOrPath username: user password: pass
	"Answer an MCRepository for the given url or path. Accepted locations are:
		- http, and ftp urls (i.e., http://source.squeak.org/trunk)
		- directory paths (i.e., C:\Squeak\packages)
		- directory matches (i.e., C:\Squeak\packages\*)
	If provided, the supplied user name and password will be used."

	| url |
	(urlOrPath findString: '://') > 0 ifTrue:[
		url := urlOrPath asUrl.
		^ url scheme caseOf: {
			['ftp'] -> [MCFtpRepository 
							host: url authority
							 directory: url pathString allButFirst
							user: user 
							password: user].
			['http'] -> [MCHttpRepository 
							location: urlOrPath 
							user: user 
							password: pass].
		} otherwise:[self error: 'Unsupported scheme: ', url scheme].
	].

	(urlOrPath endsWith: '*') ifTrue:[
		^MCSubDirectoryRepository new 
				directory: (FileDirectory on: urlOrPath allButLast)].

	^MCDirectoryRepository
			directory: (FileDirectory on: urlOrPath)! !

!MCRepository class methodsFor: 'configuring' stamp: 'ab 7/24/2003 21:01'!
morphicConfigure
	^ self new! !

!MCRepository class methodsFor: 'external settings' stamp: ''!
releaseExternalSettings
	Settings := nil! !

!MCRepository class methodsFor: 'external settings' stamp: ''!
settingsFileName
	^ 'mcSettings'! !

!MCRepository methodsFor: 'testing' stamp: 'ab 8/21/2003 12:36'!
= other
	^ other species = self species and: [other description = self description]! !

!MCRepository methodsFor: 'packages' stamp: 'cmm 8/14/2012 16:00'!
allPackageAndBranchNames
	"Currently this function is only supported by FileBased repositories."
	^ self allPackageNames! !

!MCRepository methodsFor: 'packages' stamp: 'cmm 3/2/2011 22:32'!
allPackageNames
	self subclassResponsibility! !

!MCRepository methodsFor: 'versions' stamp: 'cmm 3/12/2011 11:41'!
allVersionsDo: aBlock
	self allPackageNames asArray sort
		do:
			[ : eachPackageName | | sortedVersions |
			sortedVersions := (self versionNamesForPackageNamed: eachPackageName) sort:
				[ : a : b | a versionNumber < b versionNumber ].
			sortedVersions
				do:
					[ : eachVersionName | (self versionNamed: eachVersionName) ifNotNil:
						[ : ver | aBlock value: ver ] ]
				displayingProgress:
					[ : eachVersionName | 'Importing ' , eachVersionName ] ]
		displayingProgress:
			[ : eachPackageName | 'Importing versions of ' , eachPackageName ]! !

!MCRepository methodsFor: 'accessing' stamp: 'avi 8/31/2004 01:08'!
alwaysStoreDiffs
	^ storeDiffs ifNil: [false]! !

!MCRepository methodsFor: 'accessing' stamp: 'bkv 2/18/2004 20:48'!
asCreationTemplate
	^ self creationTemplate! !

!MCRepository methodsFor: 'private' stamp: 'avi 8/26/2004 14:20'!
basicStoreVersion: aVersion
	self subclassResponsibility! !

!MCRepository methodsFor: 'private' stamp: 'cmm 3/6/2011 20:15'!
cacheAllFileNamesDuring: aBlock
	"FileBasedRepository's can only access all version-names, therefore this is provided to allow client-code to direct caching of getting all filenames.  Other types of repositories offer more sophisticated kinds of access, so they don't need to cache, so simply run the block."
	^ aBlock value! !

!MCRepository methodsFor: 'accessing' stamp: 'ul 12/12/2009 14:10'!
closestAncestorVersionFor: anAncestry ifNone: errorBlock
	anAncestry breadthFirstAncestorsDo:
		[:ancestorInfo |
		(self versionWithInfo: ancestorInfo) ifNotNil: [:v | ^ v]].
	^ errorBlock value! !

!MCRepository methodsFor: 'versions' stamp: 'cmm 8/15/2011 17:26'!
copyAllFrom: aMCRepository 
	"Copy all MCVersions from aMCRepository to the receiver."
	self cacheAllFileNamesDuring:
		[ aMCRepository cacheAllFileNamesDuring:
			[ | pkgCount |
			pkgCount := 0.
			'Copy all package versions from ' , aMCRepository description
				displayProgressFrom: 0
				to: aMCRepository allPackageNames size
				during:
					[ : pkgBar | aMCRepository allPackageNames asArray sort do:
						[ : eachPackageName | | versions verCount |
						verCount := 0.
						versions := (aMCRepository versionNamesForPackageNamed: eachPackageName) difference: (self versionNamesForPackageNamed: eachPackageName).
						'Progress for ' , eachPackageName
							displayProgressFrom: 0
							to: versions size
							during:
								[ : verBar | versions do:
									[ : eachVersionName | (aMCRepository versionNamed: eachVersionName) ifNotNil:
										[ : ver | self storeVersion: ver ].
									verBar value: (verCount := verCount + 1) ].
								pkgBar value: (pkgCount := pkgCount + 1) ] ] ] ] ]! !

!MCRepository methodsFor: 'versions' stamp: 'cmm 8/13/2011 19:18'!
copyImageVersions
	"For each package contained in the receiver, copy the version of that package which is currently loaded in this image.  If no version of a package is loaded in the image, nothing is copied for that package."
	self cacheAllFileNamesDuring:
		[ self allPackageNames do:
			[ : eachPkgName | MCWorkingCopy allManagers
				detect: [ : each | each packageName = eachPkgName ]
				ifFound:
					[ : loaded | loaded ancestors do:
						[ : infoToCopy | (self includesVersionNamed: infoToCopy versionName) ifFalse:
							[ (MCRepositoryGroup default versionWithInfo: infoToCopy)
								ifNil: [ Warning signal: infoToCopy name , ' not found in RepositoryGroup default.' ]
								ifNotNilDo:
									[ : ver | self storeVersion: ver ] ] ] ]
				ifNone: [ "Image specifies no version to copy." ] ] ]! !

!MCRepository methodsFor: 'accessing' stamp: 'bkv 2/18/2004 20:46'!
creationTemplate
	^ creationTemplate! !

!MCRepository methodsFor: 'accessing' stamp: 'cmm 4/22/2011 15:52'!
creationTemplate: aString 
	creationTemplate := aString! !

!MCRepository methodsFor: 'accessing' stamp: 'avi 10/9/2003 12:53'!
description
	^ self class name! !

!MCRepository methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
doAlwaysStoreDiffs
	storeDiffs := true! !

!MCRepository methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
doNotAlwaysStoreDiffs
	storeDiffs := false! !

!MCRepository methodsFor: 'testing' stamp: 'ab 8/21/2003 12:36'!
hash
	^ self description hash! !

!MCRepository methodsFor: 'versions' stamp: 'cmm 8/2/2012 23:02'!
highestNumberedVersionForPackageNamed: aString 
	^ self versionNamed: (self highestNumberedVersionNameForPackageNamed: aString)! !

!MCRepository methodsFor: 'versions' stamp: 'bf 5/31/2012 11:43'!
highestNumberedVersionNameForPackageNamed: aString 
	^ (self versionNamesForPackageNamed: aString)
		ifEmpty: [ self error: aString , ' not found in ' , self asString ]
		ifNotEmptyDo:
			[ : versionNames | versionNames detectMax:
				[ : each | each versionNumber ] ]! !

!MCRepository methodsFor: 'versions' stamp: 'ab 8/21/2003 12:40'!
includesVersionNamed: aString
	self subclassResponsibility! !

!MCRepository methodsFor: 'testing' stamp: ''!
isValid
	^ true! !

!MCRepository methodsFor: 'versions' stamp: 'cmm 4/19/2011 21:11'!
missingAncestryDo: oneArgBlock 
	"Value oneArgBlock with each of the MCVersionInfo ancestry that is missing from this repository."
	self cacheAllFileNamesDuring:
		[ self allPackageNames do:
			[ : each | self
				missingAncestryForPackageNamed: each
				do: oneArgBlock ] ]! !

!MCRepository methodsFor: 'versions' stamp: 'cmm 4/19/2011 21:23'!
missingAncestryForPackageNamed: packageName do: oneArgBlock 
	| start |
	self cacheAllFileNamesDuring:
		[ start := self versionNamed: (self highestNumberedVersionNameForPackageNamed: packageName).
		self cacheAllFileNamesDuring:
			[ start info allAncestorsDo:
				[ : each | (self includesVersionNamed: each versionName) ifFalse: [ oneArgBlock value: each ] ] ] ]! !

!MCRepository methodsFor: 'ui' stamp: 'lr 9/26/2003 20:03'!
morphicOpen
	self morphicOpen: nil! !

!MCRepository methodsFor: 'ui' stamp: 'avi 2/28/2004 20:10'!
morphicOpen: aWorkingCopy
	(MCRepositoryInspector repository: self workingCopy: aWorkingCopy) show! !

!MCRepository methodsFor: 'accessing' stamp: 'avi 8/26/2004 14:27'!
notificationForVersion: aVersion
	^ MCVersionNotification version: aVersion repository: self! !

!MCRepository methodsFor: 'accessing' stamp: 'avi 8/26/2004 14:23'!
notifyList
	^ #()! !

!MCRepository methodsFor: 'versions' stamp: 'cmm 4/19/2011 21:42'!
obtainMissingAncestryFrom: sourceRepository 
	self cacheAllFileNamesDuring:
		[ self missingAncestryDo:
			[ : each | (sourceRepository includesVersionNamed: each versionName)
				ifTrue: [ self storeVersion: (sourceRepository versionNamed: each versionName) ]
				ifFalse: [ Notification signal: each versionName , ' not present in ' , sourceRepository asString ] ] ]! !

!MCRepository methodsFor: 'ui' stamp: 'bf 4/14/2005 17:30'!
openAndEditTemplateCopy
	^ self class fillInTheBlankConfigure: (self asCreationTemplate ifNil: [^nil])! !

!MCRepository methodsFor: 'versions' stamp: 'ul 5/8/2011 15:13'!
possiblyNewerVersionsOfAnyOf: versionNames 
	"Answer a collection of MCVersionNames which might be newer versions of the versions identified by versionNames."
	^self cacheAllFileNamesDuring: [
		versionNames
		inject: OrderedCollection new
		into:
			[ : coll : eachVersionName | | eachPackageName |
			eachPackageName := eachVersionName packageName.
			(self versionNamesForPackageNamed: eachPackageName) do:
				[ : eachInSelf | (eachInSelf versionNumber > eachVersionName versionNumber or:
					[ eachInSelf versionNumber = eachVersionName versionNumber and: [ eachInSelf author ~= eachVersionName author ] ]) ifTrue: [ coll add: eachInSelf ] ].
			coll ] ]! !

!MCRepository methodsFor: 'accessing' stamp: 'avi 8/31/2004 01:06'!
prepareVersionForStorage: aVersion
	^ self alwaysStoreDiffs
		ifTrue: [aVersion asDiffAgainst:
				 (self closestAncestorVersionFor: aVersion info ifNone: [^ aVersion])]
		ifFalse: [aVersion]! !

!MCRepository methodsFor: 'printing' stamp: 'mas 9/24/2003 04:21'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self description;
		nextPut: $).! !

!MCRepository methodsFor: 'accessing' stamp: 'cmm 3/4/2011 14:47'!
refresh
	"Subclasses override if necessary."! !

!MCRepository methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
sendNotificationsForVersion: aVersion
	| notification notifyList |
	notifyList := self notifyList.
	notifyList isEmpty ifFalse:
		[notification := self notificationForVersion: aVersion.
		notifyList do: [:ea | notification notify: ea]]! !

!MCRepository methodsFor: 'accessing' stamp: 'cmm 4/22/2011 16:34'!
storeVersion: aMCVersionOrConfiguration
	self basicStoreVersion: (self prepareVersionForStorage: aMCVersionOrConfiguration).
	self sendNotificationsForVersion: aMCVersionOrConfiguration! !

!MCRepository methodsFor: 'versions' stamp: 'cmm 3/6/2011 16:29'!
versionNamed: aMCVersionName
	"Answer the MCVersion with name, aMCVersionName, or nil if it doesn't exist in this repository."
	self subclassResponsibility! !

!MCRepository methodsFor: 'versions' stamp: 'cmm 3/3/2011 14:45'!
versionNamesForPackageNamed: aString
	"Answer a collection of MCVersionNames whose Package is named aString."
	self subclassResponsibility! !

!MCRepository methodsFor: 'versions' stamp: 'avi 10/9/2003 12:42'!
versionWithInfo: aVersionInfo
	^ self versionWithInfo: aVersionInfo ifAbsent: [nil]! !

!MCRepository methodsFor: 'versions' stamp: 'ab 8/16/2003 18:22'!
versionWithInfo: aVersionInfo ifAbsent: aBlock
	self subclassResponsibility ! !

!MCRepository methodsFor: 'ui' stamp: 'cmm 4/25/2011 08:07'!
wasRemoved
	"Subclasses may override to, for example, disconnect a db session."! !

MCRepository subclass: #MCWriteOnlyRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

MCWriteOnlyRepository subclass: #MCSMReleaseRepository
	instanceVariableNames: 'packageName user password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCSMReleaseRepository class methodsFor: 'as yet unclassified' stamp: ''!
creationTemplate
	^ 'MCSMReleaseRepository
	package: ''mypackage''
	user: ''squeak''
	password: ''squeak'''! !

!MCSMReleaseRepository class methodsFor: 'as yet unclassified' stamp: ''!
description
	^ 'SqueakMap Release'! !

!MCSMReleaseRepository class methodsFor: 'as yet unclassified' stamp: ''!
fillInTheBlankRequest
	^ 'SqueakMap Release Repository:'! !

!MCSMReleaseRepository class methodsFor: 'as yet unclassified' stamp: ''!
morphicConfigure
	^ self fillInTheBlankConfigure! !

!MCSMReleaseRepository class methodsFor: 'as yet unclassified' stamp: ''!
package: t1 user: t2 password: t3 
	^ self basicNew
		initializeWithPackage: t1
		user: t2
		password: t3! !

!MCSMReleaseRepository methodsFor: 'as yet unclassified' stamp: ''!
basicStoreVersion: t1 
	| t2 |
	t2 := self uploadVersion: t1.
	self releaseVersion: t1 url: t2! !

!MCSMReleaseRepository methodsFor: 'as yet unclassified' stamp: ''!
checkResult: t1 
	(#('HTTP/1.1 201 ' 'HTTP/1.1 200 ' 'HTTP/1.0 201 ' 'HTTP/1.0 200 ' )
			anySatisfy: [:t2 | t1 beginsWith: t2])
		ifFalse: [self error: t1]! !

!MCSMReleaseRepository methodsFor: 'as yet unclassified' stamp: ''!
description
	^ 'sm://' , packageName! !

!MCSMReleaseRepository methodsFor: 'as yet unclassified' stamp: ''!
initializeWithPackage: t1 user: t2 password: t3 
	packageName := t1.
	user := t2.
	password := t3! !

!MCSMReleaseRepository methodsFor: 'as yet unclassified' stamp: 'cmm 3/5/2011 15:19'!
releaseVersion: aVersion url: urlString
	| result |
	result := HTTPSocket
		httpPost: self squeakMapUrl, '/packagebyname/', packageName, '/newrelease'
		args: {'version' -> {(aVersion info versionNumber)}.
			   'note' -> {aVersion info message}.
			   'downloadURL' -> {urlString}}
		user: user
		passwd: password.
	result contents size > 4 ifTrue: [self error: result contents]
! !

!MCSMReleaseRepository methodsFor: 'as yet unclassified' stamp: ''!
squeakMapUrl
	^ 'http://localhost:9070/sm'! !

!MCSMReleaseRepository methodsFor: 'as yet unclassified' stamp: ''!
stringForVersion: t1 
	| t2 |
	t2 := RWBinaryOrTextStream on: String new.
	t1 fileOutOn: t2.
	^ t2 contents! !

!MCSMReleaseRepository methodsFor: 'as yet unclassified' stamp: ''!
uploadVersion: t1 
	| t2 t3 |
	t2 := HTTPSocket
				httpPut: (self stringForVersion: t1)
				to: self squeakMapUrl , '/upload/' , t1 fileName
				user: user
				passwd: password.
	self checkResult: t2.
	t3 := t2 readStream.
	t3 upToAll: 'http://'.
	^ 'http://' , t3 upToEnd! !

MCWriteOnlyRepository subclass: #MCSmtpRepository
	instanceVariableNames: 'email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCSmtpRepository class methodsFor: 'as yet unclassified' stamp: ''!
description
	^ 'SMTP'! !

!MCSmtpRepository class methodsFor: 'as yet unclassified' stamp: ''!
morphicConfigure
	| t1 |
	t1 := FillInTheBlankMorph request: 'Email address:'.
	^ t1 isEmpty
		ifFalse: [self new emailAddress: t1]! !

!MCSmtpRepository methodsFor: 'as yet unclassified' stamp: ''!
basicStoreVersion: t1 
	MailSender
		sendMessage: (self messageForVersion: t1)! !

!MCSmtpRepository methodsFor: 'as yet unclassified' stamp: ''!
bodyForVersion: t1 
	^ String
		streamContents: [:t2 | 
			t2 nextPutAll: 'from version info:';
				 cr;
				 cr.
			t2 nextPutAll: t1 info summary]! !

!MCSmtpRepository methodsFor: 'as yet unclassified' stamp: ''!
description
	^ 'mailto://' , email! !

!MCSmtpRepository methodsFor: 'as yet unclassified' stamp: ''!
emailAddress: t1 
	email := t1! !

!MCSmtpRepository methodsFor: 'as yet unclassified' stamp: ''!
messageForVersion: t1 
	| t2 t3 |
	t2 := MailMessage empty.
	t2 setField: 'from' toString: MailSender userName.
	t2 setField: 'to' toString: email.
	t2
		setField: 'subject'
		toString: (self subjectForVersion: t1).
	t2
		body: (MIMEDocument
				contentType: 'text/plain'
				content: (self bodyForVersion: t1)).
	t3 := RWBinaryOrTextStream on: String new.
	t1 fileOutOn: t3.
	t2 addAttachmentFrom: t3 reset withName: t1 fileName.
	^ t2! !

!MCSmtpRepository methodsFor: 'as yet unclassified' stamp: ''!
subjectForVersion: t1 
	^ '[Package] ' , t1 info name! !

!MCWriteOnlyRepository methodsFor: 'as yet unclassified' stamp: ''!
includesVersionNamed: t1 
	^ false! !

!MCWriteOnlyRepository methodsFor: 'as yet unclassified' stamp: ''!
morphicOpen: t1 
	self inform: 'This repository is write-only'! !

!MCWriteOnlyRepository methodsFor: 'as yet unclassified' stamp: 'djm 9/29/2012 18:13'!
versionNamesForPackageNamed: aString
	"Answer a collection of MCVersionNames whose Package is named aString."
	^{}! !

!MCWriteOnlyRepository methodsFor: 'as yet unclassified' stamp: ''!
versionWithInfo: t1 ifAbsent: t2 
	^ t2 value! !

Object subclass: #MCRepositoryGroup
	instanceVariableNames: 'repositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

MCRepositoryGroup class
	instanceVariableNames: 'default'!

MCRepositoryGroup class
	instanceVariableNames: 'default'!

!MCRepositoryGroup class methodsFor: 'as yet unclassified' stamp: ''!
default
	^ default
		ifNil: [default := self new]! !

!MCRepositoryGroup class methodsFor: 'as yet unclassified' stamp: 'cmm 3/15/2011 13:27'!
flushAllCaches
	self default repositoriesDo:
		[ : each | each flushCache ]! !

!MCRepositoryGroup class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCRepositoryGroup methodsFor: 'add / remove' stamp: 'avi 1/27/2004 00:29'!
addRepository: aRepository
	((repositories includes: aRepository) or: [aRepository == MCCacheRepository default])
		ifFalse: [repositories add: aRepository.
				self class default addRepository: aRepository].
	self changed: #repositories! !

!MCRepositoryGroup methodsFor: 'testing' stamp: 'avi 11/7/2003 00:20'!
includes: aRepository
	^ self repositories includes: aRepository! !

!MCRepositoryGroup methodsFor: 'testing' stamp: 'cmm 3/5/2011 18:33'!
includesVersionNamed: aString 
	| versionName |
	versionName := aString asMCVersionName.
	self repositoriesDo:
		[ : ea | (ea includesVersionNamed: versionName) ifTrue: [ ^ true ] ].
	^ false! !

!MCRepositoryGroup methodsFor: 'initialize-release' stamp: 'stephaneducasse 2/4/2006 20:47'!
initialize
	repositories := OrderedCollection new! !

!MCRepositoryGroup methodsFor: 'add / remove' stamp: 'cmm 4/25/2011 08:13'!
removeRepository: aRepository
	| removed |
	removed := repositories remove: aRepository ifAbsent: [].
	removed ifNotNil: [ removed wasRemoved ].
	self changed: #repositories! !

!MCRepositoryGroup methodsFor: 'accessing' stamp: 'nk 11/2/2003 10:57'!
repositories
	^ ((Array with: MCCacheRepository default), repositories) select: [ :ea | ea isValid ]! !

!MCRepositoryGroup methodsFor: 'accessing' stamp: 'avi 11/7/2003 00:51'!
repositoriesDo: aBlock
	self repositories do: [:ea | [aBlock value: ea] on: Error do: []]! !

!MCRepositoryGroup methodsFor: 'accessing' stamp: 'klc 5/25/2008 20:20'!
versionWithInfo: aVersionInfo
	^self versionWithInfo: aVersionInfo ifNone: [ nil ]
! !

!MCRepositoryGroup methodsFor: 'accessing' stamp: 'ul 12/12/2009 14:10'!
versionWithInfo: aVersionInfo ifNone: aBlock
	self repositoriesDo: [:ea | (ea versionWithInfo: aVersionInfo) ifNotNil: [:v | ^ v]].
	^aBlock value! !

Object subclass: #MCScanner
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Chunk Format'!

!MCScanner class methodsFor: 'as yet unclassified' stamp: ''!
scan: t1 
	^ (self new stream: t1) next! !

!MCScanner class methodsFor: 'as yet unclassified' stamp: ''!
scanTokens: t1 
	^ Array
		with: (self scan: t1 readStream)! !

!MCScanner methodsFor: 'as yet unclassified' stamp: ''!
next
	| t1 |
	stream skipSeparators.
	t1 := stream peek.
	t1 = $#
		ifTrue: [t1 := stream next; peek].
	t1 = $'
		ifTrue: [^ self nextString].
	t1 = $(
		ifTrue: [^ self nextArray].
	t1 isAlphaNumeric
		ifTrue: [^ self nextSymbol].
	self error: 'Unknown token type'! !

!MCScanner methodsFor: 'as yet unclassified' stamp: ''!
nextArray
	stream next.
	^ Array
		streamContents: [:t1 | 
			[stream skipSeparators.
			stream peek = $)
				or: [stream atEnd]]
				whileFalse: [t1 nextPut: self next].
			stream next = $)
				ifFalse: [self error: 'Unclosed array']]! !

!MCScanner methodsFor: 'as yet unclassified' stamp: ''!
nextString
	^ stream nextDelimited: $'! !

!MCScanner methodsFor: 'as yet unclassified' stamp: ''!
nextSymbol
	^ (String
		streamContents: [:t1 | 
			[stream peek isAlphaNumeric]
				whileTrue: [t1 nextPut: stream next].
			nil]) asSymbol! !

!MCScanner methodsFor: 'as yet unclassified' stamp: ''!
stream: t1 
	stream := t1! !

Object subclass: #MCSnapshot
	instanceVariableNames: 'definitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Base'!

!MCSnapshot class methodsFor: 'as yet unclassified' stamp: ''!
empty
	^ self fromDefinitions: #()! !

!MCSnapshot class methodsFor: 'as yet unclassified' stamp: ''!
fromDefinitions: t1 
	^ self new initializeWithDefinitions: t1! !

!MCSnapshot methodsFor: 'accessing' stamp: 'cmm 5/30/2012 22:29'!
= other
	self == other ifTrue: [ ^ true ].
	self species = other species ifFalse: [ ^ false ].
	^ definitions asArray = other definitions asArray! !

!MCSnapshot methodsFor: 'accessing' stamp: ''!
definitions
	^ definitions! !

!MCSnapshot methodsFor: 'accessing' stamp: ''!
hash
	^ definitions asArray hash! !

!MCSnapshot methodsFor: 'initializing' stamp: ''!
initializeWithDefinitions: t1 
	definitions := t1! !

!MCSnapshot methodsFor: 'loading' stamp: ''!
install
	MCPackageLoader installSnapshot: self! !

!MCSnapshot methodsFor: 'patching' stamp: ''!
patchRelativeToBase: t1 
	^ MCPatch fromBase: t1 target: self! !

!MCSnapshot methodsFor: 'loading' stamp: ''!
updatePackage: t1 
	MCPackageLoader updatePackage: t1 withSnapshot: self! !

Object subclass: #MCTool
	instanceVariableNames: 'morph label modal modalValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

MCTool subclass: #MCCodeTool
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCCodeTool methodsFor: 'menus' stamp: ''!
adoptMessageInCurrentChangeset
	self selectedClassOrMetaClass
		ifNotNil: [:t2 | self selectedMessageName
				ifNotNil: [:t1 | 
					ChangeSet current adoptSelector: t1 forClass: t2.
					self changed: #annotations]]! !

!MCCodeTool methodsFor: 'subclassResponsibility' stamp: ''!
annotations
	^ ''! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
browseFullProtocol
	(Smalltalk isMorphic
			and: [Smalltalk hasClassNamed: #Lexicon])
		ifFalse: [^ self spawnFullProtocol].
	self selectedClassOrMetaClass
		ifNotNil: [:t1 | (Smalltalk at: #Lexicon) new
				openOnClass: t1
				inWorld: ActiveWorld
				showingSelector: self selectedMessageName]! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
browseMessages
	self systemNavigation
		browseAllImplementorsOf: (self selectedMessageName
				ifNil: [^ nil])! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
browseMethodFull
	self selectedClassOrMetaClass
		ifNotNil: [:t1 | Browser fullOnClass: t1 selector: self selectedMessageName]! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
browseSendersOfMessages
	self systemNavigation
		browseAllCallsOn: (self selectedMessageName
				ifNil: [^ nil])! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
browseVersions
	| t1 t2 t3 |
	t1 := self selectedClassOrMetaClass.
	t2 := self selectedMessageName.
	t3 := t1
				compiledMethodAt: t2
				ifAbsent: [^ self].
	VersionsBrowser
		browseVersionsOf: t3
		class: t1 theNonMetaClass
		meta: t1 isMeta
		category: self selectedMessageCategoryName
		selector: t2! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
classHierarchy
	self systemNavigation spawnHierarchyForClass: self selectedClassOrMetaClass selector: self selectedMessageName! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
classListMenu: t1 
	t1 addList: #(#- #('browse full (b)' #browseMethodFull ) #('browse hierarchy (h)' #classHierarchy ) #('browse protocol (p)' #browseFullProtocol ) #- #('show hierarchy' #methodHierarchy ) #- #('find method...' #findMethodInChangeSets ) ).
	^ t1! !

!MCCodeTool methodsFor: 'menus' stamp: 'cmm 9/20/2010 13:59'!
copyReference
	"Copy the selected selector to the clipboard"
	self selectedMessageName ifNotNilDo:
		[ : selector | Clipboard clipboardText:
			(self selectedClassOrMetaClass
				ifNil: [ selector asString ]
				ifNotNilDo: [ : cls | (cls >> selector) reference ]) ]! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
copySelector
	self selectedMessageName
		ifNotNil: [:t1 | Clipboard clipboardText: t1 asString]! !

!MCCodeTool methodsFor: 'menus' stamp: 'eem 7/20/2012 11:29'!
fileOutMessage
	"Put a description of the selected message on a file"

	| fileName |
	self selectedMessageName ifNotNil:
		[Cursor write showWhile:
			[self selectedClassOrMetaClass fileOutMethod: self selectedMessageName].
		 ^self].
	items isEmpty ifTrue:
		[^self].
	fileName := UIManager default request: 'File out on which file?' initialAnswer: 'methods'.
	Cursor write showWhile:
		[| definitionStream removalInitStream |
		definitionStream := WriteStream on: (String new: 1000).
		removalInitStream := WriteStream on: (String new: 100).
		definitionStream header; timeStamp.
		items do:
			[:patchOp| | def |
			def := patchOp definition.
			def isMethodDefinition ifTrue:
				[(def actualClass notNil
				  and: [def actualClass includesSelector: def selector])
					ifTrue:
						[def actualClass
							printMethodChunk: def selector
							withPreamble: true
							on: definitionStream
							moveSource: false
							toFile: nil.
						(def selector == #initialize and: [def classIsMeta]) ifTrue:
							[removalInitStream nextChunkPut: def className, ' initialize'; cr]]
					ifFalse:
						[removalInitStream nextChunkPut: def className, (def classIsMeta ifTrue: [' class'] ifFalse: ['']), ' removeSelector: ', def selector printString; cr]].
			def isClassDefinition ifTrue:
				[def actualClass
					ifNotNil:
						[definitionStream nextChunkPut: def actualClass definition.
						 def comment ifNotNil:
							[def actualClass organization
								putCommentOnFile: definitionStream
								numbered: 1
								moveSource: false
								forClass: def actualClass]]
					ifNil:
						[removalInitStream nextChunkPut: def className, ' removeFromSystem'; cr]]].
		definitionStream nextPutAll: removalInitStream contents.
		FileStream writeSourceCodeFrom: definitionStream baseName: fileName isSt: true useHtml: false]! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
findMethodInChangeSets
	self selectedMessageName
		ifNotNil: [:t1 | ChangeSorter browseChangeSetsWithClass: self selectedClassOrMetaClass selector: t1]! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
methodHierarchy
	self systemNavigation methodHierarchyBrowserForClass: self selectedClassOrMetaClass selector: self selectedMessageName! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
methodListKey: t1 from: t2 
	t1 caseOf: {
		[$b] -> [self browseMethodFull].
		[$h] -> [self classHierarchy].
		[$O] -> [self openSingleMessageBrowser].
		[$p] -> [self browseFullProtocol].
		[$o] -> [self fileOutMessage].
		[$c] -> [self copySelector].
		[$n] -> [self browseSendersOfMessages].
		[$m] -> [self browseMessages].
		[$i] -> [self methodHierarchy].
		[$v] -> [self browseVersions]}
		 otherwise: []! !

!MCCodeTool methodsFor: 'menus' stamp: 'eem 4/16/2012 13:50'!
methodListMenu: aMenu
	"Build the menu for the selected method, if any."
	
	self selectedMessageName
	ifNil: [items notEmpty ifTrue:
		[aMenu addList:#(('fileOut (o)'					fileOutMessage))]]
	ifNotNil: [
	aMenu addList:#(
			('browse full (b)' 						browseMethodFull)
			('browse hierarchy (h)'					classHierarchy)
			('browse method (O)'					openSingleMessageBrowser)
			('browse protocol (p)'					browseFullProtocol)
			-
			('fileOut (o)'								fileOutMessage)
			('printOut'								printOutMessage)
			('copy selector (c)'						copySelector)
			('copy reference (C)'					copyReference)).
		aMenu addList: #(
			-
			('browse senders (n)'						browseSendersOfMessages)
			('browse implementors (m)'					browseMessages)
			('inheritance (i)'						methodHierarchy)
			('versions (v)'							browseVersions)
		('change sets with this method'			findMethodInChangeSets)
"		('x revert to previous version'				revertToPreviousVersion)"
		('remove from current change set'		removeFromCurrentChanges)
"		('x revert & remove from changes'		revertAndForget)"
		('add to current change set'				adoptMessageInCurrentChangeset)
"		('x copy up or copy down...'				copyUpOrCopyDown)"
"		('x remove method (x)'					removeMessage)"
		"-"
		).
	].
"	aMenu addList: #(
			('x inst var refs...'						browseInstVarRefs)
			('x inst var defs...'						browseInstVarDefs)
			('x class var refs...'						browseClassVarRefs)
			('x class variables'						browseClassVariables)
			('x class refs (N)'							browseClassRefs)
	).
"
	^ aMenu
! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
openSingleMessageBrowser
	| t1 t2 |
	(t1 := self selectedMessageName)
		ifNil: [^ self].
	t2 := MethodReference new setStandardClass: self selectedClassOrMetaClass methodSymbol: t1.
	self systemNavigation
		browseMessageList: (Array with: t2)
		name: t2 asStringOrText
		autoSelect: nil! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
perform: t1 orSendTo: t2 
	(self respondsTo: t1)
		ifTrue: [^ self perform: t1].
	^ super perform: t1 orSendTo: t2! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
printOutMessage
	self selectedMessageName
		ifNotNil: [self selectedClassOrMetaClass fileOutMethod: self selectedMessageName asHtml: true]! !

!MCCodeTool methodsFor: 'menus' stamp: ''!
removeFromCurrentChanges
	ChangeSet current removeSelectorChanges: self selectedMessageName class: self selectedClassOrMetaClass.
	self changed: #annotations! !

!MCCodeTool methodsFor: 'subclassResponsibility' stamp: ''!
selectedClass
	self subclassResponsibility! !

!MCCodeTool methodsFor: 'subclassResponsibility' stamp: ''!
selectedClassOrMetaClass
	self subclassResponsibility! !

!MCCodeTool methodsFor: 'subclassResponsibility' stamp: ''!
selectedMessageCategoryName
	self subclassResponsibility! !

!MCCodeTool methodsFor: 'subclassResponsibility' stamp: ''!
selectedMessageName
	self subclassResponsibility! !

MCCodeTool subclass: #MCPatchBrowser
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

MCPatchBrowser subclass: #MCChangeSelector
	instanceVariableNames: 'kept'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: ''!
buttonSpecs
	^ #(#(#Select #select 'Select these changes' ) #(#Cancel #cancel 'Cancel the operation' ) )! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: ''!
cancel
	self answer: nil! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: ''!
defaultLabel
	^ 'Change Selector'! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: 'nice 9/22/2010 00:43'!
innerButtonRow
	^ self buttonRow: self innerButtonSpecs! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: 'nice 9/22/2010 00:42'!
innerButtonSpecs
	^
		#(('Select All' selectAll 'select all changes')
		  ('Select None' selectNone 'select no changes'))! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: ''!
kept
	^ kept
		ifNil: [kept := Set new]! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: ''!
listSelectionAt: t1 
	^ self kept
		includes: (self items at: t1)! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: ''!
listSelectionAt: t1 put: t2 
	| t3 |
	t3 := self items at: t1.
	t2
		ifTrue: [self kept add: t3]
		ifFalse: [self kept
				remove: t3
				ifAbsent: []]! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: ''!
select
	self
		answer: (MCPatch operations: kept)! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: ''!
selectAll
	kept addAll: self items.
	self changed: #list! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: ''!
selectNone
	kept := Set new.
	self changed: #list! !

!MCChangeSelector methodsFor: 'as yet unclassified' stamp: ''!
widgetSpecs
	Preferences annotationPanes
		ifFalse: [^ #(#(#(#buttonRow ) #(0 0 1 0 ) #(0 0 0 30 ) ) #(#(#multiListMorph:selection:listSelection:menu: #list #selection #listSelectionAt: #methodListMenu: ) #(0 0 1 0.4 ) #(0 30 0 0 ) ) #(#(#innerButtonRow ) #(0 0.4 1 0.4 ) #(0 0 0 30 ) ) #(#(#textMorph: #text ) #(0 0.4 1 1 ) #(0 30 0 0 ) ) )].
	^ #(#(#(#buttonRow ) #(0 0 1 0 ) #(0 0 0 30 ) ) #(#(#multiListMorph:selection:listSelection:menu: #list #selection #listSelectionAt: #methodListMenu: ) #(0 0 1 0.4 ) #(0 30 0 0 ) ) #(#(#innerButtonRow ) #(0 0.4 1 0.4 ) #(0 0 0 30 ) ) #(#(#textMorph: #annotations ) #(0 0.4 1 0.4 ) #(0 30 0 60 ) ) #(#(#textMorph: #text ) #(0 0.4 1 1 ) #(0 60 0 0 ) ) )! !

MCPatchBrowser subclass: #MCMergeBrowser
	instanceVariableNames: 'conflicts merger ok'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCMergeBrowser class methodsFor: 'as yet unclassified' stamp: ''!
resolveConflictsInMerger: t1 
	| t2 |
	t2 := self new merger: t1.
	^ t2 showModally
		ifNil: [false]! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
buttonSpecs
	^ #(#(#Merge #merge 'Proceed with the merge' #canMerge ) #(#Cancel #cancel 'Cancel the merge' ) #('All Newer' #chooseAllNewerConflicts 'Choose all newer conflict versions' ) #('All Older' #chooseAllOlderConflicts 'Choose all older conflict versions' ) #('Rest Local' #chooseAllUnchosenLocal 'Choose local versions of all remaining conflicts' ) #('Rest Remote' #chooseAllUnchosenRemote 'Choose remote versions of all remaining conflicts' ) )! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
canMerge
	^ merger isMerged! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
cancel
	self answer: false! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
chooseAllNewerConflicts
	conflicts
		do: [:t1 | t1 chooseNewer].
	self changed: #text;
		 changed: #list! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
chooseAllOlderConflicts
	conflicts
		do: [:t1 | t1 chooseOlder].
	self changed: #text;
		 changed: #list! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
chooseAllUnchosenLocal
	conflicts
		do: [:t1 | t1 isResolved
				ifFalse: [t1 chooseLocal]].
	self changed: #text;
		 changed: #list! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
chooseAllUnchosenRemote
	conflicts
		do: [:t1 | t1 isResolved
				ifFalse: [t1 chooseRemote]].
	self changed: #text;
		 changed: #list! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'nice 9/6/2010 22:53'!
chooseLocal
	self conflictSelectionDo:
		[selection chooseLocal.
		self changed: #text; changed: #list].
	self selectNextUnresolvedConflict! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'nice 9/6/2010 22:38'!
chooseRemote
	self conflictSelectionDo:
		[selection chooseRemote.
		self changed: #text; changed: #list].
	self selectNextUnresolvedConflict! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
clearChoice
	self
		conflictSelectionDo: [selection clearChoice.
			self changed: #text;
				 changed: #list]! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'nice 9/6/2010 22:59'!
conflictSelectionDo: aBlock
	self selectionIsConflicted
		ifTrue: aBlock! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
defaultLabel
	^ 'Merge Browser'! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
getConflictMenu: t1 
	selection remoteChosen
		ifTrue: [t1
				add: 'undo keep change'
				target: self
				selector: #clearChoice]
		ifFalse: [t1
				add: 'keep change'
				target: self
				selector: #chooseRemote].
	selection localChosen
		ifTrue: [t1
				add: 'undo reject change'
				target: self
				selector: #clearChoice]
		ifFalse: [t1
				add: 'reject change'
				target: self
				selector: #chooseLocal].
	^ t1! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
getMenu: t1 
	selection
		ifNil: [^ t1].
	^ self selectionIsConflicted
		ifTrue: [self getConflictMenu: t1]
		ifFalse: [self getOperationMenu: t1]! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
getOperationMenu: t1 
	^ t1! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'nice 9/22/2010 00:43'!
innerButtonRow
	^ self buttonRow: self innerButtonSpecs! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'nice 9/22/2010 00:43'!
innerButtonSpecs
	^
		#((Keep chooseRemote 'keep the selected change' )
		  (Reject chooseLocal 'reject the selected change' ))! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
items
	^ conflicts , items! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
merge
	merger isMerged
		ifTrue: [self answer: true]
		ifFalse: [self inform: 'You must resolve all the conflicts first']! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
merger: t1 
	merger := t1.
	items := t1 operations asSortedCollection.
	conflicts := t1 conflicts
				sort: [:t2 :t3 | t2 operation <= t3 operation]! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'nice 9/22/2010 01:02'!
methodListKey: aKeystroke from: aListMorph 
	aKeystroke caseOf: {
		[$k] -> [self chooseRemote].
		[$r] -> [self chooseLocal]}
		 otherwise: [super methodListKey: aKeystroke from: aListMorph ]! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'nice 9/6/2010 23:09'!
selectNextUnresolvedConflict
	"Try and select the next unresolved conflict starting at current selection in the list, wrapping at beginning.
	If there is no more unresolved conflict, then simply move to next non conflict item in the list.
	This method makes assumption that conflicts are always sorted before non conflicts items."
	(self findListMorph: #list)
		ifNotNil:
			[:aMorph |
			| currentIndex nextUnresolvedIndex |
			currentIndex := aMorph getCurrentSelectionIndex min: conflicts size.
			nextUnresolvedIndex := (currentIndex + 1 to: currentIndex + conflicts size - 1)
				detect:
					[:i |
					| nextItem |
					((nextItem := conflicts atWrap: i) isKindOf: MCConflict)
						and: [nextItem isResolved not]]
				ifNone: [0].
			nextUnresolvedIndex = 0
				ifTrue: [items size > 1 ifTrue: [self selection: (aMorph getCurrentSelectionIndex max: conflicts size)  - conflicts size \\ items size + conflicts size + 1]]
				ifFalse: [self selection: nextUnresolvedIndex - 1 \\ conflicts size + 1].].! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: ''!
selectionIsConflicted
	^ selection isKindOf: MCConflict! !

!MCMergeBrowser methodsFor: 'as yet unclassified' stamp: 'nice 9/22/2010 01:55'!
widgetSpecs
	Preferences annotationPanes ifFalse: [ ^#(
		((buttonRow) (0 0 1 0) (0 0 0 30))
		((listMorph:selection:menu:keystroke: list selection methodListMenu: methodListKey:from:) (0 0 1 0.4) (0 30 0 0))
		((innerButtonRow) (0 0.4 1 0.4) (0 0 0 30))
		((textMorph: text) (0 0.4 1 1) (0 30 0 0))
		)].

	^ {
		#((buttonRow) (0 0 1 0) (0 0 0 30)).
		#((listMorph:selection:menu:keystroke: list selection methodListMenu: methodListKey:from:) (0 0 1 0.4) (0 30 0 0)).
		#((innerButtonRow) (0 0.4 1 0.4) (0 0 0 30)).
		{ #(textMorph: annotations). #(0 0.4 1 0.4). { 0. 30. 0. 30+self defaultAnnotationPaneHeight. }}.
		{ #(textMorph: text). #(0 0.4 1 1). { 0. 30+self defaultAnnotationPaneHeight. 0. 0.}}
	}! !

!MCPatchBrowser class methodsFor: 'as yet unclassified' stamp: ''!
forPatch: t1 
	^ self new patch: t1! !

!MCPatchBrowser methodsFor: 'as yet unclassified' stamp: ''!
annotations
	^ selection
		ifNil: [super annotations]
		ifNotNil: [selection annotations]! !

!MCPatchBrowser methodsFor: 'morphic ui' stamp: ''!
buttonSpecs
	^ #(#(#Invert #invert 'Show the reverse set of changes' ) #(#Export #export 'Export the changes as a change set' ) )! !

!MCPatchBrowser methodsFor: 'as yet unclassified' stamp: ''!
changeSetNameForInstall
	| t1 |
	label
		ifNil: [^ ChangeSet current name].
	t1 := label findTokens: ' '.
	t1 removeAllFoundIn: {'changes'. 'between'. 'and'}.
	(t1 size = 3
			and: [t1 second = '<working'])
		ifTrue: [^ t1 first , '-to-working'].
	t1 size = 2
		ifFalse: [^ 'InstalledPatches'].
	^ '{1}-to-{2}' format: t1! !

!MCPatchBrowser methodsFor: 'morphic ui' stamp: ''!
defaultLabel
	^ 'Patch Browser'! !

!MCPatchBrowser methodsFor: 'actions' stamp: ''!
installSelection
	| t1 |
	selection
		ifNotNil: [t1 := MCPackageLoader new.
			selection applyTo: t1.
			t1 loadWithName: self changeSetNameForInstall]! !

!MCPatchBrowser methodsFor: 'selecting' stamp: ''!
invert
	items := items
				collect: [:t1 | t1 inverse].
	self changed: #list;
		 changed: #text;
		 changed: #selection! !

!MCPatchBrowser methodsFor: 'accessing' stamp: ''!
items
	^ items! !

!MCPatchBrowser methodsFor: 'accessing' stamp: ''!
list
	^ self items
		collect: [:t1 | t1 summary]! !

!MCPatchBrowser methodsFor: 'menus' stamp: 'bf 6/21/2011 13:48'!
methodListMenu: aMenu
	selection ifNotNil:
		[aMenu addList:#(
			('install'	 installSelection)
			('revert'	 revertSelection)
			-)].
	self unchangedMethods ifNotEmpty:
		[aMenu addList:#(
			('revert unchanged methods...'	revertUnchangedMethods)
			-)].
	super methodListMenu: aMenu.
	^ aMenu
! !

!MCPatchBrowser methodsFor: 'accessing' stamp: ''!
patch: t1 
	items := t1 operations asSortedCollection! !

!MCPatchBrowser methodsFor: 'morphic ui' stamp: ''!
perform: t1 orSendTo: t2 
	(self respondsTo: t1)
		ifTrue: [^ self perform: t1].
	^ t2 perform: t1! !

!MCPatchBrowser methodsFor: 'actions' stamp: ''!
revertSelection
	| t1 |
	selection
		ifNotNil: [t1 := MCPackageLoader new.
			selection inverse applyTo: t1.
			t1 loadWithName: self changeSetNameForInstall]! !

!MCPatchBrowser methodsFor: 'actions' stamp: 'bf 6/21/2011 13:47'!
revertUnchangedMethods
	"revert methods that only have changed timestamps"
	| loader unchangedMethods |
	unchangedMethods := items select: [:op | op isUnchangedMethod].
	(self confirm: ('Revert {1} methods that only differ in timestamp?' translated format: {unchangedMethods size}))
		ifTrue: [
			loader := MCPackageLoader new.
			unchangedMethods do: [:op | op inverse applyTo: loader].
			loader loadWithName: self changeSetNameForInstall].
! !

!MCPatchBrowser methodsFor: 'subclassResponsibility' stamp: ''!
selectedClass
	| t1 |
	selection
		ifNil: [^ nil].
	(t1 := selection definition)
		ifNil: [^ nil].
	t1 isMethodDefinition
		ifFalse: [^ nil].
	^ Smalltalk
		at: t1 className
		ifAbsent: []! !

!MCPatchBrowser methodsFor: 'subclassResponsibility' stamp: ''!
selectedClassOrMetaClass
	| t1 |
	selection
		ifNil: [^ nil].
	(t1 := selection definition)
		ifNil: [^ nil].
	t1 isMethodDefinition
		ifFalse: [^ nil].
	^ t1 actualClass! !

!MCPatchBrowser methodsFor: 'subclassResponsibility' stamp: ''!
selectedMessageCategoryName
	| t1 |
	selection
		ifNil: [^ nil].
	(t1 := selection definition)
		ifNil: [^ nil].
	t1 isMethodDefinition
		ifFalse: [^ nil].
	^ t1 category! !

!MCPatchBrowser methodsFor: 'subclassResponsibility' stamp: ''!
selectedMessageName
	| t1 |
	selection
		ifNil: [^ nil].
	(t1 := selection definition)
		ifNil: [^ nil].
	t1 isMethodDefinition
		ifFalse: [^ nil].
	^ t1 selector! !

!MCPatchBrowser methodsFor: 'selecting' stamp: ''!
selection
	^ selection
		ifNil: [0]
		ifNotNil: [self items indexOf: selection]! !

!MCPatchBrowser methodsFor: 'selecting' stamp: ''!
selection: t1 
	selection := t1 = 0
				ifFalse: [self items at: t1].
	self changed: #selection;
		 changed: #text;
		 changed: #annotations! !

!MCPatchBrowser methodsFor: 'text' stamp: ''!
text
	^ selection
		ifNil: ['']
		ifNotNil: [selection source]! !

!MCPatchBrowser methodsFor: 'text' stamp: ''!
text: t1 
	self changed: #text! !

!MCPatchBrowser methodsFor: 'as yet unclassified' stamp: 'bf 6/13/2011 16:33'!
unchangedMethods
	^ items select: [:op | op isUnchangedMethod]! !

!MCPatchBrowser methodsFor: 'morphic ui' stamp: ''!
widgetSpecs
	Preferences annotationPanes
		ifFalse: [^ #(#(#(#listMorph:selection:menu:keystroke: #list #selection #methodListMenu: #methodListKey:from: ) #(0 0 1 0.4 ) #(0 0 0 0 ) ) #(#(#textMorph: #text ) #(0 0.4 1 1 ) ) )].
	^ {#(#(#listMorph:selection:menu:keystroke: #list #selection #methodListMenu: #methodListKey:from: ) #(0 0 1 0.4 ) #(0 0 0 0 ) ). {#(#textMorph: #annotations ). #(0 0.4 1 0.4 ). {0. 0. 0. self defaultAnnotationPaneHeight}}. {#(#textMorph: #text ). #(0 0.4 1 1 ). {0. self defaultAnnotationPaneHeight. 0. 0}}}! !

MCCodeTool subclass: #MCSnapshotBrowser
	instanceVariableNames: 'categorySelection classSelection protocolSelection methodSelection switch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCSnapshotBrowser class methodsFor: 'as yet unclassified' stamp: ''!
forSnapshot: t1 
	^ self new snapshot: t1! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'hmm 4/16/2010 22:07'!
allClassNames
	^ (items 
		select: [:ea | (ea isOrganizationDefinition | ea isScriptDefinition) not] 
		thenCollect: [:ea | ea className]) asSet.
! !

!MCSnapshotBrowser methodsFor: 'text' stamp: ''!
annotations
	methodSelection
		ifNotNil: [^ methodSelection annotations].
	^ ''! !

!MCSnapshotBrowser methodsFor: 'text' stamp: ''!
annotations: t1 
	self changed: #annotations! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: ''!
buttonSpecs
	^ #(#('instance' #switchBeInstance 'show instance' #buttonEnabled #switchIsInstance ) #('?' #switchBeComment 'show comment' #buttonEnabled #switchIsComment ) #('class' #switchBeClass 'show class' #buttonEnabled #switchIsClass ) )! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: ''!
categoryList
	^ self visibleCategories! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: ''!
categoryListMenu: t1 
	categorySelection
		ifNotNil: [t1
				add: (categorySelection = '*Extensions'
						ifTrue: ['load all extension methods' translated]
						ifFalse: ['load class category {1}' translated format: {categorySelection}])
				action: #loadCategorySelection].
	^ t1! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: ''!
categorySelection
	^ categorySelection
		ifNil: [0]
		ifNotNil: [self visibleCategories indexOf: categorySelection]! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: ''!
categorySelection: t1 
	categorySelection := t1 = 0
				ifFalse: [self visibleCategories at: t1].
	self classSelection: 0.
	self changed: #categorySelection;
		 changed: #annotations;
		 changed: #classList! !

!MCSnapshotBrowser methodsFor: 'text' stamp: ''!
classCommentString
	^ (items
		detect: [:t1 | t1 isClassDefinition
				and: [t1 className = classSelection]]
		ifNone: [^ '']) comment! !

!MCSnapshotBrowser methodsFor: 'text' stamp: ''!
classDefinitionString
	| t1 |
	t1 := items
				select: [:t2 | (t2 isClassDefinition
							or: [t2 isClassDefinitionExtension])
						and: [t2 className = classSelection]].
	t1 isEmpty
		ifTrue: [^ 'This class is defined elsewhere.'].
	^ String
		streamContents: [:t2 | t1 asArray sort
				do: [:t3 | t3 printDefinitionOn: t2]
				separatedBy: [t2 nextPut: $.;
						 cr]]! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: 'bf 9/9/2012 14:23'!
classList
	^ categorySelection = self extensionsCategory
		ifTrue: [self labeledClassnames: self visibleClasses]
		ifFalse: [self visibleClasses]! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: ''!
classListMenu: t1 
	classSelection
		ifNil: [^ t1].
	super classListMenu: t1.
	t1 addLine;
		add: ('load class {1}' translated format: {classSelection})
		action: #loadClassSelection.
	^ t1! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: ''!
classSelection
	^ classSelection
		ifNil: [0]
		ifNotNil: [self visibleClasses indexOf: classSelection]! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: 'eem 9/19/2012 14:09'!
classSelection: aNumber
	classSelection := aNumber = 0 ifFalse: [self visibleClasses at: aNumber].
	self protocolSelection: 0.
	self changed: #classSelection;  changed: #protocolList.
	(self protocolList size = 1
	 and: [self protocolList first first = $*])
		ifTrue:
			[self protocolSelection: 1]
		ifFalse:
			[self changed: #annotations;
				changed: #methodList]
! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: ''!
defaultExtent
	^ 650 @ 400! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: ''!
defaultLabel
	^ 'Snapshot Browser'! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
extensionClassNames
	^ (self allClassNames difference: self packageClassNames) asSortedCollection! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
extensionsCategory
	^ '*Extensions'! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'bf 8/21/2012 21:38'!
hasExtensions
	^self extensionClassNames notEmpty! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: ''!
inspectSelection
	^ self methodSelection inspect! !

!MCSnapshotBrowser methodsFor: 'private' stamp: 'bf 9/9/2012 14:38'!
labeledClassnames: classNames
	| methodClassification |
	methodClassification := Dictionary new.
	items do: [:def | def isMethodDefinition ifTrue: [
		(methodClassification at: def className ifAbsentPut: [Set new])
			add: (def classIsMeta ifFalse: [$i] ifTrue: [$c])]].
	^ classNames collect: [:className |
		String streamContents: [:s |
			s nextPutAll: className; space.
			(methodClassification at: className)
				do: [:each | each = $i
					ifTrue: [s nextPutAll: '*inst']
					ifFalse: [s nextPutAll: '*class']]
				separatedBy: [s nextPut: $,]]]
! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: ''!
loadCategorySelection
	categorySelection
		ifNil: [^ self].
	self methodsForSelectedClassCategory
		do: [:t1 | t1 load]! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: ''!
loadClassSelection
	classSelection
		ifNil: [^ self].
	(self packageClasses
		detect: [:t1 | t1 className = classSelection]
		ifNone: [^ self]) load.
	self methodsForSelectedClass
		do: [:t1 | t1 load]! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: ''!
loadMethodSelection
	methodSelection
		ifNil: [^ self].
	methodSelection load! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: ''!
loadProtocolSelection
	protocolSelection
		ifNil: [^ self].
	self methodsForSelectedProtocol
		do: [:t1 | t1 load]! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: ''!
methodList
	^ self visibleMethods
		collect: [:t1 | t1 selector]! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: ''!
methodListMenu: t1 
	super methodListMenu: t1.
	self selectedMessageName
		ifNotNil: [:t2 | t1 addLine; add: 'load method' translated action: #loadMethodSelection].
	^ t1! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: ''!
methodSelection
	^ methodSelection
		ifNil: [0]
		ifNotNil: [self visibleMethods indexOf: methodSelection]! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: ''!
methodSelection: t1 
	methodSelection := t1 = 0
				ifFalse: [self visibleMethods at: t1].
	self changed: #methodSelection;
		 changed: #text;
		 changed: #annotations! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
methodsForSelectedClass
	^ items
		select: [:t1 | t1 className = classSelection
				and: [t1 isMethodDefinition
						and: [t1 classIsMeta = self switchIsClass]]]! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
methodsForSelectedClassCategory
	| t1 |
	t1 := self visibleClasses.
	^ items
		select: [:t2 | (t1 includes: t2 className)
				and: [t2 isMethodDefinition
						and: [t2 classIsMeta = self switchIsClass]]]! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
methodsForSelectedProtocol
	| t1 |
	protocolSelection
		ifNil: [^ Array new].
	t1 := self methodsForSelectedClass asOrderedCollection.
	protocolSelection = '-- all --'
		ifFalse: [t1
				removeAllSuchThat: [:t2 | t2 category ~= protocolSelection]].
	^ t1! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
packageClassNames
	^ self packageClasses
		collect: [:t1 | t1 className]! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
packageClasses
	^ items
		select: [:t1 | t1 isClassDefinition]! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: 'bf 7/11/2011 12:27'!
packageOrganizations
	^ items select: [:ea | ea isOrganizationDefinition]! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: ''!
protocolList
	^ self visibleProtocols! !

!MCSnapshotBrowser methodsFor: 'menus' stamp: ''!
protocolListMenu: t1 
	protocolSelection
		ifNotNil: [t1
				add: ('load protocol ''{1}''' translated format: {protocolSelection})
				action: #loadProtocolSelection].
	^ t1! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: ''!
protocolSelection
	^ protocolSelection
		ifNil: [0]
		ifNotNil: [self visibleProtocols indexOf: protocolSelection]! !

!MCSnapshotBrowser methodsFor: 'selecting' stamp: ''!
protocolSelection: t1 
	protocolSelection := t1 = 0
				ifFalse: [self visibleProtocols at: t1].
	self methodSelection: 0.
	self changed: #protocolSelection;
		 changed: #methodList;
		 changed: #annotations! !

!MCSnapshotBrowser methodsFor: 'text' stamp: ''!
scriptDefinitionString
	| t1 |
	t1 := items
				select: [:t2 | t2 isScriptDefinition].
	t1 isEmpty
		ifTrue: [^ '(package defines no scripts)'].
	^ String
		streamContents: [:t2 | t1 asArray sort
				do: [:t3 | t2 nextPutAll: '---------- package ';
						 nextPutAll: t3 scriptSelector;
						 nextPutAll: ' ----------';
						 cr;
						 nextPutAll: t3 script;
						 cr]
				separatedBy: [t2 cr]]! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
selectedClass
	classSelection
		ifNil: [^ nil].
	^ Smalltalk
		at: classSelection
		ifAbsent: []! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
selectedClassOrMetaClass
	| t1 |
	classSelection
		ifNil: [^ nil].
	t1 := Smalltalk
				at: classSelection
				ifAbsent: [^ nil].
	^ self switchIsClass
		ifTrue: [t1 class]
		ifFalse: [t1]! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
selectedMessageCategoryName
	^ protocolSelection! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
selectedMessageName
	^ methodSelection
		ifNotNil: [^ methodSelection selector]! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: ''!
signalSwitchChanged
	self protocolSelection: 0.
	self changed: #switchIsInstance;
		 changed: #switchIsComment;
		 changed: #switchIsClass;
		 changed: #protocolList;
		 changed: #methodList;
		 changed: #text! !

!MCSnapshotBrowser methodsFor: 'accessing' stamp: ''!
snapshot: t1 
	items := t1 definitions asSortedCollection.
	self categorySelection: 0! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: ''!
switchBeClass
	switch := #class.
	self signalSwitchChanged! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: ''!
switchBeComment
	switch := #comment.
	self signalSwitchChanged! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: ''!
switchBeInstance
	switch := #instance.
	self signalSwitchChanged! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: ''!
switchIsClass
	^ switch = #class! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: ''!
switchIsComment
	^ switch = #comment! !

!MCSnapshotBrowser methodsFor: 'switch' stamp: ''!
switchIsInstance
	switch
		ifNil: [switch := #instance].
	^ switch = #instance! !

!MCSnapshotBrowser methodsFor: 'text' stamp: ''!
text
	self switchIsComment
		ifTrue: [^ self classCommentString].
	methodSelection
		ifNotNil: [^ methodSelection source].
	protocolSelection
		ifNotNil: [^ ''].
	classSelection
		ifNotNil: [^ self classDefinitionString].
	categorySelection
		ifNil: [^ self scriptDefinitionString].
	^ ''! !

!MCSnapshotBrowser methodsFor: 'text' stamp: ''!
text: t1 
	self changed: #text! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: 'bf 8/21/2012 21:42'!
visibleCategories
	^ ((self packageOrganizations gather: [:ea | ea categories]),
		(self packageClasses collect: [:ea | ea category]),
			(self hasExtensions ifTrue: [{self extensionsCategory}] ifFalse: [#()]))
				asSet asSortedCollection! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: ''!
visibleClasses
	^ categorySelection = self extensionsCategory
		ifTrue: [self extensionClassNames]
		ifFalse: [self packageClasses
				select: [:t1 | t1 category = categorySelection]
				thenCollect: [:t1 | t1 className]]! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: ''!
visibleMethods
	^ classSelection
		ifNil: [#()]
		ifNotNil: [self methodsForSelectedProtocol]! !

!MCSnapshotBrowser methodsFor: 'listing' stamp: ''!
visibleProtocols
	| t1 t2 |
	self switchIsComment
		ifTrue: [^ Array new].
	t1 := self methodsForSelectedClass.
	t2 := (t1
				collect: [:t3 | t3 category]) asSet asSortedCollection.
	t2 size > 1
		ifTrue: [t2 add: '-- all --'].
	^ t2! !

!MCSnapshotBrowser methodsFor: 'morphic ui' stamp: ''!
widgetSpecs
	Preferences annotationPanes
		ifFalse: [^ #(#(#(#listMorph: #category ) #(0 0 0.25 0.4 ) ) #(#(#listMorph: #class ) #(0.25 0 0.5 0.4 ) #(0 0 0 -30 ) ) #(#(#listMorph: #protocol ) #(0.5 0 0.75 0.4 ) ) #(#(#listMorph:selection:menu:keystroke: #methodList #methodSelection #methodListMenu: #methodListKey:from: ) #(0.75 0 1 0.4 ) ) #(#(#buttonRow ) #(0.25 0.4 0.5 0.4 ) #(0 -30 0 0 ) ) #(#(#codePane: #text ) #(0 0.4 1 1 ) ) )].
	^ #(#(#(#listMorph: #category ) #(0 0 0.25 0.4 ) ) #(#(#listMorph: #class ) #(0.25 0 0.5 0.4 ) #(0 0 0 -30 ) ) #(#(#listMorph: #protocol ) #(0.5 0 0.75 0.4 ) ) #(#(#listMorph:selection:menu:keystroke: #methodList #methodSelection #methodListMenu: #methodListKey:from: ) #(0.75 0 1 0.4 ) ) #(#(#buttonRow ) #(0.25 0.4 0.5 0.4 ) #(0 -30 0 0 ) ) #(#(#textMorph: #annotations ) #(0 0.4 1 0.4 ) #(0 0 0 30 ) ) #(#(#codePane: #text ) #(0 0.4 1 1 ) #(0 30 0 0 ) ) )! !

MCTool subclass: #MCSaveVersionDialog
	instanceVariableNames: 'name message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
accept
	self
		answer: (Array with: (self findTextMorph: #versionName) text asString with: (self findTextMorph: #logMessage) text asString)! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
buttonSpecs
	^ #(#(#Accept #accept 'accept version name and log message' ) #(#Cancel #cancel 'cancel saving version' ) )! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
cancel
	self answer: nil! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
defaultExtent
	^ 400 @ 300! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
defaultLabel
	^ 'Edit Version Name and Message:'! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
logMessage
	^ message
		ifNil: ['empty log message']! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
logMessage: t1 
	message := t1.
	self changed: #logMessage! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
representsSameBrowseeAs: t1 
	^ self class = t1 class
		and: [self versionName = t1 versionName]! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
versionName
	^ name! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
versionName: t1 
	name := t1.
	self changed: #versionName! !

!MCSaveVersionDialog methodsFor: 'as yet unclassified' stamp: ''!
widgetSpecs
	^ #(#(#(#textMorph: #versionName ) #(0 0 1 0 ) #(0 0 0 30 ) ) #(#(#textMorph: #logMessage ) #(0 0 1 1 ) #(0 30 0 -30 ) ) #(#(#buttonRow ) #(0 1 1 1 ) #(0 -40 0 0 ) ) )! !

!MCTool class methodsFor: 'window color' stamp: ''!
windowColorSpecification
	^ WindowColorSpec
		classSymbol: self name
		wording: 'Monticello Tool'
		brightColor: (Color
				r: 0.627
				g: 0.69
				b: 0.976)
		pastelColor: (Color
				r: 0.65
				g: 0.753
				b: 0.976) paler
		helpMessage: 'A Tool Window for the Monticello VCS'! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
answer: t1 
	modalValue := t1.
	self close! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
arrowKey: t1 from: t2 
	^ self! !

!MCTool methodsFor: 'morphic ui' stamp: 'nice 9/22/2010 00:34'!
buildWindow
	| window |
	Smalltalk at: #ToolBuilder ifPresent: [:tb | ^tb build: self].
	window := SystemWindow labelled: self label.
	window model: self.
	self widgetSpecs do: [:spec |
		| send fractions offsets |
		send := spec first.
		fractions := spec at: 2 ifAbsent: [#(0 0 1 1)].
		offsets := spec at: 3 ifAbsent: [#(0 0 0 0)].
		window
			addMorph: (self perform: send first withArguments: send allButFirst)
			fullFrame:
				(LayoutFrame
					fractions: 
						((fractions first)@(fractions second) corner: 
							(fractions third)@(fractions fourth))
					offsets:
						((offsets first)@(offsets second)  corner:
							(offsets third)@(offsets fourth)))].
	^ window! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
buildWith: t1 
	| t2 |
	t2 := MCToolWindowBuilder builder: t1 tool: self.
	self widgetSpecs
		do: [:t3 | 
			| t4 t5 t6 |
			t4 := t3 first.
			t5 := t3
						at: 2
						ifAbsent: [#(0 0 1 1 )].
			t6 := t3
						at: 3
						ifAbsent: [#(0 0 0 0 )].
			t2
				frame: (LayoutFrame
						fractions: (t5 first @ t5 second corner: t5 third @ t5 fourth)
						offsets: (t6 first @ t6 second corner: t6 third @ t6 fourth)).
			t2 perform: t4 first withArguments: t4 allButFirst].
	^ t2 build! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
buttonEnabled
	^ true! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
buttonRow
	^ self buttonRow: self buttonSpecs! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
buttonRow: t1 
	| t2 |
	t2 := AlignmentMorph newRow.
	t2
		color: (Display depth <= 8
				ifTrue: [Color transparent]
				ifFalse: [Color gray alpha: 0.2]);
		 borderWidth: 0.
	t2 hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 rubberBandCells: true.
	t2 clipSubmorphs: true.
	t2 layoutInset: 2 @ 2;
		 cellInset: 1;
		 color: Color white.
	t2 wrapCentering: #center;
		 cellPositioning: #leftCenter.
	t1
		do: [:t3 | 
			| t4 t5 |
			t5 := t3
						at: 4
						ifAbsent: [#buttonState].
			t4 := PluggableButtonMorph
						on: self
						getState: t5
						action: #performButtonAction:enabled:.
			t4 hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 label: t3 first asString;
				
				arguments: (Array with: t3 second with: t5);
				 onColor: Color white offColor: Color white.
			t2 addMorphBack: t4.
			t4 setBalloonText: t3 third].
	^ t2! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
buttonSelected
	^ false! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
buttonSpecs
	^ #()! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
buttonState
	^ true! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
close
	self window delete! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
codePane: t1 
	| t2 |
	t2 := PluggableTextMorphPlus
				on: self
				text: t1
				accept: (t1 , ':') asSymbol.
	t2 useDefaultStyler.
	^ t2! !

!MCTool methodsFor: 'morphic ui' stamp: 'nice 9/22/2010 02:03'!
defaultAnnotationPaneHeight 
	"Answer the receiver's preferred default height for new annotation panes.
	Since MC compares two annotations, reserve a bit less than a double the traditional height."
	^ (Preferences parameterAt: #defaultAnnotationPaneHeight ifAbsentPut: [25]) * 5 // 3! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
defaultBackgroundColor
	^ Preferences monticelloToolWindowColor! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
defaultButtonPaneHeight
	^ Preferences
		parameterAt: #defaultButtonPaneHeight
		ifAbsentPut: [25]! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
defaultExtent
	^ 500 @ 500! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
defaultLabel
	^ self class name! !

!MCTool methodsFor: 'morphic ui' stamp: 'eem 4/13/2012 10:21'!
fillMenu: aMenu fromSpecs: anArray
	anArray do:
		[:spec |
		spec == #addLine
			ifTrue: [aMenu addLine]
			ifFalse:
				[aMenu
					add: spec first
					target: self
					selector: spec second
					argumentList: (spec allButFirst: 2)]].
	^aMenu! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
findListMorph: t1 
	^ morph submorphs
		detect: [:t2 | (t2 respondsTo: #getListSelector)
				and: [t2 getListSelector = t1]]
		ifNone: []! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
findTextMorph: t1 
	^ morph submorphs
		detect: [:t2 | (t2 respondsTo: #getTextSelector)
				and: [t2 getTextSelector = t1]]
		ifNone: []! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
getMenu: t1 
	^ t1! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
label
	^ label
		ifNil: [self defaultLabel]! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
label: t1 
	label := t1! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
listMorph: t1 
	^ self
		listMorph: (t1 , 'List') asSymbol
		selection: (t1 , 'Selection') asSymbol
		menu: (t1 , 'ListMenu:') asSymbol! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
listMorph: t1 keystroke: t2 
	^ (self
		listMorph: (t1 , 'List') asSymbol
		selection: (t1 , 'Selection') asSymbol
		menu: (t1 , 'ListMenu:') asSymbol) keystrokeActionSelector: t2;
		 yourself! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
listMorph: t1 selection: t2 
	^ PluggableListMorph
		on: self
		list: t1
		selected: t2
		changeSelected: (t2 , ':') asSymbol! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
listMorph: t1 selection: t2 menu: t3 
	^ PluggableListMorph
		on: self
		list: t1
		selected: t2
		changeSelected: (t2 , ':') asSymbol
		menu: t3! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
listMorph: t1 selection: t2 menu: t3 keystroke: t4 
	^ (PluggableListMorph
		on: self
		list: t1
		selected: t2
		changeSelected: (t2 , ':') asSymbol
		menu: t3) keystrokeActionSelector: t4;
		 yourself! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
multiListMorph: t1 selection: t2 listSelection: t3 menu: t4 
	^ PluggableListMorphOfMany
		on: self
		list: t1
		primarySelection: t2
		changePrimarySelection: (t2 , ':') asSymbol
		listSelection: t3
		changeListSelection: (t3 , 'put:') asSymbol
		menu: t4! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
perform: t1 orSendTo: t2 
	(self respondsTo: t1)
		ifTrue: [^ self perform: t1].
	^ t2 perform: t1! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
performButtonAction: t1 enabled: t2 
	(self perform: t2)
		ifTrue: [self perform: t1]! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
postAcceptBrowseFor: t1 
	^ self! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
representsSameBrowseeAs: t1 
	^ false! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
show
	modal := false.
	Smalltalk
		at: #ToolBuilder
		ifPresent: [:t1 | 
			t1 open: self.
			^ self].
	^ self window openInWorldExtent: self defaultExtent;
		 yourself! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
showLabelled: t1 
	modal := false.
	self label: t1.
	^ self window openInWorldExtent: self defaultExtent;
		 yourself! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
showModally
	modal := true.
	self window openInWorldExtent: 400 @ 400.
	[self window world notNil]
		whileTrue: [self window outermostWorldMorph doOneCycle].
	morph := nil.
	^ modalValue! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
step
	^ self! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
textMorph: t1 
	^ PluggableTextMorph
		on: self
		text: t1
		accept: (t1 , ':') asSymbol! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
treeMorph: t1 
	^ self
		treeMorph: (t1 , 'Tree') asSymbol
		selection: (t1 , 'SelectionWrapper') asSymbol
		menu: (t1 , 'TreeMenu:') asSymbol! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
treeMorph: t1 selection: t2 menu: t3 
	^ SimpleHierarchicalListMorph
		on: self
		list: t1
		selected: t2
		changeSelected: (t2 , ':') asSymbol
		menu: t3
		keystroke: nil! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
treeOrListMorph: t1 
	^ self treeMorph: t1! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
widgetSpecs
	^ #()! !

!MCTool methodsFor: 'morphic ui' stamp: ''!
window
	^ morph
		ifNil: [morph := self buildWindow]! !

MCTool subclass: #MCVersionHistoryBrowser
	instanceVariableNames: 'ancestry index repositoryGroup package infos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
ancestry: t1 
	ancestry := t1! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
baseSnapshot
	^ self snapshotForInfo: ancestry! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: ''!
defaultExtent
	^ 440 @ 169! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: ''!
defaultLabel
	^ ancestry name , ' History'! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: 'bf 12/22/2012 15:37'!
getMenu: aMenu
	self selection < 2 ifTrue: [^ aMenu].
	self fillMenu: aMenu fromSpecs: 
		{{'view changes to ', ancestry name . #viewChanges}},
		(self selectedInfo ancestors collect: [:parent |
			{'view changes from ', parent name . #viewChanges: . parent}]),
		#(('spawn history' spawnHistory)).
	^ aMenu! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
index
	^ index! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
index: t1 
	index := t1! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: 'bf 12/8/2011 18:53'!
infos
	^ infos ifNil: [infos := ancestry topologicalAncestors]! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
list
	^ self infos
		collect: [:t1 | t1 name]! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
package: t1 
	package := t1! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
repositoryGroup
	^ MCRepositoryGroup default! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
selectedInfo
	^ self infos
		at: self selection
		ifAbsent: []! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
selectedSnapshot
	^ self snapshotForInfo: self selectedInfo! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
selection
	^ index
		ifNil: [0]! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
selection: t1 
	index := t1.
	self changed: #selection;
		 changed: #summary! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
snapshotForInfo: t1 
	^ (self repositoryGroup versionWithInfo: t1) snapshot! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: ''!
spawnHistory
	MCVersionHistoryBrowser new ancestry: self selectedInfo;
		 package: package;
		 show! !

!MCVersionHistoryBrowser methodsFor: 'accessing' stamp: ''!
summary
	| t1 |
	t1 := self selectedInfo.
	^ t1
		ifNil: ['']
		ifNotNil: [t1 summary]! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: 'bf 9/27/2011 15:00'!
viewChanges
	self viewChanges: ancestry snapshot: self baseSnapshot
		relativeTo: self selectedInfo snapshot: self selectedSnapshot! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: 'bf 9/27/2011 15:00'!
viewChanges: otherInfo
	self viewChanges: self selectedInfo snapshot: self selectedSnapshot
		relativeTo:  otherInfo snapshot: (self snapshotForInfo: otherInfo)! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: 'bf 9/27/2011 14:59'!
viewChanges: ancestorInfo snapshot: ancestorSnapshot relativeTo: baseInfo snapshot: baseSnapshot
	"Note that the patchLabel will be parsed in MCPatchBrowser>>installSelection, so don't translate it!!"
	| patch patchLabel |
	patchLabel := 'changes between {1} and {2}' format: { baseInfo name. ancestorInfo name }.
	patch := ancestorSnapshot patchRelativeToBase: baseSnapshot.
	(MCPatchBrowser forPatch: patch) label: patchLabel; show! !

!MCVersionHistoryBrowser methodsFor: 'morphic ui' stamp: ''!
widgetSpecs
	^ #(#(#(#listMorph:selection:menu: #list #selection #getMenu: ) #(0 0 0.3 1 ) ) #(#(#textMorph: #summary ) #(0.3 0 1 1 ) ) )! !

MCVersionHistoryBrowser subclass: #MCWorkingHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCWorkingHistoryBrowser methodsFor: 'as yet unclassified' stamp: ''!
baseSnapshot
	^ package snapshot! !

MCTool subclass: #MCVersionInspector
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

MCVersionInspector subclass: #MCRepositoryInspector
	instanceVariableNames: 'repository packageNames versionNames selectedPackage selectedVersion order versionInfo loaded newer inherited'
	classVariableNames: 'BrowseBranchedVersionsSeparately Order'
	poolDictionaries: ''
	category: 'Monticello-UI'!

MCRepositoryInspector subclass: #MCFileRepositoryInspector
	instanceVariableNames: 'allVersionNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCFileRepositoryInspector methodsFor: 'private' stamp: 'cmm 3/4/2011 16:27'!
allVersionNames
	^ allVersionNames ifNil:
		[ self initializeVersionNames.
		allVersionNames ]! !

!MCFileRepositoryInspector methodsFor: 'private' stamp: 'cmm 3/4/2011 16:26'!
initializeVersionNames
	repository cacheAllFileNamesDuring:
		[ super initializeVersionNames.
		allVersionNames := repository readableFileNames ]! !

!MCFileRepositoryInspector methodsFor: 'private' stamp: 'stephaneducasse 2/4/2006 20:47'!
versionInfo
	^ versionInfo ifNil: [versionInfo := repository versionInfoFromFileNamed: selectedVersion]! !

!MCFileRepositoryInspector methodsFor: 'private' stamp: 'cmm 3/4/2011 16:21'!
versionNamesForNoPackageSelection
	^ self allVersionNames! !

!MCFileRepositoryInspector methodsFor: 'private' stamp: 'eem 6/7/2012 10:11'!
versionNamesForSelectedPackage
	^ self allVersionNames select:
		(self class browseBranchedVersionsSeparately
			ifTrue: [[:each| each packageAndBranchName = selectedPackage]]
			ifFalse: [[:each| each packageName = selectedPackage]])! !

!MCFileRepositoryInspector methodsFor: 'private' stamp: 'cmm 3/6/2011 15:21'!
versionSelection: aNumber 
	versionInfo := nil.
	super versionSelection: aNumber! !

!MCFileRepositoryInspector methodsFor: 'morphic ui' stamp: ''!
versionSummary
	^ version
		ifNil: [self versionInfo summary]
		ifNotNil: [version summary]! !

!MCRepositoryInspector class methodsFor: 'class initialization' stamp: 'eem 7/11/2012 15:35'!
browseBranchedVersionsSeparately

	<preference: 'Browse branched package versions separately'
	category: 'Monticello'
	description: 'If true, versions of packages on branches will be shown in a separate section from trunk package versions'
	type: #Boolean>
	^BrowseBranchedVersionsSeparately ifNil: [true]! !

!MCRepositoryInspector class methodsFor: 'class initialization' stamp: 'eem 6/7/2012 10:05'!
browseBranchedVersionsSeparately: aBoolean
	BrowseBranchedVersionsSeparately := aBoolean! !

!MCRepositoryInspector class methodsFor: 'class initialization' stamp: 'bf 3/16/2005 14:41'!
initialize
	"self initialize"

	self migrateInstances! !

!MCRepositoryInspector class methodsFor: 'class initialization' stamp: 'bf 3/16/2005 14:53'!
migrateInstances
	self allSubInstancesDo: [:inst |
		#(packageList versionList) do: [:each |
			[(inst findListMorph: each) highlightSelector: nil]
				on: Error do: [:ignore | ]]].! !

!MCRepositoryInspector class methodsFor: 'class initialization' stamp: 'stephaneducasse 2/4/2006 20:47'!
order
	Order isNil
		ifTrue: [ Order := 5 ].
	^Order! !

!MCRepositoryInspector class methodsFor: 'class initialization' stamp: 'stephaneducasse 2/4/2006 20:47'!
order: anInteger
	Order := anInteger! !

!MCRepositoryInspector class methodsFor: 'instance creation' stamp: 'lr 9/26/2003 20:09'!
repository: aFileBasedRepository workingCopy: aWorkingCopy
	^self new
		setRepository: aFileBasedRepository workingCopy: aWorkingCopy;
		yourself! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'lr 11/10/2003 22:37'!
defaultExtent
	^450@300! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'lr 9/26/2003 20:06'!
defaultLabel
	^'Repository: ' , repository description! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'avi 9/17/2005 17:21'!
hasVersion
	^ selectedVersion notNil! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'bf 4/20/2011 14:47'!
identifyLoadedAndInherited: aMCWorkingCopy 
	| seen |
	seen := Set new.
	aMCWorkingCopy ancestors do:
		[ : ancestor | loaded add: ancestor versionName.
		seen add: ancestor.
		ancestor ancestorsDoWhileTrue:
			[ : heir | (seen includes: heir)
				ifTrue: [ false ]
				ifFalse:
					[ inherited add: heir versionName.
					seen add: heir.
					true ] ] ]! !

!MCRepositoryInspector methodsFor: 'initialize-release' stamp: 'eem 7/11/2012 15:25'!
identifyNewerVersionsOf: aMCWorkingCopy 
	(repository possiblyNewerVersionsOfAnyOf: aMCWorkingCopy ancestry names) do:
		[ : eachNewerVersionName |
		newer add: (self class browseBranchedVersionsSeparately
						ifTrue: [ eachNewerVersionName packageAndBranchName ]
						ifFalse: [ eachNewerVersionName packageName ]) ]! !

!MCRepositoryInspector methodsFor: 'initialize-release' stamp: 'cmm 3/2/2011 23:05'!
initialize
	super initialize.
	self initializeEmphasis! !

!MCRepositoryInspector methodsFor: 'initialize-release' stamp: 'cmm 3/15/2011 13:25'!
initializeEmphasis
	inherited := Set new.
	loaded := Set new! !

!MCRepositoryInspector methodsFor: 'initialize-release' stamp: 'bf 5/31/2012 11:48'!
initializeVersionNames
	repository cacheAllFileNamesDuring:
		[ versionNames := selectedPackage
			ifNil: [Array new]
			ifNotNil: [repository versionNamesForPackageNamed: selectedPackage].
		self refreshEmphasis ]! !

!MCRepositoryInspector methodsFor: 'actions' stamp: 'avi 9/18/2005 10:54'!
load
	self hasVersion ifTrue:
		[self version isCacheable
			ifTrue: [version workingCopy repositoryGroup addRepository: repository].
		super load.
		self refresh].! !

!MCRepositoryInspector methodsFor: 'actions' stamp: 'bf 11/16/2004 11:56'!
merge
	super merge.
	self refresh.
! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'stephaneducasse 2/4/2006 20:47'!
order: anInteger
	self class order: (order := anInteger).
	self changed: #versionList.! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'bf 5/31/2012 11:55'!
orderSpecs
	^{
		'unchanged' -> nil.
		'order by package' -> [ :x :y | x packageName < y packageName ].
		'order by author' -> [ :x :y | x author caseInsensitiveLessOrEqual: y author ].
		'order by version-string' -> [ :x :y | x versionNumber asString < y versionNumber asString ].
		'order by version-number' -> [ :x :y | x versionNumber > y versionNumber ].
		'order by filename' -> [ :x :y | x fileName < y fileName ].
	}! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'lr 9/26/2003 21:07'!
orderString: anIndex
	^String streamContents: [ :stream |
		order = anIndex
			ifTrue: [ stream nextPutAll: '<yes>' ]
			ifFalse: [ stream nextPutAll: '<no>' ].
		stream nextPutAll: (self orderSpecs at: anIndex) key ]! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'eem 7/11/2012 15:29'!
packageHighlight: aString 
	^ (loaded anySatisfy:
		[ : each | (self class browseBranchedVersionsSeparately
					ifTrue: [each packageAndBranchName]
					ifFalse: [each packageName]) = aString ])
		ifTrue:
			[ Text
				string: aString
				attribute:
					(TextEmphasis new emphasisCode:
						((newer includes: aString)
							ifTrue: [ 5 ]
							ifFalse: [ 4 ])) ]
		ifFalse: [ aString ]! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'eem 6/7/2012 10:10'!
packageList
	| result loadedPackages |
	packageNames ifNotNil: [ ^ packageNames ].
	repository cacheAllFileNamesDuring: 
		[ "Enjoy emphasis side-effects of populating my versionNames." 
		self versionNames.
		result := self class browseBranchedVersionsSeparately
					ifTrue: [ repository allPackageAndBranchNames ]
					ifFalse: [ repository allPackageNames ] ].
	"sort loaded packages first, then alphabetically"
	loadedPackages := Set new: loaded size.
	loaded do:
		[ : each | loadedPackages add: each packageName ].
	result := result asArray sort:
		[ : a : b | | loadedA loadedB |
		loadedA := loadedPackages includes: a.
		loadedB := loadedPackages includes: b.
		loadedA = loadedB
			ifTrue: [ a < b ]
			ifFalse: [ loadedA ] ].
	^ packageNames := result collect:
		[ : each | self packageHighlight: each ]! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'lr 9/26/2003 17:25'!
packageListMenu: aMenu
	^aMenu! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'lr 9/26/2003 20:17'!
packageSelection
	^self packageList indexOf: selectedPackage! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'cmm 11/27/2011 17:30'!
packageSelection: aNumber
	selectedPackage := (aNumber between: 1 and: self packageList size)
		ifTrue: [ (self packageList at: aNumber) asString ].
	self versionSelection: 0.
	versionNames := nil.
	self changed: #packageSelection; changed: #versionList! !

!MCRepositoryInspector methodsFor: 'initialize-release' stamp: 'cmm 2/14/2010 20:26'!
postAcceptBrowseFor: aModel
	"Make the same selections as in aModel."
	self 
		packageSelection: aModel packageSelection ;
		versionSelection: aModel versionSelection! !

!MCRepositoryInspector methodsFor: 'actions' stamp: 'cmm 3/15/2011 13:47'!
refresh
	packageNames := versionNames := newer := nil.
	repository refresh.
	self
		 changed: #packageList ;
		 changed: #versionList.! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'cmm 3/15/2011 13:55'!
refreshEmphasis
	| identifyNewer |
	identifyNewer := newer isNil.
	identifyNewer ifTrue: [ newer := Set new ].
	self initializeEmphasis.
	MCWorkingCopy allManagers do:
		[ : each | self identifyLoadedAndInherited: each.
		identifyNewer ifTrue: [ self identifyNewerVersionsOf: each ] ]! !

!MCRepositoryInspector methodsFor: 'access' stamp: 'cmm 2/14/2010 09:54'!
repository
	^ repository! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'cmm 2/14/2010 10:10'!
representsSameBrowseeAs: anotherModel 
	^ self class = anotherModel class
	and: [ self repository = anotherModel repository ]! !

!MCRepositoryInspector methodsFor: 'initialize-release' stamp: 'cmm 3/7/2011 21:43'!
setRepository: aFileBasedRepository workingCopy: aWorkingCopy 
	order := self class order.
	repository := aFileBasedRepository.
	self refresh.
	aWorkingCopy
		ifNil: [ self packageSelection: 1 ]
		ifNotNil:
			[ selectedPackage := aWorkingCopy ancestry ancestors ifNotEmpty:
				[ : ancestors | ancestors anyOne name asMCVersionName packageName ] ].
	MCWorkingCopy addDependent: self! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'cmm 3/6/2011 16:17'!
version
	^ version ifNil:
		[Cursor wait showWhile:
			[version := repository versionNamed: selectedVersion].
		version]! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'cmm 3/4/2011 15:39'!
versionHighlight: aMCVersionName
	inherited ifNil: [inherited := #()].
	^Text
		string: aMCVersionName
		attribute: (TextEmphasis new emphasisCode: (
			((loaded includes: aMCVersionName) ifTrue: [ 4 "underlined" ]
				ifFalse: [ (inherited includes: aMCVersionName)
					ifTrue: [ 0 ]
					ifFalse: [ 1 "bold" ] ])))! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'cmm 3/4/2011 16:19'!
versionList
	| result |
	result := selectedPackage
		ifNil: [ self versionNamesForNoPackageSelection ]
		ifNotNil: [ self versionNamesForSelectedPackage ].
	"Not sure why we need this ugly Error trapping here.."
	(self orderSpecs at: order) value ifNotNil:
		[ : sortBlock | result sort:
			[ : a : b | [ sortBlock
				value: a
				value: b ]
				on: Error
				do: [ true ] ] ].
	^ result collect:
		[ : each | self versionHighlight: each ]! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'lr 9/26/2003 21:07'!
versionListMenu: aMenu
	1 to: self orderSpecs size do: [ :index |
		aMenu addUpdating: #orderString: target: self selector: #order: argumentList: { index } ].
	^aMenu! !

!MCRepositoryInspector methodsFor: 'access' stamp: 'cmm 3/4/2011 16:27'!
versionNames
	^ versionNames ifNil:
		[ self initializeVersionNames.
		versionNames ]! !

!MCRepositoryInspector methodsFor: 'access' stamp: 'cmm 3/4/2011 16:04'!
versionNamesForNoPackageSelection
	^ Array empty! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'cmm 3/4/2011 16:06'!
versionNamesForSelectedPackage
	^ self versionNames! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'lr 9/26/2003 20:18'!
versionSelection
	^self versionList indexOf: selectedVersion! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'cmm 3/6/2011 15:21'!
versionSelection: aNumber 
	selectedVersion := version := nil.
	aNumber isZero ifFalse: [ selectedVersion := (self versionList at: aNumber) asString ].
	self
		 changed: #versionSelection ;
		 changed: #summary ;
		 changed: #hasVersion! !

!MCRepositoryInspector methodsFor: 'morphic ui' stamp: 'lr 9/26/2003 20:26'!
widgetSpecs
	^#(	((buttonRow) (0 0 1 0) (0 0 0 30))
		((listMorph: package) (0 0 0.5 0.6) (0 30 0 0))
		((listMorph: version) (0.5 0 1 0.6) (0 30 0 0))
		((textMorph: summary) (0 0.6 1 1) (0 0 0 0)) )! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'avi 2/28/2004 20:19'!
adopt
	(self confirm:
'Modifying ancestry can be dangerous unless you know
what you are doing.  Are you sure you want to adopt
',self version info name, ' as an ancestor of your working copy?')
		ifTrue: [self version adopt]! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'bf 3/22/2005 22:12'!
browse
	self version browse! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: 'cmm 2/28/2011 17:58'!
buttonSpecs
       ^ #(('Refresh' refresh 'refresh the version-list')
		(Browse browse 'Browse this version' hasVersion)
               (History history 'Browse the history of this version' hasVersion)
               (Changes changes 'Browse the changes this version would make to the
image' hasVersion)
               (Load load 'Load this version into the image' hasVersion)
               (Merge merge 'Merge this version into the image' hasVersion)
               (Adopt adopt 'Adopt this version as an ancestor of your working copy'
hasVersion)
               (Copy save 'Copy this version to another repository' hasVersion)
               (Diff diff 'Create an equivalent version based on an earlier release'
hasVersion))! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'nk 4/17/2004 10:05'!
changes
	(MCPatchBrowser forPatch: self version changes)
		showLabelled: 'Changes from ', self version info name! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: ''!
defaultExtent
	^ 400 @ 200! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: ''!
defaultLabel
	^ 'Version: ' , self version info name! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'ul 12/12/2009 14:09'!
diff
	| ancestorVersion |
	self pickAncestor ifNotNil:
		[:ancestor |
		ancestorVersion := self version workingCopy repositoryGroup versionWithInfo: ancestor.
		(self version asDiffAgainst: ancestorVersion) open]! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'lr 9/26/2003 20:15'!
hasVersion
	^version notNil! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'avi 9/17/2005 17:14'!
history
	(MCVersionHistoryBrowser new ancestry: self versionInfo) show! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'bf 3/14/2005 15:32'!
load
	Cursor wait showWhile: [self version load]! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'avi 2/28/2004 20:19'!
merge
	self version merge! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: ''!
pickAncestor
	| t1 t2 |
	t2 := self version info breadthFirstAncestors.
	t1 := UIManager default
				chooseFrom: (t2
						collect: [:t3 | t3 name])
				title: 'Ancestor:'.
	^ t1 = 0
		ifFalse: [t2 at: t1]! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: ''!
pickRepository
	| t1 |
	t1 := UIManager default
				chooseFrom: (self repositories
						collect: [:t2 | t2 description])
				title: 'Repository:'.
	^ t1 = 0
		ifFalse: [self repositories at: t1]! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: ''!
repositories
	^ MCRepositoryGroup default repositories! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'ul 12/12/2009 14:09'!
save
	self pickRepository ifNotNil:
		[:ea |
		ea storeVersion: self version]! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'avi 9/17/2005 17:16'!
summary
	^self hasVersion
		ifTrue: [ self versionSummary ]
		ifFalse: [ String new ]! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'avi 2/28/2004 20:19'!
version
	^ version! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:47'!
version: aVersion
	version := aVersion! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'avi 9/17/2005 17:16'!
versionInfo
	^ self version info! !

!MCVersionInspector methodsFor: 'accessing' stamp: 'avi 9/17/2005 17:16'!
versionSummary
	^ self version summary! !

!MCVersionInspector methodsFor: 'morphic ui' stamp: ''!
widgetSpecs
	^ #(#(#(#buttonRow ) #(0 0 1 0 ) #(0 0 0 30 ) ) #(#(#textMorph: #summary ) #(0 0 1 1 ) #(0 30 0 0 ) ) )! !

MCTool subclass: #MCWorkingCopyBrowser
	instanceVariableNames: 'workingCopy workingCopyWrapper repository defaults'
	classVariableNames: 'CheckForNewerVersionsBeforeSave ExternalMenuEntries'
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCWorkingCopyBrowser class methodsFor: 'hooks' stamp: 'tfel 6/12/2010 14:55'!
addMenuSpec: aMCMenuSpec
	"Register a context menu entry in the monticello browser from an external package.
	 The MCWorkingCopyBrowser model is passed as argument."
	self externalMenuEntries 
		remove: aMCMenuSpec 
		ifAbsent: ["Remove any previous entry with description string"];
		add: aMCMenuSpec.! !

!MCWorkingCopyBrowser class methodsFor: 'preferences' stamp: ''!
checkForNewerVersionsBeforeSave
	<preference: 'Check for new versions before save' category: 'Monticello' description: 'If true, MC will warn before committing to repositories that have possibly newer versions of the package being saved.' type: #Boolean>
	^ CheckForNewerVersionsBeforeSave
		ifNil: [true]! !

!MCWorkingCopyBrowser class methodsFor: 'preferences' stamp: ''!
checkForNewerVersionsBeforeSave: t1 
	CheckForNewerVersionsBeforeSave := t1! !

!MCWorkingCopyBrowser class methodsFor: 'hooks' stamp: 'tfel 6/12/2010 11:44'!
externalMenuEntries
	
	ExternalMenuEntries ifNil: [ExternalMenuEntries := Set new].
	^ ExternalMenuEntries! !

!MCWorkingCopyBrowser class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	(TheWorldMenu respondsTo: #registerOpenCommand:)
		ifTrue: [TheWorldMenu registerOpenCommand: {'Monticello Browser'. {self. #open}}]! !

!MCWorkingCopyBrowser class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCWorkingCopyBrowser class methodsFor: 'as yet unclassified' stamp: ''!
open
	self new show! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'bf 11/4/2005 17:46'!
addPackageRepository

	workingCopy ifNotNil:
		[
		(self pickRepositorySatisfying: [ :repos | (workingCopy repositoryGroup includes: repos) not ])
			ifNotNilDo:
				[:repos |
					workingCopy repositoryGroup addRepository: repos.
					self repository: repos.	
					self
						changed: #repositoryList;
						changed: #repositorySelection.
					self changedButtons]]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
addRepository
	self newRepository
		ifNotNil: [:t1 | self addRepository: t1]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
addRepository: t1 
	self repository: t1.
	self repositoryGroup addRepository: t1.
	self changed: #repositoryList;
		 changed: #repositorySelection.
	self changedButtons! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
addRepositoryToPackage
	self repository
		ifNotNil: [:t2 | (self
				pickWorkingCopySatisfying: [:t3 | (t3 repositoryGroup includes: t2) not])
				ifNotNil: [:t1 | 
					workingCopy := t1.
					workingCopy repositoryGroup addRepository: t2.
					self repository: t2.
					self changed: #workingCopySelection;
						 changed: #repositoryList;
						 changed: #repositorySelection.
					self changedButtons]]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
addRepositoryToWorkingCopy
	workingCopy
		ifNotNil: [:t1 | 
			workingCopy repositoryGroup addRepository: self repository.
			self changed: #workingCopySelection;
				 changed: #repositoryList;
				 changed: #repositorySelection.
			self changedButtons]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
addRequiredPackage
	| t1 |
	workingCopy
		ifNotNil: [:t2 | 
			t1 := self
						pickWorkingCopySatisfying: [:t3 | t3 ~= t2
								and: [(t2 requiredPackages includes: t3 package) not]].
			t1
				ifNotNil: [t2 requirePackage: t1 package.
					self workingCopyListChanged]]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
addWorkingCopy
	| t1 |
	t1 := FillInTheBlankMorph request: 'Name of package:'.
	t1 isEmptyOrNil
		ifFalse: [PackageInfo registerPackageName: t1.
			workingCopy := MCWorkingCopy
						forPackage: (MCPackage new name: t1).
			workingCopyWrapper := nil.
			self repositorySelection: 0].
	self workingCopyListChanged; changed: #workingCopySelection; changed: #repositoryList.
	self changedButtons! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
backportChanges
	self canBackport
		ifFalse: [^ self].
	workingCopy
		ifNotNil: [workingCopy needsSaving
				ifTrue: [^ self inform: 'You must save the working copy before backporting.'].
			self pickAncestorVersionInfo
				ifNotNil: [:t1 | workingCopy backportChangesTo: t1]]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
browseWorkingCopy
	workingCopy
		ifNotNil: [(MCSnapshotBrowser forSnapshot: workingCopy package snapshot) label: 'Snapshot Browser: ' , workingCopy packageName;
				 show]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
buttonSpecs
	^ #(#('+Package' #addWorkingCopy 'Add a new package and make it the working copy' ) #(#Browse #browseWorkingCopy 'Browse the working copy of the selected package' #hasWorkingCopy ) #(#Scripts #editLoadScripts 'Edit the load/unload scripts of this package' #hasWorkingCopy ) #(#History #viewHistory 'View the working copy''s history' #hasWorkingCopy ) #(#Changes #viewChanges 'View the working copy''s changes relative to the installed version from the repository' #canSave ) #(#Backport #backportChanges 'Backport the working copy''s changes to an ancestor' #canBackport ) #(#Save #saveVersion 'Save the working copy as a new version to the selected repository' #canSave ) #('+Repository' #addRepository 'Add an existing repository to the list of those visible' ) #(#Open #openRepository 'Open a browser on the selected repository' #hasRepository ) )! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
canBackport
	^ self hasWorkingCopy
		and: [workingCopy needsSaving not]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
canSave
	^ self hasWorkingCopy
		and: [self hasRepository]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
changedButtons
	self changed: #hasWorkingCopy.
	self changed: #canSave.
	self changed: #canBackport.
	self changed: #hasRepository! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'ul 5/8/2011 19:44'!
checkForNewerVersions
	| newer |
	newer := workingCopy possiblyNewerVersionsIn: self repository.
	^ newer isEmpty or: [
		self confirm: 'CAUTION!! These versions in the repository may be newer:', 
			String cr, ((newer asCommaString withNoLineLongerThan:  150) truncateWithElipsisTo: 5 * 149), String cr,
			'Do you really want to save this version?'].! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
clearRequiredPackages
	workingCopy
		ifNotNil: [:t1 | 
			t1 clearRequiredPackages.
			self workingCopyListChanged]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'cmm 8/14/2011 14:44'!
copyImageVersions
	self repository ifNotNil: [ : repos | repos copyImageVersions ]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
defaultExtent
	^ 550 @ 200! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
defaultLabel
	^ 'Monticello Browser'! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
defaults
	^ defaults
		ifNil: [defaults := Dictionary new]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
deleteWorkingCopy
	workingCopy unregister.
	self workingCopySelection: 0.
	self workingCopyListChanged! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
editLoadScripts
	| t1 |
	self hasWorkingCopy
		ifFalse: [^ self].
	t1 := MenuMorph new defaultTarget: self.
	t1
		add: 'edit preamble'
		selector: #editScript:
		argument: #preamble.
	t1
		add: 'edit postscript'
		selector: #editScript:
		argument: #postscript.
	t1
		add: 'edit preambleOfRemoval'
		selector: #editScript:
		argument: #preambleOfRemoval.
	t1
		add: 'edit postscriptOfRemoval'
		selector: #editScript:
		argument: #postscriptOfRemoval.
	t1 popUpInWorld! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
editRepository
	| t1 |
	t1 := self repository openAndEditTemplateCopy.
	t1
		ifNotNil: [t1 class = self repository class
				ifTrue: [self repository copyFrom: t1.
					self changed: #repositoryList]
				ifFalse: [self inform: 'Must not change repository type!!']]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
editScript: t1 
	| t2 |
	t2 := workingCopy packageInfo perform: t1.
	t2 openLabel: t1 asString , ' of the Package ' , workingCopy package name! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
flushAllCaches
	| t1 t3 t4 t5 |
	Cursor wait
		showWhile: [t1 := Smalltalk garbageCollect.
			t4 := MCVersion allSubInstances size.
			MCFileBasedRepository flushAllCaches.
			t3 := Smalltalk garbageCollect.
			t5 := MCVersion allSubInstances size].
	^ self inform: (t4 - t5) asString , ' versions flushed' , String cr , (t3 - t1) asStringWithCommas , ' bytes reclaimed'! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
hasRepository
	^ self repository notNil! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
hasWorkingCopy
	^ workingCopy notNil! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
initialize
	MCWorkingCopy addDependent: self.
	self workingCopies
		do: [:t1 | t1 addDependent: self]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'tfel 6/12/2010 13:47'!
insertExternalMenuEntries: aMenu
	
	self class externalMenuEntries ifNotEmpty: [
		aMenu addLine.
		self class externalMenuEntries do: [:each |
			aMenu 
				add: each entry 
				target: each target
				selector: each selector
				argument: self]].! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
inspectWorkingCopy
	workingCopy
		ifNotNil: [workingCopy inspect]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
loadRepositories
	FileStream fileIn: 'MCRepositories.st'.
	self changed: #repositoryList.
	self changedButtons! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
newRepository
	| t1 t2 |
	t1 := MCRepository allConcreteSubclasses asArray.
	t2 := UIManager default
				chooseFrom: (t1
						collect: [:t3 | t3 description])
				title: 'Repository type:'.
	^ t2 = 0
		ifFalse: [(t1 at: t2) morphicConfigure]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
openRepository
	self repository
		ifNotNil: [:t1 | t1 morphicOpen: workingCopy]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
pickAncestorVersionInfo
	| t1 t2 |
	t1 := workingCopy ancestry breadthFirstAncestors.
	t2 := UIManager default
				chooseFrom: (t1
						collect: [:t3 | t3 name])
				title: 'Ancestor:'.
	^ t2 = 0
		ifFalse: [t1 at: t2]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'ar 3/6/2006 18:16'!
pickRepositorySatisfying: aBlock
	| repos index |
	repos := MCRepositoryGroup default repositories select: aBlock.
	index := UIManager default chooseFrom: (repos collect: [:ea | ea description])
				title: 'Repository:'.
	^ index = 0 ifFalse: [repos at: index]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
pickWorkingCopy
	^ self
		pickWorkingCopySatisfying: [:t1 | true]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
pickWorkingCopySatisfying: t1 
	| t2 t3 |
	t2 := self workingCopies select: t1.
	t2 isEmpty
		ifTrue: [^ nil].
	t3 := UIManager default
				chooseFrom: (t2
						collect: [:t4 | t4 packageName])
				title: 'Package:'.
	^ t3 = 0
		ifFalse: [t2 at: t3]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
recompilePackage
	workingCopy package packageInfo methods
		do: [:t1 | t1 actualClass recompile: t1 methodSymbol]
		displayingProgress: 'Recompiling...'! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
removeRepository
	self repository
		ifNotNil: [:t1 | 
			self repositoryGroup removeRepository: t1.
			self
				repositorySelection: (1 min: self repositories size)].
	self changed: #repositoryList.
	self changedButtons! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'cmm 6/6/2011 16:56'!
renamePackage
	| newName |
	workingCopy ifNil:
		[ UIManager inform: 'Please select a package to be renamed.'.
		^ self ].
	workingCopy modified ifTrue:
		[ UIManager inform: 'Only unmodified packages should be renamed.'.
		^ self ].
	newName := FillInTheBlankMorph
		request: 'New name of package:'
		initialAnswer: workingCopy packageName.
	newName isEmptyOrNil ifFalse:
		[ | newWorkingCopy |
		newWorkingCopy := workingCopy renameToBe: newName.
		workingCopy package snapshot definitions
			ifEmpty:
				[ "It worked."
				workingCopy unregister.
				workingCopy := newWorkingCopy.
				self repositorySelection: 0.
				self
					 workingCopyListChanged ;
					 changed: #workingCopySelection ;
					 changed: #repositoryList.
				self changedButtons ]
			ifNotEmpty: 
				[ "It didn't work, browse the remaining definitions."
				self browseWorkingCopy ] ]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
repositories
	^ self repositoryGroup repositories! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
repository
	workingCopy
		ifNotNil: [repository := self defaults
						at: workingCopy
						ifAbsent: []].
	^ repository! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
repository: t1 
	repository := t1.
	workingCopy
		ifNotNil: [self defaults at: workingCopy put: t1]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
repositoryGroup
	^ workingCopy
		ifNil: [MCRepositoryGroup default]
		ifNotNil: [workingCopy repositoryGroup]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
repositoryList
	^ self repositories
		collect: [:t1 | t1 description]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'eem 4/13/2012 10:28'!
repositoryListMenu: aMenu
	"first add repository-specific commands"
	self repository ifNotNil:
		[self fillMenu: aMenu fromSpecs:
			#(('open repository' #openRepository)
			    ('edit repository info' #editRepository)
			   ('add to package...' #addRepositoryToPackage)
			   ('remove repository' #removeRepository)
			   ('copy image versions here' #copyImageVersions)).
		aMenu
			add: (self repository alwaysStoreDiffs
						ifTrue: ['store full versions']
						ifFalse: ['store diffs'])
				target: self
				selector: #toggleDiffs;
			addLine].
	"then the non-specific commands"
	^self fillMenu: aMenu fromSpecs:
		#(	('load repositories' #loadRepositories)
		 	('save repositories' #saveRepositories)
			('flush cached versions' #flushAllCaches))! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
repositorySelection
	^ self repositories indexOf: self repository! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
repositorySelection: t1 
	t1 = 0
		ifTrue: [self repository: nil]
		ifFalse: [self
				repository: (self repositories at: t1)].
	self changed: #repositorySelection.
	self changedButtons! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
representsSameBrowseeAs: t1 
	^ self class = t1 class! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
revertPackage
	self pickAncestorVersionInfo
		ifNotNil: [:t1 | (self repositoryGroup
				versionWithInfo: t1
				ifNone: [^ self inform: 'No repository found for ' , t1 name]) load]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
saveRepositories
	FileStream
		forceNewFileNamed: 'MCRepositories.st'
		do: [:t1 | MCRepositoryGroup default
				repositoriesDo: [:t2 | t2 asCreationTemplate
						ifNotNil: [:t3 | t1 nextPutAll: 'MCRepositoryGroup default addRepository: (' , t3 , ')!!';
								 cr]]]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
saveVersion
	| t1 |
	self canSave
		ifFalse: [^ self].
	self checkForNewerVersions
		ifFalse: [^ self].
	t1 := self repository.
	workingCopy newVersion
		ifNotNil: [:t2 | 
			(MCVersionInspector new version: t2) show.
			Cursor wait
				showWhile: [t1 storeVersion: t2].
			MCCacheRepository default
				cacheAllFileNamesDuring: [t1
						cacheAllFileNamesDuring: [t2
								allAvailableDependenciesDo: [:t3 | (t1 includesVersionNamed: t3 info name)
										ifFalse: [t1 storeVersion: t3]]]]]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: 'eem 4/26/2012 09:37'!
searchHistory
	workingCopy ifNotNil:
		[(UIManager default
			edit: (String streamContents:
					[:s|
					"Ignore the initial MCWorkingAncestry instance."
					workingCopy ancestry topologicalAncestors allButFirst
						do: [:versionInfo|
							s nextPutAll: versionInfo summary]
						separatedBy: [s cr; cr"; next: 32 put: $-; cr; cr"]])
			label: 'Version History: ',  workingCopy packageName)
				extent: (0.6@1) * Display height * 0.9]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
toggleDiffs
	self repository alwaysStoreDiffs
		ifTrue: [self repository doNotAlwaysStoreDiffs]
		ifFalse: [self repository doAlwaysStoreDiffs]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
unloadPackage
	workingCopy unload.
	self workingCopySelection: 0.
	self workingCopyListChanged! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
unsortedWorkingCopies
	^ MCWorkingCopy allManagers! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
update: t1 
	self unsortedWorkingCopies
		do: [:t2 | t2 addDependent: self].
	self workingCopyListChanged! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
viewChanges
	| t1 |
	self canSave
		ifTrue: [t1 := workingCopy changesRelativeToRepository: self repository.
			t1 isNil
				ifTrue: [^ self].
			t1 isEmpty
				ifTrue: [workingCopy modified: false.
					self inform: 'No changes']
				ifFalse: [workingCopy modified: true.
					(MCPatchBrowser forPatch: t1) label: 'Patch Browser: ' , workingCopy description;
						 show]]! !

!MCWorkingCopyBrowser methodsFor: 'actions' stamp: ''!
viewHistory
	workingCopy
		ifNotNil: [(MCWorkingHistoryBrowser new ancestry: workingCopy ancestry;
				 package: workingCopy package) label: 'Version History: ' , workingCopy packageName;
				 show]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
widgetSpecs
	^ #(#(#(#buttonRow ) #(0 0 1 0 ) #(0 0 0 30 ) ) #(#(#treeOrListMorph: #workingCopy ) #(0 0 0.5 1 ) #(0 30 0 0 ) ) #(#(#listMorph: #repository ) #(0.5 0 1 1 ) #(0 30 0 0 ) ) )! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopies
	^ MCWorkingCopy allManagers
		asSortedCollection: [:t1 :t2 | t1 package name <= t2 package name]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopy: t1 
	workingCopy := t1.
	self changed: #workingCopySelection;
		 changed: #repositoryList.
	self changedButtons! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopyList
	^ self workingCopies
		collect: [:t1 | (workingCopy notNil
					and: [workingCopy requiredPackages includes: t1 package])
				ifTrue: [Text
						string: t1 description
						emphasis: (Array with: TextEmphasis bold)]
				ifFalse: [t1 description]]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopyListChanged
	self changed: #workingCopyList.
	self changed: #workingCopyTree.
	self changedButtons! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'eem 4/26/2012 09:22'!
workingCopyListMenu: aMenu
	workingCopy ifNil: [^ aMenu].
	self fillMenu: aMenu fromSpecs:
		#(('add required package' #addRequiredPackage)
			('clear required packages' #clearRequiredPackages)
			('add repository...' #addPackageRepository)
			('browse package' #browseWorkingCopy)
			('view changes' #viewChanges)
			('view history' #viewHistory)
			('search history' #searchHistory)
			('recompile package' #recompilePackage)
			('revert package...' #revertPackage)
			('unload package' #unloadPackage)
			('delete working copy' #deleteWorkingCopy)
			('rename package...' #renamePackage)).
	(Smalltalk includesKey: #SARMCPackageDumper) ifTrue: [
		aMenu add: 'make SAR' target: self selector: #fileOutAsSAR
	].
	self insertExternalMenuEntries: aMenu.
	^aMenu! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopyListMorph
	^ PluggableMultiColumnListMorph
		on: self
		list: #workingCopyList
		selected: #workingCopySelection
		changeSelected: #workingCopySelection:
		menu: #workingCopyListMenu:! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopySelection
	^ self workingCopies indexOf: workingCopy! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopySelection: t1 
	self
		workingCopy: (t1 = 0
				ifFalse: [self workingCopies at: t1])! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopySelectionWrapper
	^ workingCopyWrapper! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopySelectionWrapper: t1 
	workingCopyWrapper := t1.
	self changed: #workingCopySelectionWrapper.
	self
		workingCopy: (t1
				ifNotNil: [t1 item])! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopyTree
	^ self workingCopies
		collect: [:t1 | MCDependentsWrapper with: t1 model: self]! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: 'eem 4/5/2012 09:49'!
workingCopyTreeMenu: aMenu
	workingCopy ifNil: [^ aMenu].
	self fillMenu: aMenu fromSpecs:
		#(('add required package' #addRequiredPackage)
			('clear required packages' #clearRequiredPackages)
			('browse package' #browseWorkingCopy)
			('add repository...' #addPackageRepository)
			('view changes' #viewChanges)
			('view history' #viewHistory)
			('recompile package' #recompilePackage)
			('revert package...' #revertPackage)
			('unload package' #unloadPackage)
			('delete working copy' #deleteWorkingCopy)
			('inspect working copy' #inspectWorkingCopy)).
	(Smalltalk includesKey: #SARMCPackageDumper) ifTrue: [
		aMenu add: 'make SAR' target: self selector: #fileOutAsSAR
	].
	^aMenu! !

!MCWorkingCopyBrowser methodsFor: 'morphic ui' stamp: ''!
workingCopyTreeMorph
	^ SimpleHierarchicalListMorph
		on: self
		list: #workingCopyTree
		selected: #workingCopyWrapper
		changeSelected: #workingCopyWrapper:
		menu: #workingCopyListMenu:! !

Object subclass: #MCToolWindowBuilder
	instanceVariableNames: 'builder window currentFrame tool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCToolWindowBuilder class methodsFor: 'as yet unclassified' stamp: ''!
builder: t1 tool: t2 
	^ self basicNew initializeWithBuilder: t1 tool: t2! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
build
	^ builder build: window! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
buttonRow
	^ self buttonRow: tool buttonSpecs! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
buttonRow: t1 
	| t2 |
	t2 := builder pluggablePanelSpec new.
	t2 children: OrderedCollection new.
	t1
		do: [:t3 | 
			| t4 |
			t4 := builder pluggableButtonSpec new.
			t4 model: tool.
			t4 label: t3 first asString.
			t4 action: t3 second.
			t4 help: t3 third.
			t4
				enabled: (t3
						at: 4
						ifAbsent: [#buttonEnabled]).
			t4
				state: (t3
						at: 5
						ifAbsent: [#buttonSelected]).
			t2 children add: t4].
	t2 layout: #horizontal.
	t2 frame: currentFrame.
	window children add: t2! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
codePane: t1 
	| t2 |
	t2 := builder pluggableCodePaneSpec new.
	t2 model: tool;
		 getText: t1;
		 setText: (t1 , ':') asSymbol;
		 frame: currentFrame.
	window children add: t2! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
frame: t1 
	currentFrame := t1! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
initializeWithBuilder: t1 tool: t2 
	builder := t1.
	tool := t2.
	window := builder pluggableWindowSpec new.
	window children: OrderedCollection new.
	window label: tool label asString.
	window model: tool.
	window extent: tool defaultExtent! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: 'nice 9/22/2010 00:42'!
innerButtonRow
	^ self buttonRow: tool innerButtonSpecs! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
listMorph: t1 
	^ self
		listMorph: (t1 , 'List') asSymbol
		selection: (t1 , 'Selection') asSymbol
		menu: (t1 , 'ListMenu:') asSymbol! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
listMorph: t1 keystroke: t2 
	^ (self
		listMorph: (t1 , 'List') asSymbol
		selection: (t1 , 'Selection') asSymbol
		menu: (t1 , 'ListMenu:') asSymbol) keystrokeActionSelector: t2;
		 yourself! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
listMorph: t1 selection: t2 
	self
		listMorph: t1
		selection: t2
		menu: nil! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
listMorph: t1 selection: t2 menu: t3 
	self
		listMorph: t1
		selection: t2
		menu: t3
		keystroke: nil! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
listMorph: t1 selection: t2 menu: t3 keystroke: t4 
	| t5 |
	t5 := builder pluggableListSpec new.
	t5 model: tool;
		 list: t1;
		 getIndex: t2;
		 setIndex: (t2 , ':') asSymbol;
		 frame: currentFrame.
	t3
		ifNotNil: [t5 menu: t3].
	t4
		ifNotNil: [t5 keyPress: t4].
	window children add: t5! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
multiListMorph: t1 selection: t2 listSelection: t3 menu: t4 
	| t5 |
	t5 := builder pluggableMultiSelectionListSpec new.
	t5 model: tool;
		 list: t1;
		 getIndex: t2;
		 setIndex: (t2 , ':') asSymbol;
		 getSelectionList: t3;
		 setSelectionList: (t3 , 'put:') asSymbol;
		 frame: currentFrame.
	t4
		ifNotNil: [t5 menu: t4].
	window children add: t5! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
textMorph: t1 
	| t2 |
	t2 := builder pluggableTextSpec new.
	t2 model: tool;
		 getText: t1;
		 setText: (t1 , ':') asSymbol;
		 frame: currentFrame.
	window children add: t2! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
treeMorph: t1 
	^ self
		treeMorph: (t1 , 'Tree') asSymbol
		selection: (t1 , 'SelectionWrapper') asSymbol
		menu: (t1 , 'TreeMenu:') asSymbol! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
treeMorph: t1 selection: t2 menu: t3 
	self notYetImplemented! !

!MCToolWindowBuilder methodsFor: 'as yet unclassified' stamp: ''!
treeOrListMorph: t1 
	^ self listMorph: t1! !

Object subclass: #MCVariableDefinition
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

MCVariableDefinition subclass: #MCClassInstanceVariableDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCClassInstanceVariableDefinition class methodsFor: 'as yet unclassified' stamp: ''!
type
	^ #classInstance! !

!MCClassInstanceVariableDefinition methodsFor: 'as yet unclassified' stamp: ''!
isClassInstanceVariable
	^ true! !

MCVariableDefinition subclass: #MCClassVariableDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCClassVariableDefinition class methodsFor: 'as yet unclassified' stamp: ''!
type
	^ #class! !

!MCClassVariableDefinition methodsFor: 'as yet unclassified' stamp: ''!
isClassVariable
	^ true! !

!MCClassVariableDefinition methodsFor: 'as yet unclassified' stamp: ''!
isOrderDependend
	^ false! !

MCVariableDefinition subclass: #MCInstanceVariableDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCInstanceVariableDefinition class methodsFor: 'as yet unclassified' stamp: ''!
type
	^ #instance! !

!MCInstanceVariableDefinition methodsFor: 'as yet unclassified' stamp: ''!
isInstanceVariable
	^ true! !

MCVariableDefinition subclass: #MCPoolImportDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCPoolImportDefinition class methodsFor: 'as yet unclassified' stamp: ''!
type
	^ #pool! !

!MCPoolImportDefinition methodsFor: 'testing' stamp: ''!
isOrderDependend
	^ false! !

!MCPoolImportDefinition methodsFor: 'testing' stamp: ''!
isPoolImport
	^ true! !

!MCVariableDefinition class methodsFor: 'as yet unclassified' stamp: ''!
name: t1 
	^ self new name: t1! !

!MCVariableDefinition methodsFor: 'comparing' stamp: ''!
= t1 
	^ self species = t1 species
		and: [self name = t1 name]! !

!MCVariableDefinition methodsFor: 'comparing' stamp: ''!
hash
	^ name hash! !

!MCVariableDefinition methodsFor: 'testing' stamp: ''!
isClassInstanceVariable
	^ false! !

!MCVariableDefinition methodsFor: 'testing' stamp: ''!
isClassInstanceVariableDefinition
	^ false! !

!MCVariableDefinition methodsFor: 'testing' stamp: ''!
isClassVariable
	^ false! !

!MCVariableDefinition methodsFor: 'testing' stamp: ''!
isInstanceVariable
	^ false! !

!MCVariableDefinition methodsFor: 'testing' stamp: ''!
isInstanceVariableDefinition
	^ false! !

!MCVariableDefinition methodsFor: 'testing' stamp: ''!
isOrderDependend
	^ true! !

!MCVariableDefinition methodsFor: 'testing' stamp: ''!
isPoolImport
	^ false! !

!MCVariableDefinition methodsFor: 'accessing' stamp: ''!
name
	^ name! !

!MCVariableDefinition methodsFor: 'accessing' stamp: ''!
name: t1 
	name := t1! !

!MCVariableDefinition methodsFor: 'as yet unclassified' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPut: $(;
		 nextPutAll: self name;
		 nextPut: $)! !

Object subclass: #MCVersion
	instanceVariableNames: 'package info snapshot dependencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

MCVersion subclass: #MCDiffyVersion
	instanceVariableNames: 'base patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCDiffyVersion class methodsFor: 'name utilities' stamp: ''!
baseNameFrom: t1 
	| t2 t3 |
	t2 := (t1 copyAfter: $()
				copyUpTo: $).
	t2
		ifEmpty: [^ t2].
	(t2 beginsWith: '@')
		ifTrue: [^ t2 copyAfter: $@].
	t3 := self verNameFrom: t1.
	^ (t2 includes: $.)
		ifTrue: [(t3 copyUpToLast: $-)
				, '-' , t2]
		ifFalse: [(t3 copyUpToLast: $.)
				, '.' , t2]! !

!MCDiffyVersion class methodsFor: 'name utilities' stamp: ''!
canonicalNameFor: t1 
	^ (self
		nameForVer: (self verNameFrom: t1)
		base: (self baseNameFrom: t1))
		, '.' , MCMcdReader extension! !

!MCDiffyVersion class methodsFor: 'name utilities' stamp: 'cmm 3/5/2011 16:39'!
nameForVer: versionName base: baseName
	| baseId |
	baseId := versionName = baseName
		ifTrue: [ baseName versionNumber asString ]
		ifFalse:
			[ versionName packageName = baseName packageName
				ifTrue: [ baseName author, '.', baseName versionNumber asString ]
				ifFalse: [ '@' , baseName ] ].
	^ versionName versionName , '(' , baseId , ')'! !

!MCDiffyVersion class methodsFor: 'instance creation' stamp: ''!
package: t1 info: t2 dependencies: t3 baseInfo: t4 patch: t5 
	^ self basicNew
		initializeWithPackage: t1
		info: t2
		dependencies: t3
		baseInfo: t4
		patch: t5! !

!MCDiffyVersion class methodsFor: 'instance creation' stamp: ''!
package: t1 info: t2 snapshot: t3 dependencies: t4 baseVersion: t5 
	^ self
		package: t1
		info: t2
		dependencies: t4
		baseInfo: t5 info
		patch: (t3 patchRelativeToBase: t5 snapshot)! !

!MCDiffyVersion class methodsFor: 'name utilities' stamp: ''!
verNameFrom: t1 
	^ t1 copyUpTo: $(! !

!MCDiffyVersion methodsFor: 'as yet unclassified' stamp: ''!
baseInfo
	^ base! !

!MCDiffyVersion methodsFor: 'as yet unclassified' stamp: 'fbs 6/9/2011 20:05'!
baseSnapshot
	| baseVersion |
	baseVersion := self workingCopy repositoryGroup versionWithInfo: base.
	baseVersion ifNil: [Error signal: 'Missing snapshot: ', self baseInfo name].
	^ baseVersion snapshot! !

!MCDiffyVersion methodsFor: 'as yet unclassified' stamp: ''!
canOptimizeLoading
	^ package hasWorkingCopy
		and: [package workingCopy modified not
				and: [package workingCopy ancestors includes: self baseInfo]]! !

!MCDiffyVersion methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2011 15:00'!
fileName
	^ ((self class
		nameForVer: info name
		base: base name) , '.' , self writerClass extension) asMCVersionName! !

!MCDiffyVersion methodsFor: 'as yet unclassified' stamp: ''!
initializeWithPackage: t1 info: t2 dependencies: t3 baseInfo: t4 patch: t5 
	patch := t5.
	base := t4.
	super
		initializeWithPackage: t1
		info: t2
		snapshot: nil
		dependencies: t3! !

!MCDiffyVersion methodsFor: 'as yet unclassified' stamp: ''!
isDiffy
	^ true! !

!MCDiffyVersion methodsFor: 'as yet unclassified' stamp: ''!
patch
	^ patch! !

!MCDiffyVersion methodsFor: 'as yet unclassified' stamp: ''!
snapshot
	^ snapshot
		ifNil: [snapshot := MCPatcher apply: patch to: self baseSnapshot]! !

!MCDiffyVersion methodsFor: 'as yet unclassified' stamp: ''!
summary
	^ '(Diff against ' , self baseInfo name , ')' , String cr , super summary! !

!MCDiffyVersion methodsFor: 'as yet unclassified' stamp: ''!
writerClass
	^ MCMcdWriter! !

!MCVersion class methodsFor: 'instance creation' stamp: ''!
package: t1 
	^ self package: t1 info: MCVersionInfo new! !

!MCVersion class methodsFor: 'instance creation' stamp: ''!
package: t1 info: t2 
	^ self
		package: t1
		info: t2
		snapshot: t1 snapshot! !

!MCVersion class methodsFor: 'instance creation' stamp: ''!
package: t1 info: t2 snapshot: t3 
	^ self
		package: t1
		info: t2
		snapshot: t3
		dependencies: #()! !

!MCVersion class methodsFor: 'instance creation' stamp: ''!
package: t1 info: t2 snapshot: t3 dependencies: t4 
	^ self new
		initializeWithPackage: t1
		info: t2
		snapshot: t3
		dependencies: t4! !

!MCVersion methodsFor: 'actions' stamp: ''!
addToCache
	MCCacheRepository default storeVersion: self! !

!MCVersion methodsFor: 'actions' stamp: ''!
adopt
	self workingCopy adopt: self! !

!MCVersion methodsFor: 'enumerating' stamp: ''!
allAvailableDependenciesDo: t1 
	self dependencies
		do: [:t2 | [| t3 |
			t3 := t2 resolve.
			t3 allAvailableDependenciesDo: t1.
			t1 value: t3]
				on: Error
				do: []]! !

!MCVersion methodsFor: 'enumerating' stamp: ''!
allDependenciesDo: t1 
	self
		allDependenciesDo: t1
		ifUnresolved: [:t2 | true]! !

!MCVersion methodsFor: 'enumerating' stamp: ''!
allDependenciesDo: t1 ifUnresolved: t2 
	| t3 |
	t3 := Dictionary new.
	self
		allDependenciesNotIn: t3
		do: t1
		ifUnresolved: t2! !

!MCVersion methodsFor: 'enumerating' stamp: ''!
allDependenciesNotIn: t1 do: t2 ifUnresolved: t3 
	self dependencies
		do: [:t4 | 
			| t5 |
			t5 := t1
						at: t4
						ifAbsent: [t4 resolve].
			t5
				ifNil: [t3 value: t4]
				ifNotNil: [(t1 includes: t5)
						ifFalse: [t1 at: t4 put: t5.
							t5
								allDependenciesNotIn: t1
								do: t2
								ifUnresolved: t3.
							t2 value: t5]]]! !

!MCVersion methodsFor: 'converting' stamp: ''!
asDiffAgainst: t1 
	t1 info = self info
		ifTrue: [self error: 'Cannot diff against self!!'].
	^ MCDiffyVersion
		package: self package
		info: self info
		snapshot: self snapshot
		dependencies: self dependencies
		baseVersion: t1! !

!MCVersion methodsFor: 'actions' stamp: ''!
browse
	(MCSnapshotBrowser forSnapshot: self snapshot) label: 'Snapshot of ' , self fileName;
		 show! !

!MCVersion methodsFor: 'testing' stamp: ''!
canOptimizeLoading
	^ false! !

!MCVersion methodsFor: 'accessing' stamp: ''!
changes
	^ self snapshot patchRelativeToBase: package snapshot! !

!MCVersion methodsFor: 'accessing' stamp: ''!
dependencies
	^ dependencies
		ifNil: [#()]! !

!MCVersion methodsFor: 'accessing' stamp: 'cmm 3/3/2011 14:57'!
fileName
	^ (info name, '.', self writerClass extension) asMCVersionName! !

!MCVersion methodsFor: 'actions' stamp: ''!
fileOutOn: t1 
	self writerClass fileOut: self on: t1! !

!MCVersion methodsFor: 'accessing' stamp: ''!
info
	^ info! !

!MCVersion methodsFor: 'initialize-release' stamp: 'cmm 2/25/2011 16:26'!
initializeWithPackage: aPackage info: aVersionInfo snapshot: aSnapshot dependencies: aCollection 
	self
		setPackage: aPackage
		info: aVersionInfo
		snapshot: aSnapshot
		dependencies: aCollection.
	self addToCache! !

!MCVersion methodsFor: 'testing' stamp: ''!
isCacheable
	^ true! !

!MCVersion methodsFor: 'testing' stamp: ''!
isDiffy
	^ false! !

!MCVersion methodsFor: 'actions' stamp: ''!
load
	MCVersionLoader loadVersion: self! !

!MCVersion methodsFor: 'printing' stamp: 'bf 5/11/2012 13:45'!
logLoadingOn: aStream
	aStream
		nextPutAll: '========== ', self info name, ' =========='; cr;
		nextPutAll: self info message asString; cr;
		flush.

	package hasWorkingCopy ifFalse: [^self].

	package workingCopy ancestors do: [:each |
		(self info hasAncestor: each)
			ifTrue: [(self info allAncestorsOnPathTo: each)
				do: [:ver | aStream cr; nextPutAll: '>>> ', ver name, ' <<<'; cr;
							nextPutAll: ver message; cr; flush]]]! !

!MCVersion methodsFor: 'actions' stamp: ''!
merge
	MCVersionMerger mergeVersion: self! !

!MCVersion methodsFor: 'actions' stamp: ''!
open
	(MCVersionInspector new version: self) show! !

!MCVersion methodsFor: 'accessing' stamp: ''!
package
	^ package! !

!MCVersion methodsFor: 'printing' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPut: $(.
	t1 nextPutAll: self info name.
	t1 nextPut: $)! !

!MCVersion methodsFor: 'initialize-release' stamp: ''!
setPackage: t1 info: t2 snapshot: t3 dependencies: t4 
	package := t1.
	info := t2.
	snapshot := t3.
	dependencies := t4! !

!MCVersion methodsFor: 'testing' stamp: 'cmm 8/3/2012 13:34'!
shouldMerge
	"answer true if we have to do a full merge and false if we can simply load instead"
	| pkg wc current |
	(pkg := self package) hasWorkingCopy ifFalse: [^false "no wc -> load"].
	(wc := pkg workingCopy) modified ifTrue: [^true "modified -> merge"].
	wc ancestors isEmpty ifTrue: [^true "no ancestor info -> merge"].
	current := wc ancestors first.
	(self info hasAncestor: current) ifTrue: [^false "direct descendant of wc -> load"].
	"new branch -> merge"
	^true! !

!MCVersion methodsFor: 'accessing' stamp: ''!
snapshot
	^ snapshot! !

!MCVersion methodsFor: 'accessing' stamp: ''!
summary
	^ String
		streamContents: [:t1 | 
			t1 nextPutAll: info summaryHeader.
			(dependencies isNil
					or: [dependencies isEmpty])
				ifFalse: [t1 cr; nextPutAll: 'Dependencies: '.
					dependencies
						do: [:t2 | t1 nextPutAll: t2 versionInfo name]
						separatedBy: [t1 nextPutAll: ', ']].
			t1 cr; cr; nextPutAll: info message]! !

!MCVersion methodsFor: 'enumerating' stamp: ''!
withAllDependenciesDo: t1 
	self
		allDependenciesDo: t1
		ifUnresolved: [:t2 | t2].
	t1 value: self! !

!MCVersion methodsFor: 'enumerating' stamp: ''!
withAllDependenciesDo: t1 ifUnresolved: t2 
	| t3 |
	t3 := Dictionary new.
	self
		allDependenciesNotIn: t3
		do: t1
		ifUnresolved: t2.
	t1 value: self! !

!MCVersion methodsFor: 'accessing' stamp: ''!
workingCopy
	^ package workingCopy! !

!MCVersion methodsFor: 'accessing' stamp: ''!
writerClass
	^ MCMczWriter! !

Object subclass: #MCVersionDependency
	instanceVariableNames: 'package versionInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCVersionDependency class methodsFor: 'as yet unclassified' stamp: ''!
package: t1 info: t2 
	^ self basicNew initializeWithPackage: t1 info: t2! !

!MCVersionDependency methodsFor: 'comparing' stamp: ''!
= t1 
	^ t1 species = self species
		and: [t1 versionInfo = versionInfo
				and: [t1 package = package]]! !

!MCVersionDependency methodsFor: 'comparing' stamp: ''!
hash
	^ versionInfo hash! !

!MCVersionDependency methodsFor: 'initialize-release' stamp: ''!
initializeWithPackage: t1 info: t2 
	package := t1.
	versionInfo := t2! !

!MCVersionDependency methodsFor: 'testing' stamp: ''!
isCurrent
	^ package hasWorkingCopy
		and: [self isFulfilled
				and: [package workingCopy modified not]]! !

!MCVersionDependency methodsFor: 'testing' stamp: ''!
isFulfilled
	^ package hasWorkingCopy
		and: [self isFulfilledBy: package workingCopy ancestry]! !

!MCVersionDependency methodsFor: 'testing' stamp: ''!
isFulfilledBy: t1 
	^ t1 ancestors includes: versionInfo! !

!MCVersionDependency methodsFor: 'testing' stamp: ''!
isFulfilledByAncestors
	^ package hasWorkingCopy
		and: [self isFulfilledByAncestorsOf: package workingCopy ancestry]! !

!MCVersionDependency methodsFor: 'testing' stamp: ''!
isFulfilledByAncestorsOf: t1 
	^ t1 hasAncestor: versionInfo! !

!MCVersionDependency methodsFor: 'testing' stamp: ''!
isOlder
	^ package hasWorkingCopy
		and: [self isFulfilled not
				and: [self isFulfilledByAncestors
						and: [package workingCopy modified not]]]! !

!MCVersionDependency methodsFor: 'accessing' stamp: ''!
package
	^ package! !

!MCVersionDependency methodsFor: 'accessing' stamp: 'bf 2/24/2012 14:40'!
packageAndBranchName
	^self versionInfo packageAndBranchName! !

!MCVersionDependency methodsFor: 'accessing' stamp: ''!
repositoryGroup
	^ self package workingCopy repositoryGroup! !

!MCVersionDependency methodsFor: 'resolving' stamp: ''!
resolve
	^ self repositoryGroup
		versionWithInfo: versionInfo
		ifNone: [MCRepositoryGroup default
				versionWithInfo: versionInfo
				ifNone: []]! !

!MCVersionDependency methodsFor: 'accessing' stamp: ''!
versionInfo
	^ versionInfo! !

Object subclass: #MCVersionLoader
	instanceVariableNames: 'versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Loading'!

!MCVersionLoader class methodsFor: 'as yet unclassified' stamp: ''!
loadVersion: t1 
	self new addVersion: t1;
		 load! !

!MCVersionLoader class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCVersionLoader methodsFor: 'loading' stamp: ''!
addDependency: t1 
	| t2 |
	t1 isCurrent
		ifTrue: [^ self].
	(self depAgeIsOk: t1)
		ifFalse: [^ self].
	t2 := t1 resolve.
	t2
		ifNil: [self confirmMissingDependency: t1]
		ifNotNil: [(versions includes: t2)
				ifFalse: [self addVersion: t2]]! !

!MCVersionLoader methodsFor: 'loading' stamp: ''!
addVersion: t1 
	t1 dependencies
		do: [:t2 | self addDependency: t2].
	versions add: t1! !

!MCVersionLoader methodsFor: 'checking' stamp: ''!
checkForModifications
	| t1 |
	t1 := versions
				select: [:t2 | t2 package workingCopy modified].
	t1 isEmpty
		ifFalse: [self warnAboutLosingChangesTo: t1]! !

!MCVersionLoader methodsFor: 'checking' stamp: ''!
checkIfDepIsOlder: t1 
	^ t1 isOlder not
		or: [self confirm: 'load older dependency ' , t1 versionInfo name , '?']! !

!MCVersionLoader methodsFor: 'checking' stamp: ''!
confirmMissingDependency: t1 
	| t2 |
	t2 := t1 versionInfo name.
	(self confirm: 'Can''t find dependency ' , t2 , '. ignore?')
		ifFalse: [self error: 'Can''t find dependency ' , t2]! !

!MCVersionLoader methodsFor: 'checking' stamp: ''!
depAgeIsOk: t1 
	^ t1 isOlder not
		or: [self confirm: 'load older dependency ' , t1 versionInfo name , '?']! !

!MCVersionLoader methodsFor: 'initialize-release' stamp: ''!
initialize
	versions := OrderedCollection new! !

!MCVersionLoader methodsFor: 'loading' stamp: 'bf 5/11/2012 13:31'!
load
	| loader |
	self checkForModifications.
	loader := MCPackageLoader new.
	versions do: [:ea |
		loader appendToPreamble: (String streamContents: [:s | ea logLoadingOn: s]).
		ea canOptimizeLoading
			ifTrue: [ea patch applyTo: loader]
			ifFalse: [loader updatePackage: ea package withSnapshot: ea snapshot]].
	loader loadWithNameLike: versions first info name.
	versions do: [:ea | ea workingCopy loaded: ea]! !

!MCVersionLoader methodsFor: 'checking' stamp: ''!
warnAboutLosingChangesTo: t1 
	self
		notify: (String
				streamContents: [:t2 | 
					t2 nextPutAll: 'You are about to load new versions of the following packages that have unsaved changes in the image.  If you continue, you will lose these changes.';
						 cr.
					t1
						do: [:t3 | t2 cr; space; space; nextPutAll: t3 package name]])! !

Object subclass: #MCVersionMerger
	instanceVariableNames: 'records merger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCVersionMerger class methodsFor: 'as yet unclassified' stamp: ''!
mergeVersion: t1 
	self new addVersion: t1;
		 mergeWithNameLike: t1 info name! !

!MCVersionMerger class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCVersionMerger methodsFor: 'as yet unclassified' stamp: ''!
addVersion: t1 
	records
		add: (MCMergeRecord version: t1).
	t1 dependencies
		do: [:t2 | 
			| t3 |
			t3 := t2 resolve.
			(records
					anySatisfy: [:t4 | t4 version = t3])
				ifFalse: [self addVersion: t3]]! !

!MCVersionMerger methodsFor: 'as yet unclassified' stamp: ''!
initialize
	records := OrderedCollection new.
	merger := MCThreeWayMerger new! !

!MCVersionMerger methodsFor: 'as yet unclassified' stamp: ''!
merge
	records
		do: [:t1 | merger addBaseSnapshot: t1 packageSnapshot].
	records
		do: [:t1 | merger applyPatch: t1 mergePatch].
	self resolveConflicts
		ifTrue: [merger load.
			records
				do: [:t1 | t1 updateWorkingCopy]]! !

!MCVersionMerger methodsFor: 'as yet unclassified' stamp: ''!
mergeWithNameLike: t1 
	records
		do: [:t2 | merger addBaseSnapshot: t2 packageSnapshot].
	records
		do: [:t2 | merger applyPatch: t2 mergePatch].
	self resolveConflicts
		ifTrue: [merger loadWithNameLike: t1.
			records
				do: [:t2 | t2 updateWorkingCopy]]! !

!MCVersionMerger methodsFor: 'as yet unclassified' stamp: ''!
resolveConflicts
	(records
			allSatisfy: [:t1 | t1 isAncestorMerge])
		ifTrue: [MCNoChangesException signal.
			^ false].
	^ ((MCMergeResolutionRequest new merger: merger)
		signal: 'Merging ' , records first version info name)
		= true! !

Object subclass: #MCVersionNotification
	instanceVariableNames: 'version ancestor repository changes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Repositories'!

!MCVersionNotification class methodsFor: 'as yet unclassified' stamp: ''!
version: t1 repository: t2 
	^ self basicNew initializeWithVersion: t1 repository: t2! !

!MCVersionNotification methodsFor: 'as yet unclassified' stamp: ''!
fromAddress
	^ 'monticello@beta4.com'! !

!MCVersionNotification methodsFor: 'as yet unclassified' stamp: ''!
initializeWithVersion: t1 repository: t2 
	version := t1.
	repository := t2.
	ancestor := repository
				closestAncestorVersionFor: version info
				ifNone: [].
	changes := ancestor
				ifNil: [#()]
				ifNotNil: [(version snapshot patchRelativeToBase: ancestor snapshot) operations asSortedCollection]! !

!MCVersionNotification methodsFor: 'as yet unclassified' stamp: ''!
messageText
	^ String
		streamContents: [:t1 | 
			t1 nextPutAll: 'Committed to repository: ' , repository description;
				 cr;
				 cr.
			t1 nextPutAll: version summary.
			changes isEmpty
				ifFalse: [t1 cr; cr.
					t1 nextPutAll: '-----------------------------------------------------';
						 cr.
					t1 nextPutAll: 'Changes since ' , ancestor info name , ':';
						 cr.
					changes
						do: [:t2 | 
							t1 cr; nextPutAll: t2 summary; cr.
							t1 nextPutAll: t2 sourceString]]]! !

!MCVersionNotification methodsFor: 'as yet unclassified' stamp: ''!
messageTo: t1 
	| t2 |
	t2 := MailMessage empty.
	t2 setField: 'from' toString: self fromAddress.
	t2 setField: 'to' toString: t1.
	t2 setField: 'subject' toString: '[MC] ' , version info name.
	t2
		body: (MIMEDocument contentType: 'text/plain' content: self messageText).
	^ t2! !

!MCVersionNotification methodsFor: 'as yet unclassified' stamp: ''!
notify: t1 
	| t2 |
	t2 := self messageTo: t1.
	SMTPClient
		deliverMailFrom: t2 from
		to: (Array with: t2 to)
		text: t2 text
		usingServer: MailSender smtpServer! !

Object subclass: #MCVersionSorter
	instanceVariableNames: 'layers depthIndex depths stepparents roots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

MCVersionSorter subclass: #MCFilteredVersionSorter
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCFilteredVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
addVersionInfo: t1 
	(t1 hasAncestor: target)
		ifTrue: [super addVersionInfo: t1]! !

!MCFilteredVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
processVersionInfo: t1 
	| t2 |
	t1 = target
		ifTrue: [^ true].
	(t1 hasAncestor: target)
		ifFalse: [^ false].
	self pushLayer.
	t2 := (self knownAncestorsOf: t1)
				anySatisfy: [:t3 | self processVersionInfo: t3].
	self popLayer.
	t2
		ifTrue: [self addToCurrentLayer: t1].
	^ t2! !

!MCFilteredVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
target: t1 
	target := t1! !

!MCVersionSorter class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
addAllAncestorsOf: t1 to: t2 
	(t2 includes: t1)
		ifTrue: [^ self].
	t2 add: t1.
	(self knownAncestorsOf: t1)
		do: [:t3 | self addAllAncestorsOf: t3 to: t2]! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
addAllVersionInfos: t1 
	t1
		do: [:t2 | self addVersionInfo: t2]! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
addToCurrentLayer: t1 
	| t2 |
	t2 := layers at: depthIndex.
	(t2 includes: t1)
		ifFalse: [depths
				at: t1
				ifPresent: [:t3 | t3 < depthIndex
						ifTrue: [(layers at: t3)
								remove: t1]
						ifFalse: [^ false]].
			t2 add: t1.
			depths at: t1 put: depthIndex.
			^ true].
	^ false! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
addVersionInfo: t1 
	roots add: t1.
	self registerStepChildrenOf: t1 seen: Set new! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
allAncestorsOf: t1 
	| t2 |
	t2 := Set new.
	self addAllAncestorsOf: t1 to: t2.
	^ t2! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
initialize
	stepparents := Dictionary new.
	roots := OrderedCollection new! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
knownAncestorsOf: t1 
	^ t1 ancestors , (self stepParentsOf: t1) asArray! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
layers
	^ layers! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
popLayer
	depthIndex := depthIndex - 1! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
processVersionInfo: t1 
	(self addToCurrentLayer: t1)
		ifTrue: [self pushLayer.
			(self knownAncestorsOf: t1)
				do: [:t2 | self processVersionInfo: t2].
			self popLayer]! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
pushLayer
	depthIndex := depthIndex + 1.
	depthIndex > layers size
		ifTrue: [layers add: OrderedCollection new]! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
registerStepChildrenOf: t1 seen: t2 
	(t2 includes: t1)
		ifTrue: [^ self].
	t2 add: t1.
	t1 stepChildren
		do: [:t3 | (self stepParentsOf: t3)
				add: t1].
	t1 ancestors
		do: [:t3 | self registerStepChildrenOf: t3 seen: t2]! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
sortedVersionInfos
	layers := OrderedCollection with: OrderedCollection new.
	depthIndex := 1.
	depths := Dictionary new.
	roots
		do: [:t1 | self processVersionInfo: t1].
	^ layers
		gather: [:t1 | t1]! !

!MCVersionSorter methodsFor: 'as yet unclassified' stamp: ''!
stepParentsOf: t1 
	^ stepparents
		at: t1
		ifAbsentPut: [Set new]! !

Object subclass: #MCWriter
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

MCWriter subclass: #MCMczWriter
	instanceVariableNames: 'zip infoWriter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

MCMczWriter subclass: #MCMcdWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCMcdWriter class methodsFor: 'as yet unclassified' stamp: ''!
readerClass
	^ MCMcdReader! !

!MCMcdWriter methodsFor: 'as yet unclassified' stamp: ''!
writeBaseInfo: t1 
	| t2 |
	t2 := self serializeVersionInfo: t1.
	self addString: t2 at: 'base'! !

!MCMcdWriter methodsFor: 'as yet unclassified' stamp: ''!
writeDefinitions: t1 
	self writeBaseInfo: t1 baseInfo.
	self writePatch: t1 patch! !

!MCMcdWriter methodsFor: 'as yet unclassified' stamp: ''!
writeNewDefinitions: t1 
	self
		addString: (self serializeDefinitions: t1)
		at: 'new/source.' , self snapshotWriterClass extension! !

!MCMcdWriter methodsFor: 'as yet unclassified' stamp: ''!
writeOldDefinitions: t1 
	self
		addString: (self serializeDefinitions: t1)
		at: 'old/source.' , self snapshotWriterClass extension! !

!MCMcdWriter methodsFor: 'as yet unclassified' stamp: ''!
writePatch: t1 
	| t2 t3 |
	t2 := OrderedCollection new.
	t3 := OrderedCollection new.
	t1 operations
		do: [:t4 | 
			t4 isRemoval
				ifTrue: [t2 add: t4 definition].
			t4 isAddition
				ifTrue: [t3 add: t4 definition].
			t4 isModification
				ifTrue: [t2 add: t4 baseDefinition.
					t3 add: t4 definition]].
	self writeOldDefinitions: t2.
	self writeNewDefinitions: t3.
	self
		addString: (self serializeInBinary: t1)
		at: 'patch.bin'! !

!MCMczWriter class methodsFor: 'as yet unclassified' stamp: ''!
fileOut: t1 on: t2 
	| t3 |
	t3 := self on: t2.
	t3 writeVersion: t1.
	t3 flush! !

!MCMczWriter class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!MCMczWriter class methodsFor: 'as yet unclassified' stamp: ''!
readerClass
	^ MCMczReader! !

!MCMczWriter methodsFor: 'writing' stamp: ''!
addString: t1 at: t2 
	| t3 |
	t3 := zip addString: t1 as: t2.
	t3 desiredCompressionMethod: ZipArchive compressionDeflated! !

!MCMczWriter methodsFor: 'writing' stamp: ''!
flush
	zip writeTo: stream.
	stream close! !

!MCMczWriter methodsFor: 'accessing' stamp: ''!
format
	^ '1'! !

!MCMczWriter methodsFor: 'initializing' stamp: ''!
initialize
	zip := ZipArchive new! !

!MCMczWriter methodsFor: 'serializing' stamp: ''!
serializeDefinitions: t1 
	| t2 t3 |
	t3 := RWBinaryOrTextStream on: String new.
	t2 := self snapshotWriterClass on: t3.
	t2 writeDefinitions: t1.
	^ t3 contents! !

!MCMczWriter methodsFor: 'serializing' stamp: ''!
serializeInBinary: t1 
	| t2 t3 |
	t3 := RWBinaryOrTextStream on: String new.
	t2 := DataStream on: t3.
	t2 nextPut: t1.
	^ t3 contents! !

!MCMczWriter methodsFor: 'serializing' stamp: ''!
serializePackage: t1 
	^ '(name ''' , t1 name , ''')'! !

!MCMczWriter methodsFor: 'serializing' stamp: ''!
serializeVersionInfo: t1 
	infoWriter
		ifNil: [infoWriter := MCVersionInfoWriter new].
	^ String
		streamContents: [:t2 | 
			infoWriter stream: t2.
			infoWriter writeVersionInfo: t1]! !

!MCMczWriter methodsFor: 'accessing' stamp: ''!
snapshotWriterClass
	^ MCStWriter! !

!MCMczWriter methodsFor: 'visiting' stamp: ''!
writeDefinitions: t1 
	self writeSnapshot: t1 snapshot! !

!MCMczWriter methodsFor: 'visiting' stamp: ''!
writeFormat
	^ self! !

!MCMczWriter methodsFor: 'visiting' stamp: ''!
writePackage: t1 
	self
		addString: (self serializePackage: t1)
		at: 'package'! !

!MCMczWriter methodsFor: 'visiting' stamp: ''!
writeSnapshot: t1 
	self
		addString: (self serializeDefinitions: t1 definitions)
		at: 'snapshot/source.' , self snapshotWriterClass extension.
	self
		addString: (self serializeInBinary: t1)
		at: 'snapshot.bin'! !

!MCMczWriter methodsFor: 'visiting' stamp: ''!
writeVersion: t1 
	self writeFormat.
	self writePackage: t1 package.
	self writeVersionInfo: t1 info.
	self writeDefinitions: t1.
	t1 dependencies
		do: [:t2 | self writeVersionDependency: t2]! !

!MCMczWriter methodsFor: 'visiting' stamp: ''!
writeVersionDependency: t1 
	| t2 |
	t2 := self serializeVersionInfo: t1 versionInfo.
	self addString: t2 at: 'dependencies/' , t1 package name! !

!MCMczWriter methodsFor: 'visiting' stamp: ''!
writeVersionInfo: t1 
	| t2 |
	t2 := self serializeVersionInfo: t1.
	self addString: t2 at: 'version'! !

!MCMczWriter methodsFor: 'accessing' stamp: ''!
zip
	^ zip! !

MCWriter subclass: #MCStWriter
	instanceVariableNames: 'initStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Chunk Format'!

!MCStWriter class methodsFor: 'as yet unclassified' stamp: ''!
readerClass
	^ MCStReader! !

!MCStWriter methodsFor: 'writing' stamp: ''!
chunkContents: t1 
	stream cr;
		nextChunkPut: (String streamContents: t1); cr! !

!MCStWriter methodsFor: 'visiting' stamp: ''!
visitClassDefinition: t1 
	self writeClassDefinition: t1.
	t1 hasClassInstanceVariables
		ifTrue: [self writeMetaclassDefinition: t1].
	t1 hasComment
		ifTrue: [self writeClassComment: t1]! !

!MCStWriter methodsFor: 'visiting' stamp: ''!
visitClassTraitDefinition: t1 
	self
		chunkContents: [:t2 | t2 nextPutAll: t1 baseTrait;
				 nextPutAll: ' classTrait';
				 cr;
				 tab;
				 nextPutAll: 'uses: ';
				
				nextPutAll: (t1 classTraitComposition
						ifNil: ['{}'])]! !

!MCStWriter methodsFor: 'visiting' stamp: ''!
visitMetaclassDefinition: t1 
	self writeMetaclassDefinition: t1! !

!MCStWriter methodsFor: 'visiting' stamp: ''!
visitMethodDefinition: t1 
	self writeMethodPreamble: t1.
	self writeMethodSource: t1.
	self writeMethodPostscript.
	self writeMethodInitializer: t1! !

!MCStWriter methodsFor: 'visiting' stamp: ''!
visitOrganizationDefinition: t1 
	t1 categories
		do: [:t2 | self writeCategory: t2]! !

!MCStWriter methodsFor: 'visiting' stamp: ''!
visitScriptDefinition: t1 
	self writeScriptDefinition: t1! !

!MCStWriter methodsFor: 'visiting' stamp: ''!
visitTraitDefinition: t1 
	self writeClassDefinition: t1.
	t1 hasComment
		ifTrue: [self writeClassComment: t1]! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeCategory: t1 
	stream nextChunkPut: 'SystemOrganization addCategory: ' , t1 printString;
		 cr! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeClassComment: t1 
	stream cr; nextPut: $!!; nextPutAll: t1 className; nextPutAll: ' commentStamp: '; store: t1 commentStamp; nextPutAll: ' prior: 0!!'; cr; nextChunkPut: t1 comment; cr! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeClassDefinition: t1 
	self
		chunkContents: [:t2 | t1 printDefinitionOn: stream]! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeDefinitions: t1 
	initStream := String new writeStream.
	(MCDependencySorter sortItems: t1)
		do: [:t2 | t2 accept: self]
		displayingProgress: 'Writing definitions...'.
	stream nextPutAll: initStream contents! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeMetaclassDefinition: t1 
	self
		chunkContents: [:t2 | 
			t2 nextPutAll: t1 className;
				 nextPutAll: ' class';
				 cr;
				 tab.
			t1 hasClassTraitComposition
				ifTrue: [t2 nextPutAll: 'uses: ';
						 nextPutAll: t1 classTraitCompositionString;
						 cr;
						 tab].
			t2 nextPutAll: 'instanceVariableNames: ''';
				 nextPutAll: t1 classInstanceVariablesString;
				 nextPut: $']! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeMethodInitializer: t1 
	t1 isInitializer
		ifTrue: [initStream nextChunkPut: t1 className , ' initialize';
				 cr]! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeMethodPostscript
	stream space; nextPut: $!!; cr! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeMethodPreamble: t1 
	stream cr; nextPut: $!!; nextPutAll: t1 fullClassName; nextPutAll: ' methodsFor: '; nextPutAll: t1 category asString printString; nextPutAll: ' stamp: '; nextPutAll: t1 timeStamp asString printString; nextPutAll: '!!'; cr! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeMethodSource: t1 
	stream nextChunkPut: t1 source! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeScriptDefinition: t1 
	stream
		nextChunkPut: ('(PackageInfo named: {1}) {2}: {3}' format: {t1 packageName printString. t1 scriptSelector. t1 script printString});
		 cr! !

!MCStWriter methodsFor: 'writing' stamp: ''!
writeSnapshot: t1 
	self writeDefinitions: t1 definitions! !

MCWriter subclass: #MCVersionInfoWriter
	instanceVariableNames: 'written'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Storing'!

!MCVersionInfoWriter methodsFor: 'as yet unclassified' stamp: ''!
isWritten: t1 
	^ self written includes: t1! !

!MCVersionInfoWriter methodsFor: 'as yet unclassified' stamp: ''!
writeVersionInfo: t1 
	(self isWritten: t1)
		ifTrue: [^ stream nextPutAll: '(id ' , t1 id asString printString , ')'].
	stream nextPut: $(.
	#(#name #message #id #date #time #author )
		do: [:t2 | 
			stream nextPutAll: t2.
			stream nextPut: Character space.
			((t1 perform: t2)
				ifNil: ['']) asString printOn: stream.
			stream nextPut: Character space].
	stream nextPutAll: 'ancestors ('.
	t1 ancestors
		do: [:t2 | self writeVersionInfo: t2].
	stream nextPutAll: ') stepChildren ('.
	t1 stepChildren
		do: [:t2 | self writeVersionInfo: t2].
	stream nextPutAll: '))'.
	self wrote: t1! !

!MCVersionInfoWriter methodsFor: 'as yet unclassified' stamp: ''!
written
	^ written
		ifNil: [written := Set new]! !

!MCVersionInfoWriter methodsFor: 'as yet unclassified' stamp: ''!
wrote: t1 
	self written add: t1! !

!MCWriter class methodsFor: 'accessing' stamp: ''!
extension
	^ self readerClass extension! !

!MCWriter class methodsFor: 'writing' stamp: ''!
on: t1 
	^ self new stream: t1! !

!MCWriter class methodsFor: 'accessing' stamp: ''!
readerClass
	^ self subclassResponsibility! !

!MCWriter methodsFor: 'as yet unclassified' stamp: ''!
stream
	^ stream! !

!MCWriter methodsFor: 'as yet unclassified' stamp: ''!
stream: t1 
	stream := t1! !

Object subclass: #MethodAddition
	instanceVariableNames: 'text category changeStamp requestor logSource myClass methodAndNode selector compiledMethod priorMethodOrNil'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Loading'!

!MethodAddition methodsFor: 'as yet unclassified' stamp: ''!
compile
	self createCompiledMethod.
	self installMethod.
	self notifyObservers.
	^ selector! !

!MethodAddition methodsFor: 'as yet unclassified' stamp: ''!
compile: t1 classified: t2 withStamp: t3 notifying: t4 logSource: t5 inClass: t6 
	text := t1.
	category := t2.
	changeStamp := t3.
	requestor := t4.
	logSource := t5.
	myClass := t6! !

!MethodAddition methodsFor: 'as yet unclassified' stamp: ''!
createCompiledMethod
	methodAndNode := myClass
				compile: text asString
				classified: category
				notifying: requestor
				trailer: myClass defaultMethodTrailer
				ifFail: [^ nil].
	selector := methodAndNode selector.
	compiledMethod := methodAndNode method.
	self writeSourceToLog.
	priorMethodOrNil := myClass
				compiledMethodAt: selector
				ifAbsent: []! !

!MethodAddition methodsFor: 'as yet unclassified' stamp: ''!
installMethod
	myClass addSelectorSilently: selector withMethod: compiledMethod! !

!MethodAddition methodsFor: 'as yet unclassified' stamp: ''!
notifyObservers
	SystemChangeNotifier uniqueInstance
		doSilently: [myClass organization classify: selector under: category].
	priorMethodOrNil isNil
		ifTrue: [SystemChangeNotifier uniqueInstance
				methodAdded: compiledMethod
				selector: selector
				inProtocol: category
				class: myClass
				requestor: requestor]
		ifFalse: [SystemChangeNotifier uniqueInstance
				methodChangedFrom: priorMethodOrNil
				to: compiledMethod
				selector: selector
				inClass: myClass
				requestor: requestor].
	myClass instanceSide noteCompilationOf: selector meta: myClass isClassSide! !

!MethodAddition methodsFor: 'as yet unclassified' stamp: ''!
writeSourceToLog
	logSource
		ifTrue: [myClass
				logMethodSource: text
				forMethodWithNode: methodAndNode
				inCategory: category
				withStamp: changeStamp
				notifying: requestor]! !

!Object methodsFor: '*monticello' stamp: ''!
isConflict
	^ false! !

!String methodsFor: '*monticello' stamp: 'cmm 8/14/2011 14:04'!
withLoadedPackageVersions
	"Everywhere the receiver contains a package version in the format:  PackageName-author.123 for which a version of that package is loaded in the image, answer a new String with each of those package versions changed to reflect the currently loaded version."
	| string |
	string := self.
	MCWorkingCopy allManagers do:
		[ : eachWorkingCopy | | start packageName |
		start := 1.
		packageName := eachWorkingCopy packageName.
		[ start := string
			findString: packageName
			startingAt: start.
		start > 0 and: [ string size > (start + packageName size + 4) ] ] whileTrue:
			[ | dot end versionName |
			dot := string
				indexOf: $.
				startingAt: (end := start + packageName size)
				ifAbsent: [ 0 ].
			dot > 0 ifTrue:
				[ end := (dot + 1 to: string size)
					detect: [ : n | (string at: n) isDigit not ]
					ifNone: [ 0 ].
				(end > (dot + 1) and:
					[ (dot + 1 to: end - 1) allSatisfy:
						[ : n | (string at: n) isDigit ] ])
					ifTrue:
						[ versionName := string
							copyFrom: start
							to: end - 1.
						versionName asMCVersionName packageName = packageName ifTrue:
							[ string := string
								copyReplaceTokens: versionName
								with: eachWorkingCopy ancestors first name ] ]
					ifFalse: [ end := start + packageName size ] ].
			start := end ] ].
	^ string! !

!FilePackage methodsFor: '*monticello' stamp: ''!
classDefinition: t1 with: t2 
	| t3 t4 |
	self flag: #traits.
	t3 := Scanner new scanTokens: t1.
	t4 := self
				getClass: (t3 at: 3).
	t4 definition: t1.
	classOrder add: t4! !

!FilePackage methodsFor: '*monticello' stamp: ''!
doIts
	^ doIts! !

!ByteString methodsFor: '*monticello' stamp: 'cmm 3/3/2011 14:35'!
asMCVersionName 
	^ MCVersionName on: self! !

ByteString variableByteSubclass: #MCVersionName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Modeling'!

!MCVersionName commentStamp: 'cmm 3/4/2011 13:32' prior: 0!
A MCVersionName models the Monticello file / version name, in the format [Package]-[Author].[version-number]([ancestorAuthor.ancestorVersionNumber]).[mc?].

Any file-extension, if present, is ignored.!

!MCVersionName class methodsFor: 'instance creation' stamp: 'cmm 3/3/2011 14:19'!
on: aString 
	"aString may be with or without a mc? extension."
	^ (self new: aString size)
		replaceFrom: 1
			to: aString size
			with: aString
			startingAt: 1 ;
		yourself! !

!MCVersionName methodsFor: 'comparing' stamp: 'cmm 3/12/2011 11:48'!
= aByteString 
	"Ignore any file-extension for comparison of MCVersionNames."
	| myVersionName |
	aByteString isString ifFalse: [ ^ false ].
	myVersionName := self versionName.
	^ (myVersionName
		compare: myVersionName
		with: aByteString asMCVersionName versionName
		collated: AsciiOrder) = 2! !

!MCVersionName methodsFor: 'converting' stamp: 'cmm 3/3/2011 14:33'!
asMCVersionName
	^ self! !

!MCVersionName methodsFor: 'accessing' stamp: 'ul 3/23/2011 04:55'!
author
	"The author initials embedded in the filename."
	
	^(self versionName copyAfterLast: $-) copyUpTo: $.! !

!MCVersionName methodsFor: 'accessing' stamp: 'bf 2/24/2012 15:58'!
baseVersionName
	"The version name of our ancestor, if this is a Diffy filename."

	^(MCDiffyVersion baseNameFrom: (self copyUpThrough: $))) asMCVersionName! !

!MCVersionName methodsFor: 'comparing' stamp: 'cmm 3/4/2011 10:36'!
hash
	^ self versionName hash! !

!MCVersionName methodsFor: 'testing' stamp: 'cmm 4/24/2011 20:04'!
isValid
	^ [ (self endsWith: '.mcm') or:
		[ self packageName notEmpty and:
			[ self author notEmpty and: [ self versionNumber > 0 ] ] ] ]
		on: Error
		do:
			[ : err | false ]! !

!MCVersionName methodsFor: 'accessing' stamp: 'bf 2/24/2012 13:20'!
packageAndBranchName
	"The MC package name, possibly with branch name, embedded into this filename."
	
	^self versionName copyUpToLast: $-! !

!MCVersionName methodsFor: 'accessing' stamp: 'bf 2/24/2012 13:22'!
packageName
	"The MC Package name embedded into this filename."
	
	^self packageAndBranchName copyUpTo: $.! !

!MCVersionName methodsFor: 'private' stamp: 'cmm 3/4/2011 10:12'!
species
	^ ByteString! !

!MCVersionName methodsFor: 'accessing' stamp: 'bf 7/5/2012 16:56'!
versionName
	"Answer my version name as a ByteString, without the file suffix or any ancestor-attributes."
	| end |
	self isEmpty ifTrue: [^ String empty]. 
	end := self indexOf: $( ifAbsent: [
		(self size > 4 and: [(self copyFrom: self size - 3 to: self size - 1) = '.mc'])
			ifTrue: [self size - 3]
			ifFalse: [self size + 1]].
	^self first: end - 1! !

!MCVersionName methodsFor: 'accessing' stamp: 'bf 7/4/2012 14:55'!
versionNumber
	"The Integer version number identified by this filename."
	| v |
	v := (self versionName copyAfterLast: $-) copyAfter: $..
	^(v notEmpty and: [v first isDigit])
		ifTrue: [ v asInteger ]
	 	ifFalse: [ 0 ]! !

!Time class methodsFor: '*monticello' stamp: ''!
fromString: t1 
	^ self
		readFrom: (ReadStream on: t1)! !

!PackageInfo methodsFor: '*monticello' stamp: 'cmm 3/21/2009 14:08'!
mcPackage
	^ MCPackage named: self packageName! !

!PackageInfo methodsFor: '*monticello' stamp: 'cmm 3/18/2009 20:42'!
workingCopy
	^ self mcPackage workingCopy! !

Notification subclass: #MCChangeSelectionRequest
	instanceVariableNames: 'patch label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCChangeSelectionRequest methodsFor: 'as yet unclassified' stamp: ''!
defaultAction
	^ (MCChangeSelector new patch: patch;
		 label: label) showModally! !

!MCChangeSelectionRequest methodsFor: 'as yet unclassified' stamp: ''!
label
	^ label! !

!MCChangeSelectionRequest methodsFor: 'as yet unclassified' stamp: ''!
label: t1 
	label := t1! !

!MCChangeSelectionRequest methodsFor: 'as yet unclassified' stamp: ''!
patch
	^ patch! !

!MCChangeSelectionRequest methodsFor: 'as yet unclassified' stamp: ''!
patch: t1 
	patch := t1! !

Notification subclass: #MCMergeResolutionRequest
	instanceVariableNames: 'merger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCMergeResolutionRequest methodsFor: 'as yet unclassified' stamp: ''!
defaultAction
	^ (MCMergeBrowser new merger: merger;
		 label: messageText) showModally! !

!MCMergeResolutionRequest methodsFor: 'as yet unclassified' stamp: ''!
merger
	^ merger! !

!MCMergeResolutionRequest methodsFor: 'as yet unclassified' stamp: ''!
merger: t1 
	merger := t1! !

Notification subclass: #MCVersionNameAndMessageRequest
	instanceVariableNames: 'suggestion initialMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCVersionNameAndMessageRequest methodsFor: 'as yet unclassified' stamp: 'bf 9/4/2010 15:38'!
defaultAction
	^ MCSaveVersionDialog new
		versionName: suggestion;
		logMessage: initialMessage;
		showModally! !

!MCVersionNameAndMessageRequest methodsFor: 'as yet unclassified' stamp: 'bf 9/4/2010 15:28'!
initialMessage
	^ initialMessage! !

!MCVersionNameAndMessageRequest methodsFor: 'as yet unclassified' stamp: 'bf 9/4/2010 15:28'!
initialMessage: aString
	initialMessage := aString! !

!MCVersionNameAndMessageRequest methodsFor: 'as yet unclassified' stamp: ''!
suggestedName
	^ suggestion! !

!MCVersionNameAndMessageRequest methodsFor: 'as yet unclassified' stamp: ''!
suggestedName: t1 
	suggestion := t1! !

!ChangeRecord methodsFor: '*monticello' stamp: ''!
asMethodDefinition
	^ MCMethodDefinition
		className: class
		classIsMeta: meta
		selector: self methodSelector
		category: category
		timeStamp: stamp
		source: self string! !

!ByteSymbol methodsFor: '*monticello' stamp: 'cmm 3/7/2011 14:23'!
asMCVersionName
	^ self asString asMCVersionName! !

!PseudoMetaclass methodsFor: '*monticello-override' stamp: ''!
isMeta
	^ true! !

!MethodReference methodsFor: '*monticello' stamp: ''!
asMethodDefinition
	^ MCMethodDefinition forMethodReference: self! !

!MethodReference methodsFor: '*monticello' stamp: ''!
isLocalSelector
	^ self actualClass includesLocalSelector: self methodSymbol! !

!MethodReference methodsFor: '*monticello' stamp: 'cmm 3/8/2011 20:16'!
workingCopy
	"Answer the MCWorkingCopy in which I am defined."
	^ self packageInfo workingCopy! !

!PseudoClass methodsFor: '*monticello' stamp: ''!
asClassDefinition
	^ MCClassDefinition
		name: self name
		superclassName: self superclass name
		category: self category
		instVarNames: self instVarNames
		classVarNames: self classVarNames asSortedCollection
		poolDictionaryNames: self poolDictionaryNames
		classInstVarNames: self class instVarNames
		type: self typeOfClass
		comment: self organization classComment asString
		commentStamp: self organization commentStamp! !

!PseudoClass methodsFor: '*monticello-override' stamp: ''!
isMeta
	^ false! !

Exception subclass: #MCNoChangesException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-Versioning'!

!MCNoChangesException methodsFor: 'as yet unclassified' stamp: ''!
defaultAction
	self inform: 'No changes'! !

!Class methodsFor: '*monticello' stamp: ''!
asClassDefinition
	^ MCClassDefinition
		name: self name
		superclassName: self superclass name
		traitComposition: self traitCompositionString
		classTraitComposition: self class traitCompositionString
		category: self category
		instVarNames: self instVarNames
		classVarNames: self classVarNames
		poolDictionaryNames: self poolDictionaryNames
		classInstVarNames: self class instVarNames
		type: self typeOfClass
		comment: self organization classComment asString
		commentStamp: self organization commentStamp! !

!Class methodsFor: '*monticello' stamp: ''!
classDefinitions
	^ Array with: self asClassDefinition! !

!Class methodsFor: '*monticello' stamp: 'rms 1/11/2013 22:35'!
innerBindingOf: aSymbol
	"Answer the binding of some variable resolved in the scope of the receiver, or one of its superclass
	but do not look up binding in receiver's environment.
	Use #bindingOf: for looking up the variable binding in a full scope, including receiver's environment"
	
	| binding |

	"First look in classVar dictionary."
	binding := self classPool bindingOf: aSymbol.
	binding ifNotNil: [^binding].

	"Next look in shared pools."
	self sharedPools do: [:pool | 
		| aBinding |
		aBinding := pool bindingOf: aSymbol.
		aBinding ifNotNil: [^aBinding ].
	].

	superclass ifNotNil: [
		^ superclass innerBindingOf: aSymbol.
	].	
	^ nil! !

!Class methodsFor: '*monticello' stamp: 'bf 7/4/2012 15:12'!
poolDictionaryNames
	^ self sharedPools collect: [:ea | self environment keyAtIdentityValue: ea ifAbsent: [ea name]]! !

!Class methodsFor: '*monticello' stamp: 'cmm 3/8/2011 20:55'!
workingCopy
	^ self packageInfo workingCopy! !

!ChangeList class methodsFor: '*monticello' stamp: ''!
recent: t1 on: t2 
	| t3 t4 t5 |
	t5 := t2 readOnlyCopy.
	t4 := t5 size.
	t3 := Cursor read
				showWhile: [self new
						scanFile: t5
						from: (0 max: t4 - t1)
						to: t4].
	t5 close.
	^ t3! !

!ChangeList class methodsFor: '*monticello' stamp: 'ul 11/15/2010 11:34'!
recentLogOn: origChangesFile startingFrom: initialPos 
	"Prompt with a menu of how far back to go when browsing a changes file."

	| end banners positions pos chunk i changesFile |
	changesFile := origChangesFile readOnlyCopy.
	banners := OrderedCollection new.
	positions := OrderedCollection new.
	end := changesFile size.
	pos := initialPos.
	[pos = 0
		or: [banners size > 20]]
		whileFalse: [changesFile position: pos.
			chunk := changesFile nextChunk.
			i := chunk indexOfSubCollection: 'priorSource: ' startingAt: 1.
			i > 0
				ifTrue: [positions addLast: pos.
					banners
						addLast: (chunk copyFrom: 5 to: i - 2).
					pos := Number
								readFrom: (chunk copyFrom: i + 13 to: chunk size)]
				ifFalse: [pos := 0]].
	changesFile close.
	banners size = 0 ifTrue: [^self recent: end on: origChangesFile].

	pos := UIManager default chooseFrom: banners values: positions
				title: 'Browse as far back as...'.
	pos == nil
		ifTrue: [^ self].
	^self recent: end - pos on: origChangesFile! !

!ChangeList methodsFor: '*monticello' stamp: ''!
changeTo: t1 
	| t2 t3 |
	t3 := OrderedCollection new.
	t2 := OrderedCollection new.
	1
		to: changeList size
		do: [:t4 | (t1
					includes: (changeList at: t4))
				ifTrue: [t3
						add: (changeList at: t4).
					t2
						add: (list at: t4)]].
	t3 size < changeList size
		ifTrue: [changeList := t3.
			list := t2.
			listIndex := 0.
			listSelections := Array new: list size withAll: false].
	self changed: #list! !

!TimeStamp class methodsFor: '*monticello-instance creation' stamp: ''!
fromMethodTimeStamp: t1 
	| t2 |
	t2 := ReadStream on: t1.
	t2 skipSeparators.
	t2 skipTo: Character space.
	^ self readFrom: t2! !

!TimeStamp class methodsFor: '*monticello-instance creation' stamp: ''!
fromString: t1 
	^ self
		readFrom: (ReadStream on: t1)! !

!TimeStamp class methodsFor: '*monticello-instance creation' stamp: ''!
readFrom: t1 
	| t2 t3 |
	t1 skipSeparators.
	t2 := Date readFrom: t1.
	t1 skipSeparators.
	t3 := Time readFrom: t1.
	^ self date: t2 time: t3! !

ListItemWrapper subclass: #MCDependentsWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello-UI'!

!MCDependentsWrapper methodsFor: 'as yet unclassified' stamp: ''!
asString
	^ item description! !

!MCDependentsWrapper methodsFor: 'as yet unclassified' stamp: ''!
contents
	| t1 t2 |
	t2 := model unsortedWorkingCopies.
	t1 := item requiredPackages
				collect: [:t3 | t2
						detect: [:t4 | t4 package = t3]
						ifNone: []]
				thenSelect: [:t3 | t3 notNil].
	^ t1
		collect: [:t3 | self class with: t3 model: model]! !

!MCDependentsWrapper methodsFor: 'as yet unclassified' stamp: ''!
hasContents
	^ item requiredPackages isEmpty not! !

!MCDependentsWrapper methodsFor: 'as yet unclassified' stamp: ''!
item
	^ item! !
MCMethodDefinition initialize!
MCPackageManager initialize!
MCWorkingCopy initialize!
MCVersionReader initialize!
MCCacheRepository initialize!
MCRepository initialize!
MCRepositoryInspector initialize!
MCWorkingCopyBrowser initialize!
